#ifndef __bool_ext_def__
#define __bool_ext_def__

//-------------------------------------------
//-------------------------------------------
//- environment-define 
//-------------------------------------------

#pragma warning(disable:4001)	/* "//"  warning   . */
#pragma warning(disable:4100)	/*  ʴ Ű  warning   . */
#pragma warning(disable:4201)	/* nonstandard extension used : nameless struct/union */
#pragma warning(disable:4214)	/* nonstandard extension used : bit field types other than int */
#pragma warning(disable:4115)	/* 'IRpcStubBuffer' : named type definition in parentheses */
#pragma warning(disable:4514)	/* 'Int64ShllMod32' : unreferenced inline function has been removed */
#pragma warning(disable:4127)	/* conditional expression is constant */
#pragma warning(disable:4206)	/* nonstandard extension used : translation unit is empty */
#pragma warning(disable:4121)	/* alignment of a member was sensitive to packing */
#pragma warning(disable:4218)	/* nonstandard extension used : must specify at least a storage class or a type */

#ifndef _HGWINVER_
#if defined(_INC_WINDOWS) || defined(_WINDOWS_) || defined(_WINDOWS) || defined(WINVER) || defined(WIN32) || defined(_WIN32)
#define _HGWINVER_

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>

#include <direct.h>
#include <stdio.h>  //  .  ʿϴ.
#include <stdarg.h>  //  .  ʿϴ.
#include <fcntl.h>  //  .  ʿϴ.
#include <io.h>

#if defined(_CONSOLE) || defined(CONSOLE)
#define _HGWINCON_

#include <sys\\types.h>
#include <sys\\stat.h>
#else	// (_CONSOLE) || (CONSOLE)
#endif	// (_CONSOLE) || (CONSOLE)

#ifdef _AFXDLL
#define _HGMFCVER_
#endif  // _AFXDLL
#else	// _INC_WINDOWS || _WINDOWS_ || _WINDOWS || WINVER || WIN32 || _WIN32  
#define _HGCONVER_

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>

#include "hgk_wex.h"    // win_extern_simulator
#endif	// _INC_WINDOWS || _WINDOWS_ || _WINDOWS || WINVER || WIN32 || _WIN32 
#endif	// _HGWINVER_

#if defined(DEBUG) || defined(_DEBUG) || defined(_DEBUG_) || defined(DEBUG_)
#define _HGDEBUG_
#define _hgdebug_
#endif // defined(DEBUG) || defined(_DEBUG) || defined(_DEBUG_) || defined(DEBUG_)

#if defined(HGTEST) || defined(_HGTEST) || defined(_HGTEST_) || defined(HGTEST_)
#define _HGTEST_
#define _hgtest_
#endif // defined(HGTEST) || defined(_HGTEST) || defined(_HGTEST_) || defined(HGTEST_)

// ׹  
#include <time.h>	

// system include
#include "stdio.h"
#include "stdlib.h"
#include "malloc.h"
#include "memory.h"
#include "string.h"

//-------------------------------------------
//-------------------------------------------
//-------------------------------------------

//---------------------
// ҹڷ Ÿ 
//---------------------
typedef char            schar;
typedef unsigned char   uchar;
typedef short           ssint;
typedef unsigned short  usint;
typedef int             sint;
typedef int             *p_int;
typedef sint            *p_sint;
typedef int             siint;  // 5ڷ ߱ ؼ  
typedef unsigned int    uint;
typedef uint            *p_uint;
typedef unsigned int    uiint;  // 5ڷ ߱ ؼ  
typedef long            slong;
typedef unsigned long   ulong;
typedef char            *pstr;
typedef char            *p_str;
typedef char            **ppstr;
typedef char            **pp_str;
typedef void            *pvoid;
typedef void            *p_void;
typedef const char      *p_cstr;
typedef long            *p_long;
typedef long            **pp_long;
typedef unsigned long   *p_ulong;
typedef unsigned long   *pp_ulong;
typedef float           *p_float;

typedef slong           hgpos, *p_hgpos;
typedef slong           hgnum, *p_hgnum;
typedef slong           hglen, *p_hglen;
typedef slong           hginx, *p_hginx;
typedef slong           hgloc, *p_hgloc;
//---------------------
//---------------------
//---------------------


//------------------------------
//------------ debug ---------
//------------------------------
typedef long HGDEBUG_ID, FAR *LPHGDEBUG_ID;

#define HGDBID_ENDMARK				((HGDEBUG_ID)0xffff0000)
#define HGDBID_NON					((HGDEBUG_ID)0x00000000)
#define HGDBID_BFSIZEISZERO			((HGDEBUG_ID)0x00000001)
#define HGDBID_BFSIZEOVERFLOW		((HGDEBUG_ID)0x00000002)
#define HGDBID_FAILEDMEM			((HGDEBUG_ID)0x00000003)
#define HGDBID_FATAL_MEMERR			((HGDEBUG_ID)0x00000004)
#define HGDBID_INVALID_CHAR			((HGDEBUG_ID)0x00000005)
#define HGDBID_DEFAULT				HGDBID_NON

#ifdef _HGDEBUG_

// function
void  HGALERT(p_str FILE_name, UINT LINE_num, BOOL Flag);
void  HGDEBUGALERT(p_str FILE_name, UINT LINE_num, HGDEBUG_ID hgDbgID, p_str hgDbgStr);
p_str HGGetDbgMsgString(HGDEBUG_ID hgDbgID);

#define CHECK_BF_OVERFLOW(lpEnd, lpStart, BfLen)	if((long)(lpEnd - lpStart) >= (long)BfLen) {		\
												HGDebugMsg(HGDBID_BfSizeOverflow, NULL);	\
											}												\
											else {											\
											}
#define CHECK_BF_ZEROSIZE(lpBf)			if(HGMemSize(lpBf) < 1) {							\
											HGDebugMsg(HGDBID_BfSizeIsZero, NULL);			\
										}													\
										else {												\
										}													
#else	// _HGDEBUG_

#define HGGetDbgMsgString(hgDbgID)      NULL
#define CHECK_BF_OVERFLOW(lpStart, lpEnd, BfLen)
#define CHECK_BF_ZEROSIZE(lpBf)

#endif	// _HGDEBUG_
//------------------------------------------------
//------------------------------------------------
//------------------------------------------------

//------------------------------------------------
//--------- hgmsg define -------------------------
//------------------------------------------------
#ifndef __HGK_MSG_DEF
#define __HGK_MSG_DEF


#ifdef HGMSG_ID
#undef HGMSG_ID
#define HGMSG_ID ULONG
#else
#define HGMSG_ID ULONG
#endif // HGMSG_ID

typedef HGMSG_ID FAR *LPHGMSG_ID;

#define HGMSG_ENDMARK				((HGMSG_ID)0xffff0000)
#define HGMSG_NON					((HGMSG_ID)0x00000000)
#define HGMSG_DEFAULT				HGMSG_NON
#define HGMSG_ISWORKEND_YESNO		((HGMSG_ID)0x00000001)
#define HGMSG_FILESEL_ERR			((HGMSG_ID)0x00000002)
#define HGMSG_KEYFILE_ERR			((HGMSG_ID)0x00000003)
#define HGMSG_FILEOPEN_ERR			((HGMSG_ID)0x00000004)
#define HGMSG_FILEREAD_ERR			((HGMSG_ID)0x00000005)
#define HGMSG_FILESAVE_ERR			((HGMSG_ID)0x00000006)
#define HGMSG_FILECLOSE_ERR			((HGMSG_ID)0x00000007)
#define HGMSG_FILECREATE_ERR		((HGMSG_ID)0x00000008)
#define HGMSG_SAMEFILE_OVERWRITE_YESNO	((HGMSG_ID)0x00000011)

#define HGMSGCAP_ERR				""
#define HGMSGCAP_SEE				"Ȯ"
#define HGMSGCAP_WARN				""
#define HGMSGCAP_OPEN				""
#define HGMSGCAP_READ				"б"
#define HGMSGCAP_SAVE				""
#define HGMSGCAP_CLOSE				"ݱ"

// macro
#define HGMsgBox_Err(ErrMsg)		HGMsgBox(ErrMsg, HGMSGCAP_ERR, MB_OK)
#define HGMsgBox_See(SeeMsg)		HGMsgBox(SeeMsg, HGMSGCAP_SEE, MB_OK)
#define HGMsgBox_Warn(WarnMsg)		HGMsgBox(WarnMsg, HGMSGCAP_WARN, MB_OK)
#define HGMsgBox_YesNo(HGMsg)		HGMsgBox(HGMsg, HGMSGCAP_SEE, MB_YESNO)

// function
p_str HGMsgString(HGMSG_ID HGMsgID);

#endif /* __HGK_MSG_DEF */   
//------------------------------------------------
//--------- --------------------------------------
//------------------------------------------------



#pragma pack(4)

#ifdef __cplusplus
extern "C" {            /* Assume C declarations for C++ */
#endif /* __cplusplus */

#undef  HGASSERT
#ifdef _HGDEBUG_
#define HGASSERT(flag)                  ((flag) ? (void)0 : HGALERT(__FILE__, __LINE__, flag))
#define HGDebugMsg(hgDbgID, hgDbgStr)   HGDEBUGALERT(__FILE__, __LINE__, hgDbgID, hgDbgStr)
#define HGDbgBrk                        HGASSERT(FALSE)
#define HGDbgMsg                        HGDebugMsg
#define HGDbgSysMsg(hgDbgID)            HGDebugMsg(hgDbgID, NULL)
#define HGDbgUserMsg(UserMsg)            HGDebugMsg(HGDBID_NON, UserMsg)
#else    // _HGDEBUG_
#define HGASSERT(flag)                  (void)0
#define HGDebugMsg(hgDbgID, hgDbgStr)   (void)0
#define HGDbgBrk                        (void)0
#define HGDbgMsg                        (void)0
#define HGDbgSysMsg(hgDbgID)            (void)0
#define HGDbgUserMsg(UserMsg)           (void)0
#endif    // _HGDEBUG_

#undef  hgassert
#define hgassert        HGASSERT
#undef  hgdbgbrk
#define hgdbgbrk        HGDbgBrk
#define hgdbgusermsg    HGDbgUserMsg

#ifdef _HGWINVER_

#ifndef WINAPI
#define WINAPI
#endif    //WINAPI

/* _lopen() flags */
#define READ        0
#define WRITE       1
#define READ_WRITE  2

#define FILE_CREATE_MODE        0    // for _lcreat()

#define HGSprintf               wsprintf
#define HGMsgBox                HGMsgGuiBox
#define HGMsgBeep               MessageBeep(0)
#define HG_STR_PBREAK           "\r\n"
#define HG_STR_DIR              "\\"
#define HG_CHAR_DIR             HGC__BSL
#else    // _HGWINVER_
#define MessageBeep(i)           1
#define LoadCursor(hwnd, curid)  1
#define SetCursor(curid)         1

#define FILE_CREATE_MODE         0766  // for creat(unix)
#define _O_BINARY                0x8000
#define _O_TEXT                  0x4000
#define setmode(handle, mode)    0
#define _setmode(handle, mode)   0

#define HGSprintf               sprintf
#define HGMsgBox                HGMsgConBox
#define HGMsgBeep               putc(0x07, stdout)
#define HG_STR_PBREAK           "\n"
#define HG_STR_DIR              "/"
#define HG_CHAR_DIR             HGC__SLA
#define itoa                    HGNumToAsc
#define ltoa                    HGNumToAsc
#define itob                    HGNumToByte
#endif    // _HGWINVER_

#define    HG_STR_TAB   "\t"    // TBrk(TabBreak)ʹ ٸ 뵵 Ѵ.
#define    HG_STR_CRLF  "\r\n"  // PBrk(ParaBreak)ʹ ٸ 뵵 Ѵ.
#define    HG_STR_LF    "\n"    // PBrk(ParaBreak)ʹ ٸ 뵵 Ѵ.

// lowercase redefine
#undef  export
#define      EXPORT

#undef  winapi
#define winapi      WINAPI

#undef  nnull
#define nnull       NULL

#undef  bbool
#define bbool       BOOL

#undef  ffalse
#define ffalse      FALSE

#undef  ttrue
#define ttrue      TRUE

#undef  uuint
#define uuint       UINT

#undef  bbyte
#define bbyte       BYTE

#undef  hgmsgbox
#define hgmsgbox    HGMsgBox

#undef  hgsprintf
#define hgsprintf   HGSprintf

// text-read-size
#define TEXTFILE_READSIZE        ((int)(HGKBSIZE * 31))

// share-define
#define HGPrintf                printf
#define HGPrintf_TBrk           HGPrintf(HG_STR_TBREAK)
#define HGPrintf_WBrk           HGPrintf(HG_STR_WBREAK)
#define HGPrintf_PBrk           HGPrintf(HG_STR_PBREAK)
#define HGPrintf_CRLF           HGPrintf(HG_STR_CRLF)
#define HGPrintf_LF             HGPrintf(HG_STR_LF)
#define HGPrintfTBrk(lpDisp)    {HGPrintf(lpDisp); HGPrintf(HG_STR_TBREAK);}
#define HGPrintfWBrk(lpDisp)    {HGPrintf(lpDisp); HGPrintf(HG_STR_WBREAK);}
#define HGPrintfPBrk(lpDisp)    {HGPrintf(lpDisp); HGPrintf(HG_STR_PBREAK);}

// size-define
#undef HGSIZE16
#define HGSIZE16    16
#define hgsize16    HGSIZE16

#undef HGSIZE32
#define HGSIZE32    32
#define hgsize32    HGSIZE32

#undef HGSIZE64
#define HGSIZE64	64
#define hgsize64	HGSIZE64

#undef HGSIZE80
#define HGSIZE80	80
#define hgsize80	HGSIZE80

#undef HGSIZE128
#define HGSIZE128	128
#define hgsize128	HGSIZE128

#undef HGSIZE256
#define HGSIZE256	256
#define hgsize256	HGSIZE256

#undef HGSIZE512
#define HGSIZE512	512
#define hgsize512	HGSIZE512

#undef HGSTRSIZE16
#define HGSTRSIZE16     16
#define hgstrsize16		HGSTRSIZE16

#undef HGSTRSIZE32
#define HGSTRSIZE32     32
#define hgstrsize32		HGSTRSIZE32

#undef HGSTRSIZE64
#define HGSTRSIZE64     64
#define hgstrsize64		HGSTRSIZE64

#undef HGSTRSIZE80
#define HGSTRSIZE80     80

#undef HGSTRSIZE128
#define HGSTRSIZE128    128

#undef HGSTRSIZE256
#define HGSTRSIZE256    256

#undef HGSTRSIZE512
#define HGSTRSIZE512    512

#undef HGSTRSIZE1024
#define HGSTRSIZE1024   1024

#undef HGSTRSIZE1KB     // 1 kilo-byte
#define HGSTRSIZE1KB    1024

#undef HGSTRSIZE2048
#define HGSTRSIZE2048   2048

#undef HGSTRSIZE2KB     // 2 kilo-byte
#define HGSTRSIZE2KB    2048

#undef HGSTRSIZE64KB     // 64 kilo-byte
#define HGSTRSIZE64KB   (64 * HGSTRSIZE1KB)

#undef HGKBSIZE
#define HGKBSIZE                ((UINT)HGSTRSIZE1024)
#define HGKBSIZE                ((UINT)HGSTRSIZE1024)
#define hgkbsize				HGKBSIZE

#undef HGMBSIZE
#define HGMBSIZE                ((long)(HGKBSIZE * HGKBSIZE))
#define hgmbsize				HGMBSIZE

#undef HGGBSIZE
#define HGGBSIZE                ((long)(HGMBSIZE * HGKBSIZE))

#undef KBSTR
typedef BYTE                    KBSTR[HGKBSIZE];     // kilo string

#undef HGSTR16
typedef BYTE                    HGSTR16[hgsize16];
#define hgstr16                 HGSTR16

#undef HGSTR32
typedef BYTE                    HGSTR32[hgsize32];
#define hgstr32                 HGSTR32

#undef HGSTR64
typedef BYTE                    HGSTR64[hgsize64];
#define hgstr64                 HGSTR64

#undef HGSTR80
typedef BYTE                    HGSTR80[HGSTRSIZE80];
#define hgstr80                 HGSTR80

#undef HGSTR128
typedef BYTE                    HGSTR128[HGSTRSIZE128];
#define hgstr128                HGSTR128

#undef HGSTR256
typedef BYTE                    HGSTR256[HGSTRSIZE256];
#define hgstr256                HGSTR256

#undef HGSTR512
typedef BYTE                    HGSTR512[HGSTRSIZE512];
#define hgstr512                HGSTR512

#undef HGSTR1024
typedef BYTE                    HGSTR1024[HGSTRSIZE1024];
#define hgstr1024               HGSTR1024

//extend-redefine
#ifndef LPUINT
typedef UINT                    FAR *LPUINT;
#endif

#ifndef LPLPSTR
typedef LPSTR                   FAR *LPLPSTR;
#endif

#ifndef SINT
typedef short                   SINT;
#endif

#ifndef USINT
typedef unsigned short          USINT;
#endif    //USINT

#ifndef ULONG
typedef unsigned long           ULONG;
#endif    //ULONG

#ifndef LPULONG
typedef ULONG                   FAR *LPULONG;
#endif    //LPULONG

#ifndef LPLPLONG
typedef LPLONG                  FAR *LPLPLONG;
#endif    // LPLPLONG

#ifndef LPLPVOID
typedef LPVOID                  FAR *LPLPVOID;
#endif    //LPLPVOID

#undef HGNUM1    // 8bit-1byte
typedef BYTE        HGNUM1;

#undef HGNUM2   // 16bit-2byte
typedef USINT       HGNUM2;

#undef HGNUM4   // 32bit-4byte
typedef UINT        HGNUM4;

#undef HGNUM8
typedef ULONG       HGNUM8;

#undef HGPOS
typedef long HGPOS, FAR *LPHGPOS;
#define hgpos       HGPOS        // ġ  (0x00  '0'̶ ̴.)
#define HGPOS_INV   ((HGPOS)(-1))        // ġ  (0x00  '0'̶ ̴.)
#define HGPOS_BEG   ((HGPOS)(0))        // ù° ġ
#define hgpos_inv   HGPOS_INV
#define hgpos_beg   HGPOS_BEG

#undef HGLEN
typedef long HGLEN, FAR *LPHGLEN;
#define hglen       HGLEN
#define HGLEN_INV   ((HGLEN)(0))    // {LEN}   
#define HGLEN_BEG   ((HGLEN)(1))    // ù° {LEN}
#define hglen_inv   HGLEN_INV
#define hglen_beg   HGLEN_BEG

#undef HGIDT
typedef long HGIDT, FAR *LPHGIDT;
#define hgidt       HGIDT
#define HGIDT_INV   ((HGIDT)(0))    // {ID}   - {ID} "1" Ѵ.
#define HGIDT_BEG   ((HGIDT)(1))    // ù° {ID} 
#define hgidt_inv   HGIDT_INV
#define hgidt_beg   HGIDT_BEG

#undef HGNUM
typedef long HGNUM, FAR *LPHGNUM;
#define hgnum       HGNUM
#define HGNUM_INV   ((HGNUM)(0))    // {NUM}  
#define HGNUM_BEG   ((HGNUM)(1))    // ù° {NUM}
#define hgnum_inv   HGNUM_INV
#define hgnum_beg   HGNUM_BEG

#undef HGFLAG
typedef long HGFLAG, FAR *LPHGFLAG;
#define hgflag      HGFLAG
#define HGFLAG_T    ((HGFLAG)(TRUE))    // {TRUE}
#define HGFLAG_F    ((HGFLAG)(FALSE))    // {FALSE}
#define hgflag_t    HGFLAG_T
#define hgflag_f    HGFLAG_F

#undef hfile
#define hfile    HFILE

#undef hfile_error
#define hfile_error HFILE_ERROR


// define-string
#define    HG_STR_WBREAK            " "
#define    HG_STR_TBREAK            "\t"
#define    HG_STR_PARENT_DIR        ".."
#define    HG_STR_CURRENT_DIR       "."

// compare-constant
#define __HG_CP_EQ__            ((long)(0))
#define __HG_CP_NOTEQ__         ((long)((~__HG_CP_EQ__)))
#define __HG_CP_MORE__          ((long)((1)))
#define __HG_CP_MOREEQ__        ((long)((2)))
#define __HG_CP_LESS__          ((long)((-1)))
#define __HG_CP_LESSEQ__        ((long)((-2)))

// *** max-limit-define ***
#define HGMAX_LMT_char          0x7f
#define HGMAX_LMT_BYTE          0xff
#define HGMAX_LMT_unsigned_char HGMAX_LMT_BYTE

#define HGMAX_LMT_int           0x7fffffff
#define HGMAX_LMT_UINT          0xffffffff
#define HGMAX_LMT_unsigned_int  HGMAX_LMT_UINT
#define HGMAX_LMT_SINT          0x7fff
#define HGMAX_LMT_USINT         0xffff
#define HGMAX_LMT_long          0x7fffffff
#define HGMAX_LMT_ULONG         0xffffffff

// *** sizeof type define ***
#define HGSIZEOF_CHAR           sizeof(char)
#define HGSIZEOF_BYTE           sizeof(BYTE)
#define HGSIZEOF_INT            sizeof(int)
#define HGSIZEOF_UINT           sizeof(UINT)
#define HGSIZEOF_SINT           sizeof(SINT)
#define HGSIZEOF_USINT          sizeof(USINT)
#define HGSIZEOF_LONG           sizeof(long)
#define HGSIZEOF_ULONG          sizeof(ULONG)

// *** sizeof type bit size define ***
#define HGSIZE_CHAR_BIT         (HGSIZEOF_CHAR * 8)
#define HGSIZE_BYTE_BIT         (HGSIZEOF_BYTE * 8)
#define HGSIZE_INT_BIT          (HGSIZEOF_INT * 8)
#define HGSIZE_UINT_BIT         (HGSIZEOF_UINT * 8)
#define HGSIZE_SINT_BIT         (HGSIZEOF_SINT * 8)
#define HGSIZE_USINT_BIT        (HGSIZEOF_USINT * 8)
#define HGSIZE_LONG_BIT         (HGSIZEOF_LONG * 8)
#define HGSIZE_ULONG_BIT        (HGSIZEOF_ULONG * 8)

// *** value-macro *** 
#define HGLOBYTE(w)             ((BYTE)(w))
#define HGHIBYTE(w)             ((BYTE)(((USINT)(w) >> HGSIZE_BYTE_BIT) & 0xFF))

#define HGLOSINT(l)             ((SINT)(long)(l))
#define HGHISINT(l)             ((SINT)((((long)(l)) >> HGSIZE_SINT_BIT) & 0xFFFF))

#define HGLOINT(l)              ((int)(long)(l))
#define HGHIINT(l)              ((int)((((long)(l)) >> HGSIZE_INT_BIT) & 0xFFFF))

#define HGLOUSINT(l)            ((USINT)(long)(l))
#define HGHIUSINT(l)            ((USINT)((((long)(l)) >> HGSIZE_USINT_BIT) & 0xFFFF))

#define HGUSINT(hi, lo)         ((USINT)(((BYTE)(lo)) | (((USINT)((BYTE)(hi))) << 8)))
#define HGLONG(high, low)       ((LONG)(((USINT)(low)) | (((LONG)((USINT)(high))) << 16)))

// function macro - file-seek
#define HGFP_START(hFile)       (HGLSeek(hFile, 0, SEEK_SET))
#define HGFP_END(hFile)         (HGLSeek(hFile, 0, SEEK_END))
#define HGFP_CUR(hFile)         (HGLSeek(hFile, 0, SEEK_CUR))
#define HGFP_SET(hFile, setpos) (HGLSeek(hFile, setpos, SEEK_SET))

// function macro - extra
#define HGFileWrite_PBrk(hFile)    HGFileWrite(hFile, HG_STR_PBREAK, HGStrLen(HG_STR_PBREAK))
#define HGFileWrite_WBrk(hFile)    HGFileWrite(hFile, HG_STR_WBREAK, HGStrLen(HG_STR_WBREAK))
#define HGFileWrite_TBrk(hFile)    HGFileWrite(hFile, HG_STR_TBREAK, HGStrLen(HG_STR_TBREAK))
#define HGInitString(Str, Size, Type)    HGMemSet(Str, Type, Size)

// function macro - memory-monitor
#ifdef _MEMMONITOR_
#define HGAlloc(AllocSize)          (ASSERTHGAlloc(__FILE__, __LINE__, AllocSize))
#define HGFree(lpMem)               (ASSERTHGFree(__FILE__, __LINE__, (LPLPVOID)&lpMem))
#else    // _MEMMONITOR_
#define HGAlloc(AllocSize)          (HGMemAlloc(AllocSize))
#define HGFree(lpMem)               (HGMemFree(lpMem))
#endif    // _MEMMONITOR_

#define HGRealloc       HGMemRealloc

#define hgfree          HGFree
#define hgalloc         HGAlloc
#define hgrealloc       HGRealloc
#define hginitstring	HGInitString

//  ÷(increase-decrease-flag)
#define HGFLAG_INC        TRUE    // increase-counter
#define HGFLAG_DEC        FALSE    // decrease-counter

// RGB color
#define HGGetBValue(HGRgb)      ((BYTE) ((HGRgb) >> 16)) 
#define HGGetGValue(HGRgb)      ((BYTE) (((WORD) (HGRgb)) >> 8)) 
#define HGGetRValue(HGRgb)      ((BYTE) (HGRgb)) 
#define HGRGB(HGR, HGG ,HGB)    ((DWORD) (((BYTE) (HGR) | ((WORD) (HGG) << 8)) | (((DWORD) (BYTE) (HGB)) << 16))) 

//--------------
// ҹ 
//--------------
#define hgmemset	HGMemSet
#define hgstrlen	HGStrLen
#define hgstrcpy	HGStrCpy
#define hgstrncpy	HGStrNCpy
#define hgstrdup    HGStrDup
#define hgstrcmp    HGStrCmp
#define hgstrncmp   HGStrNCmp
#define hgstrchr    HGStrChr
#define hgstrchr_pair   HGStrChrPair

#define hgfilewrite HGFileWrite
#define hgfileclose HGFileClose
#define hgfileread  HGFileRead
#define hgfileseek  HGLSeek

enum hgcomp {
    hgcm_eq = 0,
    hgcm_lt = (-1),
    hgcm_lte = (-2),
    hgcm_gt = (1),
    hgcm_gte = (2),
    hgcm_ne = (~hgcm_eq)
};

//-------------------
// time  ()
//-------------------
typedef struct tagHGTIME HGTIME, FAR *LPHGTIME;
typedef LPHGTIME FAR *LPLPHGTIME;
#define hgtime      HGTIME
#define lphgtime    LPHGTIME
#define lplphgtime  LPLPHGTIME

struct tagHGTIME {
    char        hiyear;    // high-year: century
    char        loyear;    // low-year: ~ty-year
    char        mon;    // (1 - 12; January = 1)
    char        day;    // (1 - 31)
    char        hour;    // (0 - 23)
    char        min;    // (0 - 59)
    char        sec;    // (0 - 59)
    char        wday;    // (1 - 7; Sunday = 1)
    char        hiyday;    // (0 - 3; 000, 100, 200, 300) (Day of year)
    char        loyday;    // (1 - 99; ) (Day of year)
    char        disp;    // (0 - 10) 
};

//-----
// Լ
//-----
long HGLSeek(HFILE hFile, long Offset, int SeekMode);
int  HGFileOpen(LPCSTR filename, int oflag);
int  HGFileCreate(LPCSTR filename, int oflag);
int  HGFileClose(int handle);
int  HGFileRead(int handle, LPVOID buffer, UINT count);
int  HGFileWrite(int handle, LPVOID buffer, UINT count);
UINT HGStrLen(LPCSTR String);
LPVOID HGMemAlloc(UINT AllocSize);
void HGMemFree(LPVOID lpMem);
UINT HGMemSize(LPVOID lpMem);
void HGMemSet(p_str Str, int Type, UINT Size);
int HGMsgGuiBox(LPCSTR lpszText, LPCSTR lpszTitle, UINT fuStyle);
int HGMsgConBox(LPCSTR lpszText, LPCSTR lpszTitle, UINT fuStyle);
int HGStrCmp(LPCSTR lpOrgStr, LPCSTR lpDstStr);
p_str HGStrCpy(p_str String1, LPCSTR String2);
p_str HGStrDup(p_str String);
int HGStrNCmp(LPCSTR lpOrgStr, LPCSTR lpDstStr, int Num);
p_str HGStrNCpy(p_str Dst, p_str Src, int Num);
bbool HGGetTime(LPHGTIME lpHGTime);

#ifdef __cplusplus
}
#endif

#pragma pack()
#endif /* __bool_ext_def__ */   
