#include "nowinfo.h"
//-#include "mod_exp.h"

//--------
// nowgate
//--------
nowgate::nowgate(p_nowgate p_nowgate_b /* = nnull */, long sortkey_b /* = sortkey_invalid */)
{
    init();

    // ϴ ˻
    if(p_nowgate_b != nnull) {
        //Ʈ
        hgstrncpy((p_str)this->m_nowhead.ba_gatename, 
            (p_str)p_nowgate_b->m_nowhead.ba_gatename, 
            sizeof(this->m_nowhead.ba_gatename));
    	
        this->m_nowanal = p_nowgate_b->m_nowanal;  //  м 
        this->m_analopt = p_nowgate_b->m_analopt;  //  м ó  ɼ


        // codegateκ   ޴ Ѱش
        // codegateκ   ؼ ߰ Ȯ  ֱ ̴.
        this->m_nowhead.assistcode = p_nowgate_b->m_nowhead.assistcode;

        //   ش.
        if(sortkey_b == sortkey_invalid) {
            //   Ű  ȿ̸ p_nowgate_b  Ű ̾޴´.
            this->m_nowhead.sortkey = p_nowgate_b->m_nowhead.sortkey;
        }
        else {
            this->m_nowhead.sortkey = sortkey_b;
        }
    
        // 
        int         debug_cnt = 0;
	    p_nowlink	lpCurRec, p_new;
    	
	    lpCurRec = p_nowgate_b->p_head;
	    while(lpCurRec) {
            debug_cnt++;
            if(debug_cnt > p_nowgate_b->get_linknum()) {
                hgdbgbrk;
                break;
            }
            //-if(debug_cnt > 4) {
            //-    // ӽ÷ 10 óѴ.
            //-    break;
            //-}

            p_new = dup_nowlink(lpCurRec);
            if(this->append(p_new) == ffalse) {
                hgfree(p_new);
                p_new = nnull;
			    hgdbgbrk;
                break;
		    }

            //
		    lpCurRec = lpCurRec->p_next;
	    }

        //  ũ ȭŲ.
        // - 뷮 ݺ Ž ӵ  ش.
        this->centering_link();

        //-------------------------
        // nowhead  Ѱش.
        //-------------------------
        // ð+ð
        this->m_nowhead.runday = p_nowgate_b->m_nowhead.runday;    //  ȹ ؼ Ų ¥
        this->m_nowhead.dataday = p_nowgate_b->m_nowhead.dataday;   //  ȹ ¥(runday ʴ.)
        this->m_nowhead.datatime = this->m_nowhead.datatime;  //  ȹ ð(0=> 00:00:00, (-1) ȿ )

    }
    else {
        //   Ѿ  Ű Ѱִ Ȯ
        if(sortkey_b != sortkey_invalid) {
            this->m_nowhead.sortkey = sortkey_b;
        }
    }
}

nowgate::~nowgate()
{
    reset();
}

bbool nowgate::init()
{
    if(init_nowhead(&this->m_nowhead) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }
    if(init_nowanal(&this->m_nowanal) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }
    if(init_nowanal(&this->m_analopt) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

	// ũ
	this->init_link();

    return ttrue;
}

void nowgate::init_link()
{
    init_link_child();
    init_link_sible();
}

void nowgate::init_link_child()
{
	this->p_top = nnull;
	this->p_head = nnull;
	this->p_tail = nnull;
}

void nowgate::init_link_sible()
{
    // sible
    this->p_parsib = nnull;
    this->p_nextsib = nnull;
	this->p_prevsib = nnull;
	this->p_leftsib = nnull;
	this->p_rightsib = nnull;
}

bbool nowgate::reset(void)
{
	p_nowlink	lpCurRec, lpNewRec;
	
    if(reset_nowhead(&this->m_nowhead) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    if(reset_nowanal(&this->m_nowanal) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }
    if(reset_nowanal(&this->m_analopt) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }

    //
	lpCurRec = this->p_head;
	
	while(lpCurRec) {
		lpNewRec = lpCurRec->p_next;

		if(free_nowlink(&lpCurRec) == ffalse) {
			hgdbgbrk;
            break;
		}
        lpCurRec = nnull;
	
		lpCurRec = lpNewRec;
	}

	//
    init();

    return ttrue;
}

bbool nowgate::comp(p_nowgate p_info_n, long sortkey, p_int p_retcomp)
{
    hgassert((p_info_n != nnull) && (p_retcomp != nnull));

	if((p_info_n == nnull) || (p_retcomp == nnull)) {
        hgdbgbrk;
		return ffalse;
	}

    //
    float   avgrate_up = 0, avgrate_down = 0;
    float   avgrate_up_n = 0, avgrate_down_n = 0;
    float   retfloat;

    *p_retcomp = 0;

    switch(sortkey) {
    case sortkey_lastatach: //  ڿ ̱(ũ   )
        // append  ڿ ٰ ذ  ɷ .
        *p_retcomp = (-1);
        break;
    case sortkey_upitem_high:   //    
        //---------------------------------------------------
        // (compval > 0)   
        // (compval < 0) ū  
        // ū ͺ  Ϸ  ٲپ ־ Ѵ.
        //---------------------------------------------------
        //-*p_retcomp = this->m_nowanal.num_up - p_info_n->m_nowanal.num_up;
        *p_retcomp = p_info_n->m_nowanal.num_up - this->m_nowanal.num_up;
        break;
    case sortkey_midupitem_high:    // ߰    
        //---------------------------------------------------
        // (compval > 0)   
        // (compval < 0) ū  
        // ū ͺ  Ϸ  ٲپ ־ Ѵ.
        //---------------------------------------------------
        //-*p_retcomp = this->m_nowanal.num_midup - p_info_n->m_nowanal.num_midup;
        *p_retcomp = p_info_n->m_nowanal.num_midup - this->m_nowanal.num_midup;
        break;
    case sortkey_avg_uprate_high:   // ջ    
        this->get_updown_avgrate(&avgrate_up, &avgrate_down);
        p_info_n->get_updown_avgrate(&avgrate_up_n, &avgrate_down_n);
        retfloat = avgrate_up_n - avgrate_up;
        if(retfloat > 0) {
            *p_retcomp = 1;
        }
        else if(retfloat < 0) {
            *p_retcomp = (-1);
        }
        else {
            *p_retcomp = 0;
        }
        break;
    case sortkey_codename:  // ̸ - ⼭ Ʈ̸ óϴ  ǹѴ.
        *p_retcomp = hgstrcmp(this->get_gatename(), p_info_n->get_gatename());
        break;
    default:
        hgdbgbrk;
		return ffalse;
    }

	return ttrue;
}

bbool nowgate::append_dup(p_nowlink p_org)
{
	p_nowlink  p_new;

    hgassert(p_org != nnull);

	if(p_org == nnull) {
		return ffalse;
	}
    p_new = dup_nowlink(p_org);
    if(this->append(p_new) == ffalse) {
        hgfree(p_new);
        p_new = nnull;
		hgdbgbrk;

        return ffalse;
	}

    return ttrue;
}

bbool nowgate::append(p_nowlink p_new)
{
	p_nowlink  p_curpos, p_loop;

    hgassert(p_new != nnull);

	if(p_new == nnull) {
		return ffalse;
	}

	// [p_new] õ ũ(θ,,,,) ʱȭѴ.
	// 쿡 󼭴 ʱȭ    ´.
	init_nowlink_link(p_new);

	p_curpos = p_top;
	if(p_curpos == nnull) {
		p_head = p_new;
		p_tail = p_new;
		p_top = p_new;
	}
    else {
        p_loop = nnull;
	    while(p_curpos) {
            if((p_loop != nnull) && (p_loop == p_curpos)) {
                HGMsgBox_Err(" (loop) ϴ.");
                return false;
            }
            p_loop = p_curpos;

            int     compval;

            if(comp_nowinfo(&p_curpos->value, &p_new->value, this->m_nowhead.sortkey, &compval) == ffalse) {
                hgdbgbrk;
                return ffalse;
            }
            if(compval < 0) {
                if(p_curpos->p_left == nnull) {
				    p_new->p_par = p_curpos;
				    p_curpos->p_left = p_new;
    				
                    if(p_curpos->p_prev) {
                        p_curpos->p_prev->p_next = p_new;
                        p_new->p_prev = p_curpos->p_prev;
                        p_curpos->p_prev = p_new;
                        p_new->p_next = p_curpos;
                    }
                    else {
                        p_curpos->p_prev = p_new;
                        p_new->p_next = p_curpos;
            		    p_head = p_new;
                    }
				    break;
			    }
    				
			    p_curpos = p_curpos->p_left;
		    }
		    else {
			    if(p_curpos->p_right == nnull) {
                    p_new->p_par = p_curpos;
				    p_curpos->p_right = p_new;

                    if(p_curpos->p_next) {
                        p_curpos->p_next->p_prev = p_new;
                        p_new->p_next = p_curpos->p_next;
                        p_curpos->p_next = p_new;
                        p_new->p_prev = p_curpos;
                    }
                    else {
                        p_curpos->p_next = p_new;
                        p_new->p_prev = p_curpos;
            		    p_tail = p_new;
                    }
				    break;
			    }
    				
			    p_curpos = p_curpos->p_right;
		    }
	    }
    }

    //
    this->m_nowhead.linknum++;

    //  ȹ ð - ֽ ð 
    if(p_new->value.fixvalue.pri.amount > 0) {
        // ݵ ŷ ִ Ȯؾ Ѵ.
        // ŷ   ŷ  񿡼 ð  ִ 찡 ִ.
        // -   Ͱ ִ  .
        if(this->m_nowhead.datatime < p_new->value.fixvalue.pri.time) {
            this->m_nowhead.datatime = p_new->value.fixvalue.pri.time;
        }
    }

    return ttrue;
}

p_nowlink nowgate::append(p_str p_codeval, p_str p_codename, p_nowfxin p_fixvalue, p_codefxin p_code_fix /* = nnull */)
{
    // p_code_fix ׸ nnull ȿ̴.
	hgassert((p_codeval != nnull) && (p_fixvalue != nnull) && (p_codename != nnull));

    if((p_codeval == nnull) || (p_fixvalue == nnull) || (p_codename == nnull)) {
        hgdbgbrk;
        return nnull;
    }

    //
	p_nowlink	p_info;
	
	p_info = create_nowlink();
	if(p_info == nnull) {
		hgdbgbrk;
        return nnull;
	}

	//
    hgstrncpy((p_str)p_info->value.code.ba_num, p_codeval, sizeof(p_info->value.code.ba_num));

    p_info->value.code.p_name = hgstrdup(p_codename);
    if(p_info->value.code.p_name == nnull) {
        hgdbgbrk;
        goto exit_pos;
    }

    //
    p_info->value.fixvalue = *p_fixvalue;

    //--------------------------------------------
    // ⼭ʹ  ߰ ̴.
    //--------------------------------------------
    //-if(hgstrcmp(p_info->value.code.p_name, "ũ") == 0) {
    //-    int     dummy;
    //-    dummy = 0;
    //-}
    p_info->value.fixvalue.pri.rate = calc_nowinfo_rate(&p_info->value);  // ϴ 
    p_info->value.fixvalue.amount_rate = calc_nowinfo_amountrate(&p_info->value);  // ϴ ŷ 
    p_info->value.fixvalue.amount_rotate = calc_nowinfo_amountrotation(&p_info->value);

    // ڵ Ȯ  ó
    if(p_code_fix != nnull) {   //    óѴ.
        p_info->value.fixvalue.assist_code = *p_code_fix;

        // ŷ (ŷ , ڽ õ)
        // ŷҸ õ ش.
        //  ̹Ƿ 10 ؼ õ ļ
        // ŷ  ϽŲ.
        if(p_info->value.fixvalue.assist_code.market == market_ext_so) {
            p_info->value.fixvalue.money *= 10; 
        }
    }

    //
	if(this->append(p_info) == ffalse) {
exit_pos:
		hgdbgbrk;
		if(free_nowlink(&p_info) == ffalse) {
			hgdbgbrk;
		}
        return nnull;
	}

	return p_info;
}

bbool nowgate::append(p_codeinfo p_codeinfo_b)
{
	hgassert(p_codeinfo_b != nnull);

    if(p_codeinfo_b == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
	p_nowlink	p_info;
	
	p_info = create_nowlink_codeinfo(p_codeinfo_b);
	if(p_info == nnull) {
		hgdbgbrk;
		return ffalse;
	}

    //
	if(this->append(p_info) == ffalse) {
		hgdbgbrk;
		if(free_nowlink(&p_info) == ffalse) {
			hgdbgbrk;
		}
		return ffalse;
	}

	return ttrue;
}

bbool nowgate::del(p_nowlink p_del)
{
    if(this->unlink(p_del) == ffalse) {
        hgdbgbrk;
        return ffalse;
    }
	
    //--------------------------
    // Linũ ʱȭѴ.
	init_nowlink_link(p_del);

	if(free_nowlink(&p_del) == ffalse) {
		hgdbgbrk;
        return ffalse;
	}
    p_del = nnull;
	
    return true;
}

bbool nowgate::unlink(p_nowlink p_unlink)
{
    if(p_unlink == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
	p_nowlink   lpCurRec, lpPreRec, lpRepRec, lpParRec, lpSonRec;
	p_nowlink   lpSamePre, lpSameNext;

    // init
    lpRepRec = nnull;
    lpParRec = nnull;
    lpSonRec = nnull;

	lpCurRec = p_top;
	lpPreRec = NULL;
	while(lpCurRec) {
		if(lpCurRec == p_unlink) {
			break;
		}
		lpPreRec = lpCurRec;

        int compval;
        if(comp_nowinfo(&lpCurRec->value, &p_unlink->value, this->m_nowhead.sortkey, &compval) == ffalse) {
            hgdbgbrk;
            return ffalse;
        }
        if(compval == 0) {
            //  ڵ   ̵
	        while(lpCurRec) {
		        if(lpCurRec == p_unlink) {
			        break;
		        }
                lpSamePre = lpCurRec->p_prev;
                if(lpSamePre == nnull) {
                    break;
                }

                if(comp_nowinfo(&lpCurRec->value, &lpSamePre->value, this->m_nowhead.sortkey, &compval) == ffalse) {
                    hgdbgbrk;
                    return ffalse;
                }
                if(compval != 0) {
                    break;
                }

                lpPreRec = lpCurRec->p_par;
                lpCurRec = lpSamePre;
            }

            //  ڵ  տ ʴ ˻
	        while(lpCurRec) {
		        if(lpCurRec == p_unlink) {
			        break;
		        }
                lpSameNext = lpCurRec->p_next;
                if(lpSameNext == nnull) {
                    hgdbgbrk;
                    return ffalse;
                }

                if(comp_nowinfo(&lpCurRec->value, &lpSameNext->value, this->m_nowhead.sortkey, &compval) == ffalse) {
                    hgdbgbrk;
                    return ffalse;
                }
                if(compval != 0) {
                    hgdbgbrk;
                    return ffalse;
                }

                lpPreRec = lpCurRec->p_par;
                lpCurRec = lpSameNext;
            }
        }
        else if(compval < 0) {
			lpCurRec = lpCurRec->p_left;
		}
		else {
			lpCurRec = lpCurRec->p_right;
		}
	}
	if(lpCurRec == NULL) {
        hgdbgbrk;
        HGMsgBox_Err("Ϸ ޸  شϴ  ϴ.");
		return false;	// not-exist
	}
	
    if(lpCurRec->p_left == NULL) {
    	lpRepRec = lpCurRec->p_right;
    }
    else {
    	if(lpCurRec->p_right == NULL) {
	    	lpRepRec = lpCurRec->p_left;
    	}
    	else {
    		lpParRec = lpCurRec;
    		lpRepRec = lpCurRec->p_right;
    		lpSonRec = lpRepRec->p_left;
        
    		while(lpSonRec) {
	    		lpParRec = lpRepRec;
	    		lpRepRec = lpSonRec;
	    		lpSonRec = lpRepRec->p_left;
    		}
        	
    		if(lpParRec != lpCurRec) {
    			lpParRec->p_left = lpRepRec->p_right;
    			lpRepRec->p_right = lpCurRec->p_right;
    		}
        	
    		lpRepRec->p_left = lpCurRec->p_left;
    	}
    }
    
    if(lpPreRec == NULL) {
    	p_top = lpRepRec;
    }
    else {
    	if(lpCurRec == lpPreRec->p_left) {
    		lpPreRec->p_left = lpRepRec;
    	}
    	else {
    		lpPreRec->p_right = lpRepRec;
    	}
    }
	
	//  ũ óѴ.
	if(lpCurRec == p_head) {
		if(lpCurRec == p_tail) {
			hgassert(this->m_nowhead.linknum == 1);

			p_head = nnull;
			p_tail = nnull;
		}
		else {
			p_head = lpCurRec->p_next;
			p_head->p_prev = nnull;
		}
	}
	else if(lpCurRec == p_tail) {
		hgassert(this->m_nowhead.linknum > 1);

		if(lpCurRec == p_head) {
			// ٷ տ ˻߱    .
			hgdbgbrk;

			p_head = nnull;
			p_tail = nnull;
		}
		else {
			p_tail = lpCurRec->p_prev;
			p_tail->p_next = nnull;
		}
	}
	else {
		hgassert(this->m_nowhead.linknum > 1);

		lpPreRec = lpCurRec->p_prev;
		lpSonRec = lpCurRec->p_next;

		lpPreRec->p_next = lpSonRec;
		lpSonRec->p_prev = lpPreRec;
	}

	this->m_nowhead.linknum--;

    return true;
}

bbool nowgate::del_dublecode()
{
    switch(this->m_nowhead.sortkey) {
    case sortkey_codeval:   // ڵ
    case sortkey_codename:  // ̸
        break;
    default:
        //  Ű  Լ   .
        hgdbgbrk;
        return ffalse;
    }

	p_nowlink  lpCurRec, lpNextRec;

    // init
	lpCurRec = this->p_head;
	while(lpCurRec) {
        lpNextRec = lpCurRec->p_next;
        if(lpNextRec == nnull) {
            if(lpCurRec != this->p_tail) { //  
                hgdbgbrk;
                return ffalse;
            }
            //    -  ̻ ߺ ڵ尪 .
            break;
        }

        int compval;
        switch(this->m_nowhead.sortkey) {
        case sortkey_codeval:   // ڵ
            compval = hgstrcmp((p_str)lpCurRec->value.code.ba_num, 
                                (p_str)lpNextRec->value.code.ba_num);
            break;
        case sortkey_codename:  // ̸
            compval = hgstrcmp((p_str)lpCurRec->value.code.p_name, 
                                (p_str)lpNextRec->value.code.p_name);
            break;
        default:
            //  Ű  Լ   .
            hgdbgbrk;
            return ffalse;
        }
        if(compval == 0) {
            //   ߰ߵǸ   .
            // ڿ    ֽ  ɼ .
            if(this->del(lpCurRec) == ffalse) {
                hgdbgbrk;
                return ffalse;
            }
        }
		lpCurRec = lpNextRec;
	}
	
    return true;
}

p_str nowgate::get_gatename()
{
    return (p_str)this->m_nowhead.ba_gatename;
}

bbool nowgate::set_gatename(p_str p_gatename, long day_ymd /* = 0 */)
{
    hgassert(p_gatename != nnull);

    if(p_gatename == nnull) {
        hgdbgbrk;
        return ffalse;
    }
    
    if(day_ymd > 0) {
        hgsprintf((LPTSTR)this->m_nowhead.ba_gatename, _T("%s-%d"),
            p_gatename, day_ymd);
    }
    else {
        hgstrncpy((p_str)this->m_nowhead.ba_gatename, 
            p_gatename, sizeof(this->m_nowhead.ba_gatename));
    }

    return ttrue;
}

bbool nowgate::get_assistcode()
{
    return this->m_nowhead.assistcode;
}

void nowgate::set_assistcode(bbool assistcode)
{
    this->m_nowhead.assistcode = assistcode;
}

long nowgate::get_sortkey()
{
    return this->m_nowhead.sortkey;
}

void nowgate::set_sortkey(long sortkey)
{
    switch(sortkey) {
    case sortkey_invalid:   // ȿ-̰ ޾ش.
    case sortkey_codeval:   // ڵ
    case sortkey_codename:  // ̸
    case sortkey_amount_high:   // ŷ ūͺ
    case sortkey_amountrate_high:   // ŷ ūͺ
    case sortkey_money_high:    // ŷ ūͺ
    case sortkey_rate_high: //  ūͺ
    case sortkey_presee_rate_high: //  üᰡ  ūͺ
    case sortkey_amountrotate_high: //  ֽĿ  ŷ ȸ
    case sortkey_lastatach: //  ڿ ̱(ũ   )
        this->m_nowhead.sortkey = sortkey;
        break;
    default:
        hgdbgbrk;
		return ;
    }
}

long nowgate::get_runday()
{
    return this->m_nowhead.runday;
}

void nowgate::set_runday(long runday)
{
    this->m_nowhead.runday = runday;
}

long nowgate::get_dataday()
{
    return this->m_nowhead.dataday;
}

void nowgate::set_dataday(long dataday)
{
    this->m_nowhead.dataday = dataday;
}

long nowgate::get_datatime()
{
    return this->m_nowhead.datatime;
}

void nowgate::set_datatime(long datatime)
{
    this->m_nowhead.datatime = datatime;
}

long nowgate::get_linknum()
{
    return this->m_nowhead.linknum;
}

long nowgate::get_avgmount20_filter()
{
    return this->m_nowhead.avgmount20_filter;
}

void nowgate::set_avgmount20_filter(long avgmount20_filter)
{
    this->m_nowhead.avgmount20_filter = avgmount20_filter;
}

long nowgate::get_pluscandle_many_filter()
{
    return this->m_nowhead.pluscandle_many_filter;
}

void nowgate::set_pluscandle_many_filter(long pluscandle_many_filter)
{
    this->m_nowhead.pluscandle_many_filter = pluscandle_many_filter;
}
p_nowhead nowgate::get_nowhead()
{
    return &this->m_nowhead;
}

p_nowanal nowgate::get_nowanal()
{
    return &this->m_nowanal;
}

p_nowanal nowgate::get_analopt()
{
    return &this->m_analopt;
}

bbool nowgate::set_analopt(p_nowanal p_analopt_new)
{
    if(p_analopt_new == nnull) {
        hgdbgbrk;
        return ffalse;
    }
    
    this->m_analopt = *p_analopt_new;

    return ttrue;
}

p_nowlink nowgate::get_top()
{
    return this->p_top;
}

p_nowlink nowgate::get_head()
{
    return this->p_head;
}

p_nowlink nowgate::get_tail()
{
    return this->p_tail;
}

p_nowgate nowgate::get_prevsib()
{
    return this->p_prevsib;
}

bbool nowgate::set_prevsib(p_nowgate p_prevsib)
{
    //--------------------
    // nnull   ִ.
    //--------------------
    //-if(p_prevsib == nnull) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    this->p_prevsib = p_prevsib;

    return ttrue;
}

void nowgate::reset_prevsib()
{
    this->p_prevsib = nnull;
}

p_nowgate nowgate::get_nextsib()
{
    return this->p_nextsib;
}

bbool nowgate::set_nextsib(p_nowgate p_nextsib)
{
    //--------------------
    // nnull   ִ.
    //--------------------
    //-if(p_nextsib == nnull) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    this->p_nextsib = p_nextsib;

    return ttrue;
}

void nowgate::reset_nextsib()
{
    this->p_nextsib = nnull;
}

p_nowgate nowgate::get_parsib()
{
    return this->p_parsib;
}

bbool nowgate::set_parsib(p_nowgate p_parsib)
{
    //--------------------
    // nnull   ִ.
    //--------------------
    //-if(p_parsib == nnull) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    this->p_parsib = p_parsib;

    return ttrue;
}

void nowgate::reset_parsib()
{
    this->p_parsib = nnull;
}

p_nowgate nowgate::get_leftsib()
{
    return this->p_leftsib;
}

bbool nowgate::set_leftsib(p_nowgate p_leftsib)
{
    //--------------------
    // nnull   ִ.
    //--------------------
    //-if(p_leftsib == nnull) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    this->p_leftsib = p_leftsib;

    return ttrue;
}

void nowgate::reset_leftsib()
{
    this->p_leftsib = nnull;
}

p_nowgate nowgate::get_rightsib()
{
    return this->p_rightsib;
}

bbool nowgate::set_rightsib(p_nowgate p_rightsib)
{
    //--------------------
    // nnull   ִ.
    //--------------------
    //-if(p_rightsib == nnull) {
    //-    hgdbgbrk;
    //-    return ffalse;
    //-}

    this->p_rightsib = p_rightsib;

    return ttrue;
}

void nowgate::reset_rightsib()
{
    this->p_rightsib = nnull;
}

long nowgate::find_recorder(p_nowlink p_cur)
{
	p_nowlink p_code;
	long      Order;

	hgassert(p_cur != nnull);

    if(p_cur == nnull) {
		return hgpos_inv;
	}

    Order = 0;
	p_code = this->p_head;
	while(p_code) {
        Order++;
        if(p_code == p_cur) {
            return Order;
        }
        
        p_code = p_code->p_next;
    }

    //    .
    hgdbgbrk;
	return hgpos_inv;
}

p_nowlink nowgate::find_codeval(p_str p_codeval)
{
    hgassert(p_codeval != nnull);

    if(p_codeval == nnull) {
        return nnull;
    }
    if(hgstrlen(p_codeval) <= 0) {
        hgdbgbrk;
        return nnull;
    }

    if(this->m_nowhead.sortkey == sortkey_codeval) {
	    p_nowlink  p_curpos;

	    p_curpos = this->p_top;
	    if(p_curpos == nnull) {
            //-hgdbgbrk;  ƴϴ.
            return nnull;
	    }
        else {
	        while(p_curpos) {
                int     compval;

                // this->append() Ҷ ٸ   ٲپ Ѵ.
                compval = hgstrcmp(p_codeval, (p_str)p_curpos->value.code.ba_num);
                if(compval == 0) {
                    return p_curpos;
                }
                else if(compval < 0) {
                    if(p_curpos->p_left == nnull) {
                        //-hgdbgbrk;  ƴϴ.
                        return nnull;
			        }
			        p_curpos = p_curpos->p_left;
		        }
		        else {
			        if(p_curpos->p_right == nnull) {
                        //-hgdbgbrk;  ƴϴ.
                        return nnull;
			        }
			        p_curpos = p_curpos->p_right;
		        }
	        }
        }
    }
    else {
        // Ű ڵ尪 ƴϸ  Ž ã´
        // Ͱ  쿡 ð  ɸ.
	    p_nowlink    p_code;

	    p_code = this->p_head;
	    while(p_code) {
            if(hgstrcmp((p_str)p_code->value.code.ba_num, p_codeval) == 0) {
                return p_code;
            }

            //
            p_code = p_code->p_next;
        }
    }

    //-------------------------------
    //    ִ.
    // ٸ Ʈ   ˻縦 ϴٺ  
    //  ˻  ִ.
    //-------------------------------
    //-//    .
    //-hgdbgbrk;
    //-------------------------------
	return nnull;
}

p_nowlink nowgate::find_codename(p_str p_codename)
{
    hgassert(p_codename != nnull);

    if(p_codename == nnull) {
        return nnull;
    }
    if(hgstrlen(p_codename) <= 0) {
        hgdbgbrk;
        return nnull;
    }

    if(this->m_nowhead.sortkey == sortkey_codeval) {
	    p_nowlink  p_curpos;

	    p_curpos = this->p_top;
	    if(p_curpos == nnull) {
            //-hgdbgbrk;  ƴϴ.
            return nnull;
	    }
        else {
	        while(p_curpos) {
                int     compval;

                // this->append() Ҷ ٸ   ٲپ Ѵ.
                compval = hgstrcmp(p_codename, p_curpos->value.code.p_name);
                if(compval == 0) {
                    return p_curpos;
                }
                else if(compval < 0) {
                    if(p_curpos->p_left == nnull) {
                        //-hgdbgbrk;  ƴϴ.
                        return nnull;
			        }
			        p_curpos = p_curpos->p_left;
		        }
		        else {
			        if(p_curpos->p_right == nnull) {
                        //-hgdbgbrk;  ƴϴ.
                        return nnull;
			        }
			        p_curpos = p_curpos->p_right;
		        }
	        }
        }
    }
    else {
        // Ű ڵ尪 ƴϸ  Ž ã´
        // Ͱ  쿡 ð  ɸ.
	    p_nowlink    p_code;

	    p_code = this->p_head;
	    while(p_code) {
		    if(hgstrcmp(p_code->value.code.p_name, p_codename) == 0) {
                return p_code;
            }

            //
            p_code = p_code->p_next;
        }
    }

    //-------------------------------
    //    ִ.
    // ٸ Ʈ   ˻縦 ϴٺ  
    //  ˻  ִ.
    //-------------------------------
    //-//    .
    //-hgdbgbrk;
    //-------------------------------
	return nnull;
}

p_nowlink nowgate::drag_entrylink(hgpos LocPos)
{
	p_nowlink lpMrec_Cur;
	long			Cnt;

	hgassert((LocPos > hgpos_inv) && (LocPos <= this->get_linknum()));

    if((LocPos <= hgpos_inv) || (LocPos > this->get_linknum())) {
		return nnull;
	}

	if(p_head == nnull) {
        hgdbgbrk;
		return nnull;
	}
	
	Cnt = 0;
	lpMrec_Cur = this->p_head;
	while(lpMrec_Cur) {
		if(Cnt == LocPos) {
			return lpMrec_Cur;
		}
	
        Cnt++;
		lpMrec_Cur = lpMrec_Cur->p_next;
	}

	return nnull;
}

bool nowgate::centering_link()
{
    p_nowlink  lpHead, lpTail;
    hgnum       RecNum;

	RecNum = this->m_nowhead.linknum;
    if(RecNum <= hgnum_inv) {
		return true;
	}

	// Bin-Link ´.
	if(this->unlink_binlink() == false) {
		hgdbgbrk;
		return false;
	}

	// óѴ.
	lpHead = p_head;
	lpTail = p_tail;

	p_top = this->binize_link(lpHead, lpTail, RecNum);
	if(p_top == nnull) {
		hgdbgbrk;
		return false;
	}

	return true;
}

bool nowgate::unlink_binlink()
{
	p_nowlink  lpLink;
	hgnum       RecNum;

    //
	RecNum = this->m_nowhead.linknum;
	if(RecNum <= 0) {
		return true;
	}

	// Bin-Link ´.
	lpLink = this->p_head;
	while(lpLink) {
        if(init_nowlink_bin(lpLink) == ffalse) {
            hgdbgbrk;
            return ffalse;
        }

        lpLink = lpLink->p_next;
	}

	return true;
}

p_nowlink nowgate::binize_link(p_nowlink lpHead, p_nowlink lpTail, hgnum RecNum)
{
	p_nowlink  lpMid, lpSubMid, lpSubHead, lpSubTail;
	hgnum       HalfPos, HalfRecNum;

	hgassert((lpHead != nnull) && (lpTail != nnull) && (RecNum > 0));

	if((lpHead == nnull) || (lpTail == nnull) || (RecNum <= 0)) {
		return nnull;
	}

	if(RecNum == 1) {
		hgassert(lpHead == lpTail);
		
		return lpHead;
	}
	else if(RecNum == 2) {
		hgassert(lpHead->p_next == lpTail);

		lpTail->p_left = lpHead;
		lpHead->p_par = lpTail;

		return lpTail;
	}
	else if(RecNum > 2) {
		lpMid = get_midlink(lpHead, lpTail, RecNum, &HalfPos);
		if(lpMid == nnull) {
			hgdbgbrk;
			return nnull;
		}

		// lpLeft .
		lpSubHead = lpHead;
		lpSubTail = lpMid->p_prev;
		HalfRecNum = (HalfPos - 1);

		lpSubMid = this->binize_link(lpSubHead, lpSubTail, HalfRecNum);
		if(lpSubMid == nnull) {
			hgdbgbrk;
			return nnull;
		}
		lpMid->p_left = lpSubMid;
		lpSubMid->p_par = lpMid;

		// lpRight .
		lpSubHead = lpMid->p_next;
		lpSubTail = lpTail;
		HalfRecNum = (RecNum - HalfPos);

		lpSubMid = this->binize_link(lpSubHead, lpSubTail, HalfRecNum);
		if(lpSubMid == nnull) {
			hgdbgbrk;
			return nnull;
		}
		lpMid->p_right = lpSubMid;
		lpSubMid->p_par = lpMid;

		return lpMid;
	}

	return nnull;
}

p_nowlink nowgate::get_midlink(p_nowlink lpHead, p_nowlink lpTail, 
									 hgnum RecNum, LPHGNUM lpMidWordPos)
{
	p_nowlink  lpMid;
	hgnum       HalfPos, Cnt;

	hgassert((lpHead != nnull) && (lpTail != nnull) && (lpMidWordPos != nnull) && (RecNum > 0));

	if((lpHead == nnull) || (lpTail == nnull) || (lpMidWordPos == nnull) || (RecNum <= 0)) {
		return nnull;
	}

	// ߰ ġ Ѵ.
	HalfPos = ((hgnum)(RecNum / 2)) + 1;
	if(HalfPos < 1) {
		hgdbgbrk;
		return nnull;
	}
	*lpMidWordPos = HalfPos;
	
	if(HalfPos == 1) {
		if(lpHead != lpTail) {
			hgdbgbrk;
			return nnull;
		}
		return lpHead;
	}
	else {
		lpMid = lpHead;

		for(Cnt = 1; Cnt < HalfPos; Cnt++) {
            if(lpMid == nnull) {
                hgdbgbrk;
                return nnull;
            }

			lpMid = lpMid->p_next;
		}
	
		return lpMid;
	}

	return nnull;	//  ؼ
}

p_str nowgate::make_codeval_string(hgpos locbeg, long makenum, p_long p_makenum)
{
    hgassert((locbeg > hgpos_inv) && (makenum > 0) && 
        (makenum <= stockmst2_max) && (p_makenum != nnull));

    if((locbeg <= hgpos_inv) || (makenum <= 0) || 
        (makenum > stockmst2_max) || (p_makenum == nnull)) {
        hgdbgbrk;
        return nnull;
    }

    // init
    *p_makenum = 0;
    
    //
    int         cnt, strsum, strpos, curlen;
    p_str       p_retstr;
    p_nowlink   p_cur, p_work;

    //  ġ ̵Ų.
    cnt = 0;
    p_cur = this->p_head;

    while(cnt < locbeg) {
        if(p_cur == nnull) {
            hgdbgbrk;
            return nnull;
        }

        //
        cnt++;
        p_cur = p_cur->p_next;
    }

    // codeval  ü ڿ ̸ Ѵ.
    cnt = 0;
    strsum = 0;
    p_retstr = nnull;
    p_work = p_cur; //  ۾ ؼ  ũ صд.

    while(cnt < makenum) {
        if(p_cur == nnull) {
            //   ׸  
            // -  ƴϴ. ׸   Ⱚ  ʱ ̴.
            //-hgdbgbrk;
            break;
        }

        curlen = hgstrlen((p_str)p_cur->value.code.ba_num);
        if(curlen <= 0) {
            hgdbgbrk;
            return nnull;
        }
        strsum += curlen;

        //
        cnt++;
        p_cur = p_cur->p_next;
    }

    //
    if(strsum <= 0) {
        // ׸ ϳ     
        // - ̸ ϰ Ա  ּ 1 ׸̶ ־ ̴.
        hgdbgbrk;
        return nnull;
    }

    //----------------------------------------------------
    // ޸𸮸 ҴϿ codeval Ŀ ° Ѱش.
    //----------------------------------------------------
    strsum += cnt;  // stocmst2 code ϴ (,)  ߰
    p_retstr = (p_str)hgalloc(strsum + 1);
    if(p_retstr == nnull) {
        hgdbgbrk;
        return nnull;
    }

    cnt = 0;
    strpos = 0;

    while(cnt < makenum) {
        if(p_work == nnull) {
            //   ׸  
            // -  ƴϴ. ׸   Ⱚ  ʱ ̴.
            //-hgdbgbrk;
            break;
        }

        curlen = hgstrlen((p_str)p_work->value.code.ba_num);
        if(curlen <= 0) {
            hgdbgbrk;
            return nnull;
        }
        hgstrcpy(&p_retstr[strpos], (p_str)p_work->value.code.ba_num);
        strpos += curlen;
        p_retstr[strpos++] = stockdelimt;

        //
        cnt++;
        p_work = p_work->p_next;
    }
    if(strsum != strpos) {
        hgdbgbrk;
        hgfree(p_retstr);
        p_retstr = nnull;
        return p_retstr;
    }

    //   ڵ屸а پִµ ̰ ش.
    p_retstr[strpos - 1] = 0x00;

    // result
    *p_makenum = cnt;

    return p_retstr;
}

long nowgate::checkin_datatime()
{
    //   ð ش.
    // return: '0' - ȿ(00:00:00)
    //         '-1' - ȿ

    if(this->p_head == nnull) {
        return (-1);
    }

    //
	p_nowlink p_code;

	p_code = this->p_head;
	while(p_code) {
        if(this->m_nowhead.datatime < p_code->value.fixvalue.pri.time) {
            this->m_nowhead.datatime = p_code->value.fixvalue.pri.time;
        }
        
        p_code = p_code->p_next;
    }

    return this->m_nowhead.datatime;
}

bbool nowgate::suffing_nowinfo(p_nowgate p_nowgate_server)
{
    hgassert(p_nowgate_server != nnull);

    if(p_nowgate_server == nnull) {
        return ffalse;
    }
    if(p_nowgate_server->get_linknum() <= 0) {
        hgdbgbrk;
        return ffalse;
    }

    if(this->m_nowhead.linknum <= 0) {    // ۿ   
        //-hgdbgbrk;
        return ffalse;
    }

    // ۾
    p_nowlink   p_link = this->p_head;
    p_nowlink   p_find;

    while(p_link) {
        p_find = p_nowgate_server->find_codeval((p_str)p_link->value.code.ba_num);
        if(p_find == nnull) {
            // ־    幰 Ϸ  ͸ 
            // ߿ ˻ 쿡  Ͽ  ڵ尡   ִ.
            //  忡  ޽ ϰ  ۾ Ѱش.

            //-NibDebugString_CR((p_str)p_link->value.code.ba_num);
            hgdbgbrk;

            //-return ffalse;    ۾ ѱ.
        }
        else {
            p_link->value.fixvalue = p_find->value.fixvalue;
        }

        //
        p_link = p_link->p_next;
    }

    // ۾ð Ѱش.
    this->m_nowhead.runday = p_nowgate_server->m_nowhead.runday;    //  ȹ ؼ Ų ¥
    this->m_nowhead.dataday =  p_nowgate_server->m_nowhead.dataday;   //  ȹ ¥(runday ʴ.)
    this->m_nowhead.datatime = p_nowgate_server->m_nowhead.datatime;  //  ȹ ð

    return ttrue;
}

bbool nowgate::get_updown_avgrate(float *p_avgrate_up, float *p_avgrate_down)
{   //    ·, ϶   ϶
    hgassert((p_avgrate_up != nnull) && (p_avgrate_down != nnull));

    if((p_avgrate_up == nnull) || (p_avgrate_down == nnull)) {
        return ffalse;
    }

    if(this->m_nowhead.linknum <= 0) {    // ۿ   
        hgdbgbrk;
        return ffalse;
    }
    if((this->m_nowanal.num_up <= 0) && // Ѵ   ó ʴ´.
        (this->m_nowanal.num_down <= 0)) {
        //-hgdbgbrk; ƴϴ.
        return false;
    }

    //
    *p_avgrate_up = 0;
    *p_avgrate_down = 0;

    // ۾
    p_nowlink   p_link = this->p_head;
    p_nowfxin   p_nowfxin_w;

    for(int cnt = 0, upcnt = 0, downcnt = 0; 
        cnt < this->m_nowhead.linknum; 
        p_link = p_link->p_next, cnt++) {
        //
        if(p_link == nnull) {
            hgdbgbrk;
            return ffalse;
        }

        //
        p_nowfxin_w = &p_link->value.fixvalue;

        //---------------------------
        //  м  - +϶
        //---------------------------
        if(p_nowfxin_w->pri.yesday_daebi > 0) {
            upcnt++;
            *p_avgrate_up += p_nowfxin_w->pri.rate; // 
        }
        if(p_nowfxin_w->pri.yesday_daebi < 0) {
            downcnt++;
            *p_avgrate_down += p_nowfxin_w->pri.rate; // ϶
        }
    }
    if(upcnt != this->m_nowanal.num_up) {
        hgdbgbrk;
        return ffalse;
    }
    if(downcnt != this->m_nowanal.num_down) {
        hgdbgbrk;
        return ffalse;
    }

    if(this->m_nowanal.num_up > 0) {
        *p_avgrate_up = *p_avgrate_up / this->m_nowanal.num_up;
    }
    if(this->m_nowanal.num_down > 0) {
        *p_avgrate_down = *p_avgrate_down / this->m_nowanal.num_down;
    }

    return ttrue;
}

int nowgate::get_yesday_price(p_str p_codeval)
{
    int     price_ret = 0;

    hgassert(p_codeval != nnull);

    if(p_codeval == nnull) {
        return ffalse;
    }

    p_nowlink   p_nowcur = this->find_codeval(p_codeval);
    if(p_nowcur == nnull) {
        hgdbgbrk;
        return price_ret;
    }
    
    price_ret = p_nowcur->value.fixvalue.yesday_endval;
    return price_ret;
}

