#ifndef _NOWNFO_DEFN_
#define _NOWNFO_DEFN_

#include "stockdef.h"
#include "codeinfo.h"
#include "priceinfo.h"

class nowgate;

// 
typedef struct strunowinfo_fix nowfxin, *p_nowfxin;
typedef p_nowfxin *pp_nowfxin;

typedef struct strunowinfo nowinfo, *p_nowinfo;
typedef p_nowinfo *pp_nowinfo;

typedef struct strunowlink nowlink, *p_nowlink;
typedef p_nowlink *pp_nowlink;

typedef struct struNowGateHead nowhead, *p_nowhead;
typedef p_nowhead *pp_nowhead;

typedef struct struNowAnal nowanal, *p_nowanal;
typedef p_nowanal *pp_nowanal;

typedef class nowgate *p_nowgate;
typedef p_nowgate *pp_nowgate;

//
struct strunowinfo_fix {
    price   pri;    //2- (long) ð(HHMM)// (ð5,6,7,(簡3), ϴ4, ŷ10, )
    bbyte   state;      //5- (BYTE) ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
    long    call_sale;   //9- (long) ŵȣ
    long    call_buy;    //10- (long) żȣ
    long    money;      //12- (long) ŷ(, ŷ:, ڽ:õ)
    long    total_sale_amount;  //13- (long) Ѹŵܷ
    long    total_buy_amount;   //14- (long) Ѹżܷ
    long    spare_sale; //15- (long) ŵܷ
    long    spare_buy;  //16- (long) żܷ
    ulong   stocknum;   //17- (unsigned long) ֽļ
    long    fore_rate;  //18- (long) ܱκ(%)
    long    yesday_endval;//19- (long) 
    ulong   yesday_amount;//20- (unsigned long) ϰŷ
    float   connect_power;//21- (float) üᰭ
                          // ⼭ üᰭ (long)  ٸ (float) .
                          // com-object (float)    ʴ´.
                          // ׷ ⼭ ޴  Ҽ   Ƿ
                          // Ȯ . ü Ʈ Ϸ [8081] ̿ؼ óؾ Ѵ.
    ulong   connect_price;//22- (unsigned long) üᷮ
    bbyte   connect_state;//23- (BYTE) üᰡ Flag('O':ŵ, 'B':ż)
    bbyte   call_state; //24- (BYTE) ȣ Flag('O':ŵ, 'B':ż)
    bbyte   sametime;   //25- (BYTE) ȣ('1':ȣ, '2':)
    long    preconnect_price;   //26- (long) üᰡ
    long    yesday_daebi_preconnect_price;  //27- (long) üᰡ ϴ
    long    preconnect_price_state; //28- (long) üᰡ ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
    ulong   preconnect_price_amount;//29- (unsigned long) üᰡ ŷ
    //--------------------------------------------
    // ⼭ʹ  ߰ ̴.
    //--------------------------------------------
    codefxin    assist_code;// codegate  Ȯ Ѱܹ޴ 
    long    amount_rate;  // ϴ ŷ 
    float   amount_rotate;//  ֽĿ  ŷ ȸ
};

struct strunowinfo {
    codepair    code;
    nowfxin     fixvalue;
};

struct strunowlink {
	nowinfo    value;
    // ʿ信 ؼ Ȯ 
    p_void     p_move; //- incldue   p_void ȯ(p_movepair p_move);  //  (޸ ȿ ؼ ʿ  Ѵ.)
    long       gab_time;    //    ð
    long       gab_amount;  //    ŷ
    float      gab_rate;    //    
    long       gab_trademoney_avg;//   ŷ ݾ(ݺ հ )
    // bin-link
	p_nowlink  p_par;
	p_nowlink  p_left;
	p_nowlink  p_right;
    // double-ling
	p_nowlink  p_prev;
	p_nowlink  p_next;
};

struct struNowGateHead {
	// checksum
	hgstr64		checksum_strn;	//  +б⿡ ȿ  ˻ ڿ
    long        checksum_num;   //  +б⿡ ȿ  ˻ 
    // Ʈ
    hgstr64     ba_gatename;
	// ũ
    bbool       assistcode; // codegate  Ȯ  
    long        sortkey;// Ű
    // ð+ð
    long        runday;    //  ȹ ؼ Ų ¥
    long        dataday;   //  ȹ ¥(runday ʴ.)
    long        datatime;  //  ȹ ð
	//
	long		linknum;
    //
    long        avgmount20_filter;    // 20 հŷ
    long        pluscandle_many_filter;//   
	//  ġ
	long		arcbeg;	// Ÿ   ġ
	long		arcend;
};

struct struNowAnal {    //  м  - 
    // +϶
    long    num_up; // 
    long    num_midup;  // ߰(5%)
    long    num_higharea;   // (10%)
    long    num_upmaxarea;  // Ѱα
    long    num_upmax;      // Ѱ
    long    num_upmax_series;// ӻѰ
    long    num_upmax_5day; // 5ùѰ
    long    num_upmax_20day;// 20ùѰ(5ϳ ùѰ  ʴ´.)
    long    num_upmax_pause;// Ѱ
    long    num_upmaxafter; // Ѱ Ż
    long    num_down;       // ϶
    long    num_middown;    // ߰(-5%) ϶
    long    num_lowarea;    // (-10%) ϶
    long    num_downmaxarea;// Ѱα
    long    num_downmax;    // Ѱ
    long    num_downmaxafter;   // Ѱ - Ѱ Ż
    long    num_stop;   // ŷ
    // ĵ - +
    long    num_pluscandle; // 
    long    num_gab_pluscandle; // ϶ 
    long    num_minuscandle;// 
    long    num_flatcandle; // 
    long    num_kangyakcandle;  // () 
    long    num_reverhammer;    // ġ 
    long    num_smallaen;   // small-N (Ѱ)
    // ̵ռ
    long    num_move5_up;   // 5ϼ ⵹(  )
    long    num_move20_up;  // 20ϼ ⵹(  )
    long    num_move60_up;  // 60ϼ ⵹(  )
    long    num_move120_up; // 120ϼ ⵹(  )
    long    num_move240_up; // 240ϼ ⵹(  )
    long    num_move480_up; // 480ϼ ⵹(  )
    long    num_move520_drilup; // 5+20ϼ   ( ð Ͽ )
    //-
    long    num_move5_down;   // 5ϼ ⵹(  )
    long    num_move20_down;  // 20ϼ ⵹(  )
    long    num_move60_down;  // 60ϼ ⵹(  )
    long    num_move120_down; // 120ϼ ⵹(  )
    long    num_move240_down; // 240ϼ ⵹(  )
    long    num_move480_down; // 480ϼ ⵹(  )
    //-
    long    num_move5_on;    // 5ϼ  ִ 
    long    num_move20_on;   // 20ϼ  ִ 
    long    num_move60_on;   // 60ϼ  ִ 
    long    num_move120_on;  // 120ϼ  ִ 
    long    num_move240_on;  // 240ϼ  ִ 
    long    num_move480_on;  // 480ϼ  ִ 
    //-
    long    num_move5_below;    // 5ϼ Ʒִ 
    long    num_move20_below;   // 20ϼ Ʒִ 
    long    num_move60_below;   // 60ϼ Ʒִ 
    long    num_move120_below;  // 120ϼ Ʒִ 
    long    num_move240_below;  // 240ϼ Ʒִ 
    long    num_move480_below;  // 480ϼ Ʒִ 
    //-
    long    num_move5_20_pluslayer; // 5-20 迭 
    long    num_move5_60_pluslayer; // 5-20-60 迭 
    long    num_move5_120_pluslayer;// 5-20-60-120 迭 
    long    num_move20_5_minuslayer; // 5-20 迭 
    long    num_move60_5_minuslayer; // 5-20-60 迭 
    long    num_move120_5_minuslayer;// 5-20-60-120 迭 
    long    num_move60_5_20_layer;// 60-5-20 ܱ ʹ
    long    num_move20_5_60_layer;// 20-5-60 ܱ ʹ
    long    num_move_noarea_5_20_layer; // 5-20迭/20-5迭 ƴ 
    long    num_move_join_5_20_layer;   // 5-20
    //
    long    num_precross_520;   // 5-20 迭(迭 )
    long    num_postcross_520;  // 5-20 迭(迭 ʱ);
    long    num_pause_avg20;    // 20ϼ 
    long    num_pause_avg5;     // 5ϼ 
    long    num_pluscandle_many;//   -    Լ  ޴´.
    long    num_rocket_pause1;  // ޵  ù
    long    num_connectpower_250;// üᰭ 250%̻ 
    //
    long    run_opt_rate;   //      
};

//
class nowgate
{
private:
	// 
	nowhead	    m_nowhead;
	nowanal     m_nowanal;  //  м 
	nowanal     m_analopt;  //  м ó  ɼ
    // child
	p_nowlink   p_top;
	p_nowlink   p_head;
	p_nowlink   p_tail;
    // sible
	p_nowgate   p_parsib;
	p_nowgate   p_nextsib;
	p_nowgate   p_prevsib;
	p_nowgate   p_leftsib;
	p_nowgate   p_rightsib;
    // ¿
    hgstr512    prtmsg512;

public:
    nowgate(p_nowgate p_nowgate_b = nnull, long sortkey_b = sortkey_invalid);
    ~nowgate();
	//
    bbool init();
	void  init_link();
    void  init_link_child();
    void  init_link_sible();
    bbool reset();
    bbool comp(p_nowgate p_info_n, long sortkey, p_int p_retcomp);
    bbool append_dup(p_nowlink p_org);
    bbool append(p_nowlink p_new);
    p_nowlink append(p_str p_codeval, p_str p_codename, p_nowfxin p_fixvale, p_codefxin p_code_fix = nnull);
    bbool append(p_codeinfo p_codeinfo_b);
    bbool del(p_nowlink p_del);
    bbool unlink(p_nowlink p_unlink);
    bbool del_dublecode();

    p_str get_gatename();
    bbool set_gatename(p_str p_gatename, long day_ymd = 0);
    bbool get_assistcode();
    void set_assistcode(bbool assistcode);
    long get_runday();
    void set_runday(long runday);
    long get_dataday();
    void set_dataday(long dataday);
    long get_datatime();
    void set_datatime(long datatime);
    long get_sortkey();
    void set_sortkey(long sortkey);
    long get_linknum();
    long get_avgmount20_filter();
    void set_avgmount20_filter(long avgmount20_filter);
    long get_pluscandle_many_filter();
    void set_pluscandle_many_filter(long pluscandle_many_filter);
    p_nowhead get_nowhead();
    p_nowanal get_nowanal();
    p_nowanal get_analopt();
    bbool set_analopt(p_nowanal p_analopt_new);
    p_nowlink get_top();
    p_nowlink get_head();
    p_nowlink get_tail();
    p_nowgate get_prevsib();
    bbool set_prevsib(p_nowgate p_prevsib);
    void reset_prevsib();
    p_nowgate get_nextsib();
    bbool set_nextsib(p_nowgate p_nextsib);
    void reset_nextsib();
    p_nowgate get_parsib();
    bbool set_parsib(p_nowgate p_parsib);
    void reset_parsib();
    p_nowgate get_leftsib();
    bbool set_leftsib(p_nowgate p_leftsib);
    void reset_leftsib();
    p_nowgate get_rightsib();
    bbool set_rightsib(p_nowgate p_rightsib);
    void reset_rightsib();

    long find_recorder(p_nowlink p_cur);
    p_nowlink find_codeval(p_str p_codeval);
    p_nowlink find_codename(p_str p_codename);
    p_nowlink drag_entrylink(hgpos LocPos);
    //
    bool centering_link();
    bool unlink_binlink();
    p_nowlink binize_link(p_nowlink lpHead, p_nowlink lpTail, hgnum RecNum);
    p_nowlink get_midlink(p_nowlink lpHead, p_nowlink lpTail, 
									 hgnum RecNum, LPHGNUM lpMidWordPos);

    bbool suffing_nowinfo(p_nowgate p_nowgate_server);
    p_str make_codeval_string(hgpos locbeg, long makenum, p_long p_makenum);
    long checkin_datatime();
    bbool get_updown_avgrate(float *p_avgrate_up, float *p_avgrate_down);
    int get_yesday_price(p_str p_codeval);

    // nowgate_io.cpp
    bbool write(p_str p_file, bbool textfile_f = ffalse, bbool codelist_f = ffalse);
    bbool write(hfile hfile_work);
    bbool write_txt(hfile hfile_work, bbool codelist_f = ffalse);
    bbool read(p_str p_file, long sortkey_b = sortkey_invalid);
    bbool read(hfile hfile_work, long sortkey_b = sortkey_invalid);
    p_codegate make_codegate_sortver();
};

// nowfxin.cpp
bbool init_nowfxin(p_nowfxin p_info);
float get_nowfxin_bodyrate(p_nowfxin p_info);
float get_nowfxin_begrate(p_nowfxin p_info);
float get_nowfxin_highrate(p_nowfxin p_info);
float get_nowfxin_downtailrate(p_nowfxin p_info);
bbool is_nowfxin_stop(p_nowfxin p_info);
float calc_nowfxin_gabspot(p_nowfxin p_info_b, p_nowfxin p_info_e);
float calc_nowfxin_rate(p_nowfxin p_info, bbool begbal = ffalse);
float calc_nowfxin_lowdaebi_rate(p_nowfxin p_info, bbool lowbal = ffalse);
long calc_nowfxin_amountrate(p_nowfxin p_info);
float calc_nowfxin_amountrotation(p_nowfxin p_info);
bbool is_nowfxin_updown_up(p_nowfxin p_info);
bbool is_nowfxin_updown_down(p_nowfxin p_info);
bbool is_nowfxin_updown_non(p_nowfxin p_info);
bbool is_nowfxin_updown_upmax(p_nowfxin p_info);
bbool is_nowfxin_updown_downmax(p_nowfxin p_info);
bbool is_nowfxin_updown_upmaxout(p_nowfxin p_info);
bbool is_nowfxin_updown_downmaxout(p_nowfxin p_info);
bbool is_nowfxin_uprate_higharea(p_nowfxin p_info);
bbool is_nowfxin_uprate_upmaxarea(p_nowfxin p_info);
bbool is_nowfxin_uprate_lowarea(p_nowfxin p_info);
bbool is_nowfxin_uprate_downmaxarea(p_nowfxin p_info);
bbool is_nowfxin_movedrillup(p_nowfxin p_info_n, int basevalue);
bbool is_nowfxin_kangyak(p_price p_price_yes, p_nowfxin p_info_to);
bbool is_nowfxin_kangyak_second(p_nowfxin p_info_to);
bbool is_nowfxin_moverise(p_nowfxin p_info_n, p_price p_price_yesday, int basevalue);
bbool is_nowfxin_movebreak(p_nowfxin p_info_n, p_price p_price_yesday, int basevalue);

// nowinfo.cpp
bbool comp_nowinfo(p_nowinfo p_info_b, p_nowinfo p_info_n, long sortkey, p_int p_retcomp);
float calc_nowinfo_rate(p_nowinfo p_info, bbool begbal = ffalse);
float calc_nowinfo_lowdaebi_rate(p_nowinfo p_info, bbool lowbal = ffalse);
long calc_nowinfo_amountrate(p_nowinfo p_info);
float calc_nowinfo_amountrotation(p_nowinfo p_info);
bbool init_nowinfo(p_nowinfo p_info);
bbool is_nowinfo_updown_up(p_nowinfo p_info);
bbool is_nowinfo_updown_down(p_nowinfo p_info);
bbool is_nowinfo_updown_non(p_nowinfo p_info);
bbool is_nowinfo_updown_upmax(p_nowinfo p_info);
bbool is_nowinfo_updown_downmax(p_nowinfo p_info);
bbool is_nowinfo_updown_upmaxout(p_nowinfo p_info);
bbool is_nowinfo_updown_downmaxout(p_nowinfo p_info);
bbool is_nowinfo_uprate_higharea(p_nowinfo p_info);
bbool is_nowinfo_uprate_upmaxarea(p_nowinfo p_info);
bbool is_nowinfo_uprate_lowarea(p_nowinfo p_info);
bbool is_nowinfo_uprate_downmaxarea(p_nowinfo p_info);

//
p_nowlink create_nowlink_codeinfo(p_codeinfo p_codeinfo_b);
p_nowlink dup_nowlink(p_nowlink	p_infolink_b);
p_nowlink  create_nowlink(void);
bbool init_nowlink(p_nowlink p_infolink);
bbool init_nowlink_link(p_nowlink p_infolink);
bbool init_nowlink_bin(p_nowlink p_infolink);
bbool init_nowlink_double(p_nowlink p_infolink);
bbool free_nowlink(pp_nowlink pp_infolink);

//
bbool init_nowhead(p_nowhead p_nowhead_n);
bbool reset_nowhead(p_nowhead p_nowhead_n);

//
bbool init_nowanal(p_nowanal p_nowanal_n);
bbool reset_nowanal(p_nowanal p_nowanal_n);

#endif  //- _NOWNFO_DEFN_

