// StockNow.cpp :  Դϴ.
//

#include "stdafx.h"
#include "boolhts.h"
#include "StockNow.h"

#include "stocktid.h"

char BASED_CODE szFilter_Now[] = "Stock Now Files (*.stn)|*.stn|All Files (*.*)|*.*||";
extern char szFilter_NowGroup[];

extern CboolhtsApp theApp;
// CStockNow ȭ Դϴ.

IMPLEMENT_DYNAMIC(CStockNow, CDialog)
CStockNow::CStockNow(CWnd* pParent /*=NULL*/)
	: CDialog(CStockNow::IDD, pParent)
{
    this->m_nowgate_server = nnull;
    this->m_nowgate_worker = nnull;
}

CStockNow::~CStockNow()
{
    this->m_stockgate.reset();

    if(this->m_nowgate_server != nnull) {
        delete this->m_nowgate_server;
        this->m_nowgate_server = nnull;
    }
    if(this->m_nowgate_worker != nnull) {
        delete this->m_nowgate_worker;
        this->m_nowgate_worker = nnull;
    }
}

void CStockNow::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_LIST, m_List);
    DDX_Control(pDX, IDC_RES_NUM, m_ResNum);
    DDX_Control(pDX, IDC_ITEM_NUM, m_ItemNum);
    DDX_Control(pDX, IDC_ITEM_NUM_SO, m_ItemNumSo);
    DDX_Control(pDX, IDC_ITEM_NUM_DAK, m_ItemNumDak);
    DDX_Control(pDX, IDC_DATATIME, m_DataTime);
    DDX_Control(pDX, IDC_TIMER, m_AutoTimer);
}


BEGIN_MESSAGE_MAP(CStockNow, CDialog)
    ON_MESSAGE(WM_SPOT_TIMER_EVENT, SpotTimerEvent)
    ON_BN_CLICKED(IDC_GET_JONGMOK, OnBnClickedGetJongmok)
    ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
    ON_BN_CLICKED(IDC_MARKET_BOTH, OnBnClickedMarketBoth)
    ON_BN_CLICKED(IDC_MARKET_SO, OnBnClickedMarketSo)
    ON_BN_CLICKED(IDC_MARKET_DAK, OnBnClickedMarketDak)
    ON_BN_CLICKED(IDC_SORT_HIGHRATE, OnBnClickedSortHighrate)
    ON_BN_CLICKED(IDC_SORT_HIGHAMOUNT, OnBnClickedSortHighamount)
    ON_BN_CLICKED(IDC_SORT_NAME, OnBnClickedSortName)
    ON_BN_CLICKED(IDC_SORT_CODE, OnBnClickedSortCode)
    ON_BN_CLICKED(IDC_SORT_AMOUNTRATE, OnBnClickedSortAmountrate)
    ON_BN_CLICKED(IDC_CANDLE_PLUS, OnBnClickedCandlePlus)
    ON_BN_CLICKED(IDC_CANDLE_MINUS, OnBnClickedCandleMinus)
    ON_BN_CLICKED(IDC_CANDLE_FLAT, OnBnClickedCandleFlat)
    ON_BN_CLICKED(IDC_CANDLE_NON, OnBnClickedCandleNon)
    ON_BN_CLICKED(IDC_SORT_HIGHMONEY, OnBnClickedSortHighmoney)
    ON_BN_CLICKED(IDC_UPDOWN_ALL, OnBnClickedUpdownAll)
    ON_BN_CLICKED(IDC_UPDOWN_UP, OnBnClickedUpdownUp)
    ON_BN_CLICKED(IDC_UPDOWN_DOWN, OnBnClickedUpdownDown)
    ON_BN_CLICKED(IDC_UPDOWN_NON, OnBnClickedUpdownNon)
    ON_BN_CLICKED(IDC_AMOUNT_1, OnBnClickedAmount1)
    ON_BN_CLICKED(IDC_AMOUNT_1000, OnBnClickedAmount1000)
    ON_BN_CLICKED(IDC_AMOUNT_10K, OnBnClickedAmount10k)
    ON_BN_CLICKED(IDC_AMOUNT_15K, OnBnClickedAmount15k)
    ON_BN_CLICKED(IDC_AMOUNT_20K, OnBnClickedAmount20k)
    ON_BN_CLICKED(IDC_AMOUNT_30K, OnBnClickedAmount30k)
    ON_BN_CLICKED(IDC_AMOUNT_50K, OnBnClickedAmount50k)
    ON_BN_CLICKED(IDC_AMOUNT_100K, OnBnClickedAmount100k)
    ON_BN_CLICKED(IDC_AMOUNT_500K, OnBnClickedAmount500k)
    ON_BN_CLICKED(IDC_AMOUNT_1M, OnBnClickedAmount1m)
    ON_BN_CLICKED(IDC_AMOUNT_ALL, OnBnClickedAmountAll)
    ON_BN_CLICKED(IDC_AMOUNT_0, OnBnClickedAmount0)
    ON_BN_CLICKED(IDC_TIMER, OnBnClickedTimer)
    ON_BN_CLICKED(IDC_READ, OnBnClickedRead)
    ON_BN_CLICKED(IDC_UPDOWN_MAX, OnBnClickedUpdownMax)
    ON_BN_CLICKED(IDC_UPDOWN_MIX, OnBnClickedUpdownMix)
    ON_BN_CLICKED(IDC_UPDOWN_MAXAFTER, OnBnClickedUpdownMaxafter)
    ON_BN_CLICKED(IDC_UPDOWN_MINAFTER, OnBnClickedUpdownMinafter)
    ON_BN_CLICKED(IDC_UPDOWN_HIGHAREA, OnBnClickedUpdownHigharea)
    ON_BN_CLICKED(IDC_UPDOWN_LOWAREA, OnBnClickedUpdownLowarea)
    ON_BN_CLICKED(IDC_UPDOWN_UPMAXAREA, OnBnClickedUpdownUpmaxarea)
    ON_BN_CLICKED(IDC_UPDOWN_DOWNMAXAREA, OnBnClickedUpdownDownmaxarea)
    ON_BN_CLICKED(IDC_SORT_AMOUNTROTATE, OnBnClickedSortAmountrotate)
    ON_BN_CLICKED(IDC_SAVE, OnBnClickedSave)
END_MESSAGE_MAP()


// CStockNow ޽ óԴϴ.
BOOL CStockNow::OnInitDialog()
{
	CDialog::OnInitDialog();

    //  ¿ Ʈ ڽ
	m_List.InsertColumn(0,"",LVCFMT_RIGHT, 42);
	m_List.InsertColumn(1,"ڵ",LVCFMT_LEFT, 68);
	m_List.InsertColumn(2,"",LVCFMT_LEFT, 100);
	m_List.InsertColumn(3,"ð",LVCFMT_RIGHT, 48);
	m_List.InsertColumn(4,"簡",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(5,"",LVCFMT_RIGHT, 44);    //  ߰ ڸ
	m_List.InsertColumn(6,"ϴ",LVCFMT_RIGHT, 64);
	m_List.InsertColumn(7,"",LVCFMT_LEFT, 100);
	m_List.InsertColumn(8,"ð",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(9,"",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(10,"",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(11,"ŵȣ",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(12,"żȣ",LVCFMT_RIGHT, 68);
	m_List.InsertColumn(13,"ŷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(14,"ŷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(15,"Ѹŵܷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(16,"Ѹżܷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(17,"ŵܷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(18,"żܷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(19,"ֽļ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(20,"κ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(21,"",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(22,"ϰŷ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(23,"üᰭ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(24,"üᷮ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(25,"üᰡ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(26,"ȣ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(27,"ȣ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(28,"üᰡ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(29,"-Ϻ",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(30,"-±",LVCFMT_RIGHT, 100);
	m_List.InsertColumn(31,"-ŷ",LVCFMT_RIGHT, 100);
    //---------------------
    //  ߰ 
    //---------------------
	m_List.InsertColumn(32,"ŷ",LVCFMT_RIGHT, 100); //  ߰ 
	m_List.InsertColumn(33,"ŷȸ",LVCFMT_RIGHT, 100); //  ߰ 
	m_List.InsertColumn(34,"*а-ð",LVCFMT_RIGHT, 100);  //    ð
	m_List.InsertColumn(35,"*а-ŷ",LVCFMT_RIGHT, 100);//    ŷ
	m_List.InsertColumn(36,"*а-",LVCFMT_RIGHT, 100);//    
	m_List.InsertColumn(37,"*а-ŷݾ",LVCFMT_RIGHT, 100);//   ŷ ݾ(ݺ հ )
    //-m_List.SetRowHeight(14);

    // Ű()
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_HIGHRATE);

    //  ()
	this->CheckRadioButton(IDC_MARKET_BOTH, IDC_MARKET_DAK, IDC_MARKET_BOTH);

    // ĵ (Ϳ)
    this->CheckRadioButton(IDC_CANDLE_NON, IDC_CANDLE_FLAT, IDC_CANDLE_NON);

    // ϴ  (Ϳ)
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_ALL);

    // ŷ (Ϳ)
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_ALL);

    //----------------
    // ڵ Ȯ
    //----------------
    if(theApp.mp_codelist_excfirst == nnull) {
        AfxMessageBox(" ڵ  ٿε ߽ϴ.");
    }

    //
    CString strDisp;
    strDisp.Format("%d", theApp.mp_codelist_excfirst->get_linknum());
    m_ItemNum.SetWindowText(strDisp);
    strDisp.Format("%d", theApp.mp_codelist_excfirst->get_linknum_so());
    m_ItemNumSo.SetWindowText(strDisp);
    strDisp.Format("%d", theApp.mp_codelist_excfirst->get_linknum_dak());
    m_ItemNumDak.SetWindowText(strDisp);

    // spot
    this->m_SpotWnd.Create(this, 7991);

    // TODO: Add extra initialization here

    return TRUE;  // return TRUE  unless you set the focus to a control
}

void CStockNow::OnBnClickedGetJongmok()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_nowgate_server != nnull) {
        delete this->m_nowgate_server;
        this->m_nowgate_server = nnull;
    }
    if(this->m_nowgate_worker != nnull) {
        delete this->m_nowgate_worker;
        this->m_nowgate_worker = nnull;
    }

    this->m_nowgate_server = this->m_SpotWnd.GetJongmok();
    if(this->m_nowgate_server == nnull) {
        return;
    }
    
    //  Ÿ ó
    Trans_Serverdownlaod_2_FillWork();
}

void CStockNow::Trans_Serverdownlaod_2_FillWork()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_nowgate_server == nnull) {
        hgdbgbrk;
        return ;
    }

    //  Ÿ  ð 
    CString strDisp;
    strDisp.Format("%d", this->m_nowgate_server->get_datatime());
    m_DataTime.SetWindowText(strDisp);
    m_DataTime.UpdateWindow();

    //------------
    // fill result
    //------------
    long    sortkey_c;

    //------------
    // Ű ˻
    //------------
    if(this->IsDlgButtonChecked(IDC_SORT_HIGHRATE) != 0) {
        sortkey_c = sortkey_rate_high;  //  ūͺ
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_HIGHAMOUNT) != 0) {
        sortkey_c = sortkey_amount_high;    // ŷ ūͺ
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_AMOUNTRATE) != 0) {
        sortkey_c = sortkey_amountrate_high;    // ŷ ūͺ
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_CODE) != 0) {
        sortkey_c = sortkey_codeval;    // ڵ尪
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_NAME) != 0) {
        sortkey_c = sortkey_codename;   // 
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_HIGHMONEY) != 0) {
        sortkey_c = sortkey_money_high;   // ŷݼ
    }
    else if(this->IsDlgButtonChecked(IDC_SORT_AMOUNTROTATE) != 0) {
        sortkey_c = sortkey_amountrotate_high;   // ŷȸ
    }
    else {
        AfxMessageBox("Ű Ȯ ʽϴ.");
        return ;
    }

    this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_c);
    if(this->m_nowgate_worker == nnull) {
        hgdbgbrk;
        return ;
    }

    FillStockNow();
}

void CStockNow::OnBnClickedExit()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->m_SpotWnd.StopTimer();

    this->OnOK();
}

void CStockNow::FillStockNow()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    //
    if(this->m_nowgate_server == nnull) {
        HGMsgBeep;
        return ;
    }
    if(this->m_nowgate_worker == nnull) {
        //--------------------------------------
        //  ׸ м  ް ۾ ѱ ʰ ־ ߻  ִ.
        //-AfxMessageBox("α׷  ");
        //--------------------------------------
        return ;
    }

    //
    BeginWaitCursor();

    CString     strDisp, strName;
    long        i, itemnum, index, inscnt;

    p_nowlink   p_now;

    //  
	this->m_List.DeleteAllItems();
	UpdateData(TRUE);

    p_now = this->m_nowgate_worker->get_head();
    itemnum = this->m_nowgate_worker->get_linknum();

	for(i = 0, index = 0, inscnt = 0; 
        i < itemnum; 
        i++, index++, p_now = p_now->p_next) {
        //
        if(p_now == nnull) {
            hgdbgbrk;
            break;
        }

        //---------------
        //   ˻
        //---------------
        if(this->FilterCheck(p_now) == ffalse) {
            continue;
        }

        //--------------------------------------
        // ׸   Ʈ ڽ ä.
        //--------------------------------------
        strDisp.Format("%d", (inscnt + 1));
		m_List.InsertItem(inscnt, strDisp);

        m_List.SetItemText(inscnt , 1, (p_str)p_now->value.code.ba_num);
		m_List.SetItemText(inscnt , 2, p_now->value.code.p_name);

        strDisp.Format("%d", p_now->value.fixvalue.pri.time);
		m_List.SetItemText(inscnt , 3, strDisp);    //2- (long) ð(HHMM)

        strDisp.Format("%d", p_now->value.fixvalue.pri.endval);
		m_List.SetItemText(inscnt , 4, strDisp);    //3- (long) 簡

        strDisp.Format("%2.2f", p_now->value.fixvalue.pri.rate);
		m_List.SetItemText(inscnt , 5, strDisp);    //  =>  ߰ ڸ

        strDisp.Format("%d", p_now->value.fixvalue.pri.yesday_daebi);
		m_List.SetItemText(inscnt , 6, strDisp);    //4- (long) ϴ

        //5- (BYTE) ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
        switch(p_now->value.fixvalue.state) {
        case '1':
            strDisp = "";   break;
        case '2':
            strDisp = "";   break;
        case '3':
            strDisp = "";   break;
        case '4':
            strDisp = "";   break;
        case '5':
            strDisp = "϶";   break;
        case '6':
            strDisp = "⼼";   break;
        case '7':
            strDisp = "⼼";   break;
        case '8':
            strDisp = "⼼";   break;
        case '9':
            strDisp = "⼼϶";   break;
		default:
            strDisp = "";   break;
		}
		m_List.SetItemText(inscnt , 7, strDisp);

        //6- (long) ð
        strDisp.Format("%d", p_now->value.fixvalue.pri.begval);
		m_List.SetItemText(inscnt , 8, strDisp);

        //7- (long) 
        strDisp.Format("%d", p_now->value.fixvalue.pri.highval);
		m_List.SetItemText(inscnt , 9, strDisp);

        //8- (long) 
        strDisp.Format("%d", p_now->value.fixvalue.pri.lowval);
		m_List.SetItemText(inscnt , 10, strDisp);

        //9- (long) ŵȣ
        strDisp.Format("%d", p_now->value.fixvalue.call_sale);
		m_List.SetItemText(inscnt , 11, strDisp);

        //10- (long) żȣ
        strDisp.Format("%d", p_now->value.fixvalue.call_buy);
		m_List.SetItemText(inscnt , 12, strDisp);

        //11- (unsigned long) ŷ
        strDisp.Format("%d", p_now->value.fixvalue.pri.amount);
		m_List.SetItemText(inscnt , 13, strDisp);
        
        //12- (long) ŷ(, ŷ:, ڽ:õ)  
        //  1õ  ս״.
        strDisp.Format("%d", p_now->value.fixvalue.money);
		m_List.SetItemText(inscnt , 14, strDisp);

        //13- (long) Ѹŵܷ
        strDisp.Format("%d", p_now->value.fixvalue.total_sale_amount);
		m_List.SetItemText(inscnt , 15, strDisp);

        //14- (long) Ѹżܷ
        strDisp.Format("%d", p_now->value.fixvalue.total_buy_amount);
		m_List.SetItemText(inscnt , 16, strDisp);

        //15- (long) ŵܷ
        strDisp.Format("%d", p_now->value.fixvalue.spare_sale);
		m_List.SetItemText(inscnt , 17, strDisp);

        //16- (long) żܷ
        strDisp.Format("%d", p_now->value.fixvalue.spare_buy);
		m_List.SetItemText(inscnt , 18, strDisp);

        //17- (unsigned long) ֽļ
        strDisp.Format("%d", p_now->value.fixvalue.stocknum);
		m_List.SetItemText(inscnt , 19, strDisp);

        //18- (long) ܱκ(%)
        strDisp.Format("%d", p_now->value.fixvalue.fore_rate);
		m_List.SetItemText(inscnt , 20, strDisp);

        //19- (long) 
        strDisp.Format("%d", p_now->value.fixvalue.yesday_endval);
		m_List.SetItemText(inscnt , 21, strDisp);

        //20- (unsigned long) ϰŷ
        strDisp.Format("%d", p_now->value.fixvalue.yesday_amount);
		m_List.SetItemText(inscnt , 22, strDisp);

        //21- (long) üᰭ
        //-strDisp.Format("%d", p_now->value.fixvalue.connect_power);
        strDisp.Format("%.02f", p_now->value.fixvalue.connect_power);
		m_List.SetItemText(inscnt , 23, strDisp);
                
        //22- (unsigned long) üᷮ
        strDisp.Format("%d", p_now->value.fixvalue.connect_price);
		m_List.SetItemText(inscnt , 24, strDisp);

        //23- (BYTE) üᰡ Flag('O':ŵ, 'B':ż)
        switch(p_now->value.fixvalue.connect_state) {
        case '0':
            strDisp = "ŵ";   break;
        case 'B':
            strDisp = "ż";   break;
		default:
            strDisp = "";   break;
		}
		m_List.SetItemText(inscnt , 25, strDisp);

        //24- (BYTE) ȣ Flag('O':ŵ, 'B':ż)
        switch(p_now->value.fixvalue.call_state) {
        case '0':
            strDisp = "ŵ";   break;
        case 'B':
            strDisp = "ż";   break;
		default:
            strDisp = "";   break;
		}
		m_List.SetItemText(inscnt , 26, strDisp);

        //25- (BYTE) ȣ('1':ȣ, '2':)
        switch(p_now->value.fixvalue.sametime) {
        case '1':
            strDisp = "";   break;
        case '2':
            strDisp = "";   break;
		default:
            strDisp = "";   break;
		}
		m_List.SetItemText(inscnt , 27, strDisp);

        //26- (long) üᰡ
        strDisp.Format("%d", p_now->value.fixvalue.preconnect_price);
		m_List.SetItemText(inscnt , 28, strDisp);

        //27- (long) üᰡ ϴ
        strDisp.Format("%d", p_now->value.fixvalue.yesday_daebi_preconnect_price);
		m_List.SetItemText(inscnt , 29, strDisp);

        //28- (long) üᰡ ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
        switch(p_now->value.fixvalue.preconnect_price_state) {
        case '1':
            strDisp = "";   break;
        case '2':
            strDisp = "";   break;
        case '3':
            strDisp = "";   break;
        case '4':
            strDisp = "";   break;
        case '5':
            strDisp = "϶";   break;
        case '6':
            strDisp = "⼼";   break;
        case '7':
            strDisp = "⼼";   break;
        case '8':
            strDisp = "⼼";   break;
        case '9':
            strDisp = "϶";   break;
		default:
            strDisp = "";   break;
		}
		m_List.SetItemText(inscnt , 30, strDisp);

        //29- (unsigned long) üᰡ ŷ
        strDisp.Format("%d", p_now->value.fixvalue.preconnect_price_amount);
		m_List.SetItemText(inscnt , 31, strDisp);

        //-----------------------
        //  ߰ 
        //-----------------------
        strDisp.Format("%d", p_now->value.fixvalue.amount_rate);
		m_List.SetItemText(inscnt , 32, strDisp);   // ŷ =>  ߰ 

        strDisp.Format("%.2f", p_now->value.fixvalue.amount_rotate);
		m_List.SetItemText(inscnt , 33, strDisp);   //  ֽĿ  ŷ ȸ

        //    ð
        strDisp.Format("%d", p_now->gab_time);
		m_List.SetItemText(inscnt , 34, strDisp);

        //    ŷ
        strDisp.Format("%d", p_now->gab_amount);
		m_List.SetItemText(inscnt , 35, strDisp);

        //    
        strDisp.Format("%2.2f", p_now->gab_rate);
		m_List.SetItemText(inscnt , 36, strDisp);

        //   ŷ ݾ(ݺ հ )
        strDisp.Format("%d", p_now->gab_trademoney_avg);
		m_List.SetItemText(inscnt , 37, strDisp);

        // 
        inscnt++;
	} 

    //
    strDisp.Format("%d", inscnt);
    this->m_ResNum.SetWindowText(strDisp);

    // datatime 

//-exit_this:
    EndWaitCursor();
}

bbool CStockNow::FilterCheck(p_nowlink p_now)
{
    // ŷ   ȴ.
    if(is_nowfxin_stop(&p_now->value.fixvalue) == ttrue) {
        return ffalse;
    }

    //---------
    // 屸
    //---------
    if(this->IsDlgButtonChecked(IDC_MARKET_SO)) {
        //---------------------------------------------------------------
        //  Ѵ.
        //  {ŷ, ڽ, 3, , } з 
        //  ó {, } ŷҿ ԽѼ Ѵ.
        //
        // ׷  ó ؼ
        // {ڽ+3} ° ƴϸ ŷҷ зش.
        //---------------------------------------------------------------
        //-if(p_now->value.fixvalue.assist_code.market != market_so) {
        //-    return ffalse;
        //-}
        //---------------------------------------------------------------
        if(p_now->value.fixvalue.assist_code.market == market_ext_dak) {
            return ffalse;
        }
        else if(p_now->value.fixvalue.assist_code.market == market_ext_free) {
            return ffalse;
        }

        //   ŷҷ зѴ.
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_DAK)) {
        if(p_now->value.fixvalue.assist_code.market != market_ext_dak) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_ALL)) {
        // ϱ ؼ  ڵ带 д.
    }

    //----------
    // ĵ 
    //----------
    if(this->IsDlgButtonChecked(IDC_CANDLE_NON)) {  // о
    }
    else if(this->IsDlgButtonChecked(IDC_CANDLE_PLUS)) {    // 
        //
        if((p_now->value.fixvalue.pri.begval > 0) && 
            (p_now->value.fixvalue.pri.begval < p_now->value.fixvalue.pri.endval)) {
        }
        else {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_CANDLE_MINUS)) {    // 
        //
        if((p_now->value.fixvalue.pri.begval > 0) && 
            (p_now->value.fixvalue.pri.begval > p_now->value.fixvalue.pri.endval)) {
        }
        else {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_CANDLE_FLAT)) {    // 
        //
        if(p_now->value.fixvalue.pri.begval != p_now->value.fixvalue.pri.endval) {
        }
        else {
            return ffalse;
        }
    }
    else {
        AfxMessageBox(" - ĵ鱸");
        return ffalse;
    }

    //-------------------
    // ϴ  
    //-------------------
    if(this->IsDlgButtonChecked(IDC_UPDOWN_ALL)) {  // о
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_UP)) {    // 
        if(is_nowinfo_updown_up(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_DOWN)) {    // ϶
        if(is_nowinfo_updown_down(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_NON)) {    // 
        if(is_nowinfo_updown_non(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_MAX)) {    // 
        if(is_nowinfo_updown_upmax(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_MIX)) {    // 
        if(is_nowinfo_updown_downmax(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_MAXAFTER)) {    //  ϶
        if(is_nowinfo_updown_upmaxout(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_MINAFTER)) {    //  
        if(is_nowinfo_updown_downmaxout(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_HIGHAREA)) {    // 
        if(is_nowinfo_uprate_higharea(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_UPMAXAREA)) {    // Ѱ α
        if(is_nowinfo_uprate_upmaxarea(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_LOWAREA)) {    // 
        if(is_nowinfo_uprate_lowarea(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_UPDOWN_DOWNMAXAREA)) {    // Ѱ α
        if(is_nowinfo_uprate_downmaxarea(&p_now->value) == ffalse) {
            return ffalse;
        }
    }
    else {
        AfxMessageBox(" - ϴ ");
        return ffalse;
    }

    //---------------------
    // ŷ (Ϳ)
    //---------------------
    if(this->IsDlgButtonChecked(IDC_AMOUNT_ALL)) {  // о
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_0)) {    // 0 - ŷ  
        //
        if(p_now->value.fixvalue.pri.amount != 0) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_1)) {    // 1̻
        //
        if(p_now->value.fixvalue.pri.amount < 1) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_1000)) {    // 1000̻
        //
        if(p_now->value.fixvalue.pri.amount < 1000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_10K)) {    // 1̻
        //
        if(p_now->value.fixvalue.pri.amount < 10000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_15K)) {    // 15õ̻
        //
        if(p_now->value.fixvalue.pri.amount < 15000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_20K)) {    // 2̻
        //
        if(p_now->value.fixvalue.pri.amount < 20000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_30K)) {    // 3̻
        //
        if(p_now->value.fixvalue.pri.amount < 30000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_50K)) {    // 5̻
        //
        if(p_now->value.fixvalue.pri.amount < 50000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_100K)) {    // 10̻
        //
        if(p_now->value.fixvalue.pri.amount < 100000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_500K)) {    // 50̻
        //
        if(p_now->value.fixvalue.pri.amount < 500000) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_AMOUNT_1M)) {    // 100̻
        //
        if(p_now->value.fixvalue.pri.amount < 1000000) {
            return ffalse;
        }
    }
    else {
        AfxMessageBox(" - ŷ ");
        return ffalse;
    }

    /*
    //---------
    // 
    //---------
    if(this->IsDlgButtonChecked(IDC_ADMINST_NORM)) {
        //
        if(p_now->value.fixvalue.gamli != gamli_norm) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_OVER)) {
        //
        if(p_now->value.fixvalue.gamli != gamli_over) {
            return ffalse;
        }// ̻޵
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_YES)) {
        //
        if(p_now->value.fixvalue.gamli != gamli_admin) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_STOP)) {
        //
        if(p_now->value.fixvalue.gamli != gamli_stop) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_UNK)) {
		switch(p_now->value.fixvalue.gamli) {
        case gamli_norm:    // 
        case gamli_over:    // ̻޵
        case gamli_admin:   // 
        case gamli_stop:    // 
            return ffalse;
		default:
            break;
		}
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_ALL)) {
        // ϱ ؼ  ڵ带 д.
    }
    */

    //
    return ttrue;
}

void CStockNow::OnBnClickedMarketBoth()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_BOTH, IDC_MARKET_DAK, IDC_MARKET_BOTH);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedMarketSo()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_BOTH, IDC_MARKET_DAK, IDC_MARKET_SO);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedMarketDak()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_BOTH, IDC_MARKET_DAK, IDC_MARKET_DAK);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortHighrate()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_HIGHRATE);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_rate_high) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_rate_high);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortHighamount()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_HIGHAMOUNT);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_amount_high) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_amount_high);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortName()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_NAME);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_codename) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_codename);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortCode()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_CODE);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_codeval) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_codeval);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortAmountrate()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_AMOUNTRATE);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_amountrate_high) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_amountrate_high);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortAmountrotate()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_AMOUNTROTATE);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_amountrotate_high) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_amountrotate_high);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedCandlePlus()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_CANDLE_NON, IDC_CANDLE_FLAT, IDC_CANDLE_PLUS);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedCandleMinus()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_CANDLE_NON, IDC_CANDLE_FLAT, IDC_CANDLE_MINUS);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedCandleFlat()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_CANDLE_NON, IDC_CANDLE_FLAT, IDC_CANDLE_FLAT);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedCandleNon()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_CANDLE_NON, IDC_CANDLE_FLAT, IDC_CANDLE_NON);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedSortHighmoney()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_AMOUNTROTATE, IDC_SORT_HIGHMONEY);

    if(this->m_nowgate_worker == nnull) {
        //     
        return ;
    }
    if(this->m_nowgate_worker->get_sortkey() == sortkey_money_high) {
        // Ű ϱ ٽ  ʿ.
        return ;
    }
    else {
        if(this->m_nowgate_worker != nnull) {
            delete this->m_nowgate_worker;
        }
        this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_money_high);
        if(this->m_nowgate_worker == nnull) {
            hgdbgbrk;
            return ;
        }
    }

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownAll()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_ALL);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownUp()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_UP);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownDown()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_DOWN);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownNon()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_NON);

    //  쿡 ŷ(,,...) 쿡 
    // ŷ 1̻̾ Ѵ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_1);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownMax()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_MAX);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownMix()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_MIX);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownMaxafter()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_MAXAFTER);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownMinafter()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_MINAFTER);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount1()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_1);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount1000()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_1000);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount10k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_10K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount15k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_15K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount20k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_20K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount30k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_30K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount50k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_50K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount100k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_100K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount500k()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_500K);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount1m()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_1M);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmountAll()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_ALL);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedAmount0()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_AMOUNT_ALL, IDC_AMOUNT_0, IDC_AMOUNT_0);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedTimer()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_SpotWnd.m_AutoDown != 0) {
        this->m_SpotWnd.StopTimer();

        this->m_AutoTimer.SetWindowText("Ÿ̸ ");
    }
    else {
        this->m_SpotWnd.RunTimer();

        this->m_AutoTimer.SetWindowText("Ÿ̸ ߴ");
    }
}

void CStockNow::OnBnClickedRead()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    //----------
    //  
    //----------
    CFileDialog FileSel(ttrue, arcext_stocknow, NULL, 
        OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_OVERWRITEPROMPT, szFilter_Now, NULL);

    if(FileSel.DoModal() != IDOK) {
        return ;
    }

	// get full path to database file
    CString     cstrExtName = FileSel.GetFileExt();
    if(cstrExtName.CompareNoCase(arcext_stocknow) != 0) {
        AfxMessageBox(" α׷    Դϴ.");
        return ;
    }

    LPSTR       lpFile;
    CString     m_FileName = FileSel.GetPathName();
    lpFile = m_FileName.GetBuffer(512);

    BeginWaitCursor();
    if(this->m_nowgate_server != nnull) {
        delete this->m_nowgate_server;
        this->m_nowgate_server = nnull;
    }
    if(this->m_nowgate_worker != nnull) {
        delete this->m_nowgate_worker;
        this->m_nowgate_worker = nnull;
    }

    //  ٿεϴ  ʹ ۾ ȿ  ؼ
    // ڵ Ű ش.
    // ׷ б Ŀ  ׽Ʈ    Ƿ 
    //  ٿε嶧  ڵ Ű ش.
    this->m_nowgate_server = this->m_stockgate.read_nowgate_new(lpFile, sortkey_codeval);
    if(this->m_nowgate_server == nnull) {
        EndWaitCursor();
        AfxMessageBox("Ͽ  ߽ϴ.");
        return ;
    }
    EndWaitCursor();

    //  Ÿ  ð 
    CString strDisp;
    strDisp.Format("%d", this->m_nowgate_server->get_datatime());
    m_DataTime.SetWindowText(strDisp);
    m_DataTime.UpdateWindow();

    //------------
    // fill result
    //------------
    this->m_nowgate_worker = new nowgate(this->m_nowgate_server, sortkey_codeval);
    if(this->m_nowgate_worker == nnull) {
        hgdbgbrk;
        return ;
    }

    Trans_Serverdownlaod_2_FillWork();
}

void CStockNow::OnBnClickedUpdownHigharea()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_HIGHAREA);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownLowarea()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_LOWAREA);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownUpmaxarea()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_UPMAXAREA);

    //
    FillStockNow();
}

void CStockNow::OnBnClickedUpdownDownmaxarea()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->CheckRadioButton(IDC_UPDOWN_ALL, IDC_UPDOWN_NON, IDC_UPDOWN_DOWNMAXAREA);

    //
    FillStockNow();
}

LONG CStockNow::SpotTimerEvent(WPARAM wParam, LPARAM lParam)
{
    if(wParam == 1) {
        long    curtime = get_curtime_hourmin();
    
        CString strDisp;
        strDisp.Format("%d", curtime);
        m_DataTime.SetWindowText(strDisp);
        m_DataTime.UpdateWindow();
        HGMsgBeep;
    }

    return 0;
}

void CStockNow::OnBnClickedSave()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_nowgate_server == nnull) {
        AfxMessageBox(" ü  Ͱ ϴ.  ͸ ʽÿ.");
        return ;
    }

    //----------
    //  
    //----------
    CFileDialog FileSel(ffalse, arcext_stocknow, NULL, 
        OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_OVERWRITEPROMPT, szFilter_Now, NULL);

    if(FileSel.DoModal() != IDOK) {
        return ;
    }

	// get full path to database file
    CString     cstrExtName = FileSel.GetFileExt();
    if(cstrExtName.CompareNoCase(arcext_stocknow) != 0) {
        AfxMessageBox(" α׷    Դϴ.");
        return ;
    }

    LPSTR       lpFile;
    CString     m_FileName = FileSel.GetPathName();
    lpFile = m_FileName.GetBuffer(512);

    BeginWaitCursor();
    
    if(this->m_nowgate_server->write(lpFile) == ffalse) {
        EndWaitCursor();
        AfxMessageBox("Ϸ  ߽ϴ.");
        return ;
    }
    EndWaitCursor();
}




