#ifndef _PRICEINFO_DEFN_
#define _PRICEINFO_DEFN_

#include "stockdef.h"

typedef struct struPrice price, *p_price;
typedef p_price *pp_price;

typedef struct struDayVal dayval, *p_dayval;
typedef p_dayval *pp_dayval;

struct struPrice {
	long	time;    // Ϻ(¥)/к(+)
	long	begval; // ð
	long	highval;// 
	long	lowval; // 
	long	endval; // 
    long	yesday_daebi;// ϴ(Ϻ)/(к)
	ulong   amount; // ŷ - ŷ/ڽ  ,ֺ ulong ʰ  ִ. ׳ Ѿ.
	float	rate;   // 
};

struct struDayVal {
	long		day;
	long		val;
};

//
bbool init_price(p_price p_info);
long get_price_bodyval(p_price p_info);
float get_price_bodyrate(p_price p_info);
long get_yesday_price(p_price p_info);
float calc_price_rate(p_price p_info, bbool begval = ffalse);
bbool is_price_pluscandle(p_price p_work);
bbool is_price_minuscandle(p_price p_work);
bbool is_price_flatcandle(p_price p_work);
bbool is_price_underscorecandle(p_price p_work);
float get_money_avg3(p_price p_info);
float get_money_avg2(p_price p_info);
bbool is_price_updown_up(p_price p_info);
bbool is_price_updown_down(p_price p_info);
bbool is_price_updown_non(p_price p_info);
bbool is_price_updown_upmax(p_price p_info);
bbool is_price_updown_downmax(p_price p_info);
bbool is_price_updown_upmaxout(p_price p_info);
bbool is_price_updown_downmaxout(p_price p_info);
bbool is_price_uprate_higharea(p_price p_info);
bbool is_price_uprate_upmaxarea(p_price p_info);
bbool is_price_uprate_lowarea(p_price p_info);
bbool is_price_uprate_downmaxarea(p_price p_info);

//
bbool init_dayval(p_dayval p_info);


#endif  //- _PRICEINFO_DEFN_

