#ifndef _STOCGATE_DEFN_
#define _STOCGATE_DEFN_

#include "stockdef.h"
#include "codeinfo.h"
#include "nowinfo.h"

class stockgate;

// 
typedef class stockgate *p_stockgate;
typedef p_stockgate *pp_stockgate;

//
class stockgate
{
private:
	// 
	ICpStockCodePtr pStockCode;
	ICpCodeMgrPtr   pCodeMgr;

    // ۾  ǥ
    CComboBox       *mp_ComboMsg;
    bbool           msgon_combo;

public:
    //------------------
    // stockgate_gen.cpp
    //------------------
    stockgate();
    ~stockgate();

    //
    bbool init();
    bbool reset();
    bbool is_active(void);
    bbool get_codefilename(CString cstrDataFolder, p_str p_codeval, 
                            CString &cstrCodeFileName, bbyte TimeType = 'D');
    bbool get_powercodefilename(CString cstrDataFolder, p_str p_codeval, CString &cstrCodeFileName);
    void send_combmsg(CComboBox *p_ComboMsg);
    void send_combmsg_on(bbool on_flag);
    void print_combomsg(CString cstrMsg);

    static CString GetPathname();
    static CString GetProfileName();

    // etc-expand
    bbool FillJongmok(CComboBox *p_JongMokList, p_codegate p_codegate_w);

    //-------------------
    // stockgate_code.cpp
    //-------------------
    //----------
    // code-gate
    //----------
    p_codegate download_codegate_new(long sortkey_b = sortkey_invalid, bbool exc_3market = ttrue);
    bbool download_codegate(p_codegate p_codegate_serv, 
                        long sortkey_b = sortkey_invalid, 
                        bbool exc_3market = ttrue);
    bbool old_download_codegate(p_codegate p_codegate_serv, 
                        long sortkey_b = sortkey_invalid, 
                        bbool exc_3market = ttrue);
    p_codegate read_codegate_new(p_str pfile, long sortkey_b = sortkey_invalid, bbool exc_3market = ttrue);

    //------------------
    // stockgate_now.cpp
    //------------------
    //---------
    // now-gate
    //---------
    p_nowgate download_nowgate_new(p_codegate p_codegate_w, long sortkey_b = sortkey_invalid);
    p_nowgate download_nowgate_new(p_str p_codelist, long sortkey_b = sortkey_invalid);
    bbool download_nowgate(p_nowgate p_nowgate_serv, p_codegate p_codegate_w, long sortkey_b = sortkey_invalid);
    long download_nowgate(p_nowgate p_nowgate_serv, p_str p_codelist, 
                        long sortkey_b = sortkey_invalid, p_codelink p_codelink_beg = nnull);
    bbool download_nowgate_item(IDibPtr pStockMst2, long itempos, p_nowfxin p_nowfxin_r, CString &strCode, CString &strName);
    p_nowgate read_nowgate_new(p_str pfile, long sortkey_b = sortkey_invalid);
    bbool get_jongmok_now2(p_nowfxin p_nowfxin_r, p_str p_codevalue);
    long get_jongmok_capital(p_str p_codevalue);

    //-------------------
    // CpCodeMgr
    //-------------------
    long stockgate::get_market_time(bbool begin_time = ttrue);
};

#endif  //- _STOCGATE_DEFN_




















