#include "stocgate.h"
#include <shlobj.h>

//----------
// stockgate
//----------
p_codegate stockgate::download_codegate_new(long sortkey_b /* = sortkey_invalid */, bbool exc_3market /* = ttrue */)
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    p_codegate  p_codegate_serv;

    p_codegate_serv = new codegate(nnull, sortkey_b);

    if(download_codegate(p_codegate_serv, sortkey_b, exc_3market) == ffalse) {
        hgdbgbrk;
        delete p_codegate_serv;
        return nnull;
    }

    return p_codegate_serv;
}

bbool stockgate::download_codegate(p_codegate p_codegate_serv, 
                                   long sortkey_b /* = sortkey_invalid */,
                                   bbool exc_3market /* = ttrue */)
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(p_codegate_serv != nnull);

    if(p_codegate_serv == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
    if(sortkey_b != sortkey_invalid) {
        p_codegate_serv->set_sortkey(sortkey_b);
    }

    //
    CString strCode,strName,strImsi, strFullCode;
    char    buf[2];
    long    itemnum;
    sint    cnt;
    bbool   retst = ttrue;

    codefxin    codefxin_r;

    init_codefxin(&codefxin_r);


    pCodeMgr.CreateInstance(__uuidof(CpCodeMgr));
    pStockCode.CreateInstance(__uuidof(CpStockCode));
    
    itemnum = pStockCode->GetCount();

    for(cnt = 0; cnt < itemnum; cnt++) {
        init_codefxin(&codefxin_r);

        strCode = (LPCTSTR)(_bstr_t)pStockCode->GetData(0,cnt);
        strName = (LPCTSTR)(_bstr_t)pStockCode->GetData(1,cnt);
        strFullCode = (LPCTSTR)(_bstr_t)pStockCode->GetData(2,cnt);

        // [ڵ]
        hgstrncpy((p_str)codefxin_r.ba_fullcode, 
            strFullCode.GetBuffer(strFullCode.GetLength()+1), sizeof(codefxin_r.ba_fullcode));
        //-codefxin_r.stk_code = (_variant_t)pStockCode->GetData(3,cnt);
        codefxin_r.stk_code = (_variant_t)pCodeMgr->GetStockIndustryCode((_bstr_t)strCode);

        // [Ҽӱ: 峻, ڽ, 3]
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(4,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockMarketKind((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.market = buf[0];

        // [(̻޵)]
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(5,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockControlKind((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.gamli = buf[0];

        // []
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(5,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockSupervisionKind((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.admin = buf[0];

        // []
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(5,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockStatusKind ((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.state = buf[0];

        // [ںݱ: , , ]
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(6,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockCapital((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.scale = buf[0];

        //- codefxin_r.cashtime = (_variant_t)pStockCode->GetData(7,cnt);   // []
        codefxin_r.cashtime = (_variant_t)pCodeMgr->GetStockFiscalMonth((_bstr_t)strCode);   // []

        //-codefxin_r.groupcode = (_variant_t)pStockCode->GetData(8,cnt);  // [׷ڵ]
        codefxin_r.groupcode = (_variant_t)pCodeMgr->GetStockGroupCode((_bstr_t)strCode);   // [׷ڵ]

        // [K200]
        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        //-strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(9,cnt);
        strImsi = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockKospi200Kind((_bstr_t)strCode);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.kospiflag = buf[0];

        //
        if(p_codegate_serv->append(strCode.GetBuffer(strCode.GetLength()+1), 
            strName.GetBuffer(strName.GetLength()+1), &codefxin_r) == ffalse) {
            hgdbgbrk;
            retst = ffalse;
            break;
        }
    } 
    pStockCode.Release();
    pCodeMgr.Release();

    if(retst == ttrue) {
        //  ũ ȭŲ.
        // - 뷮 ݺ Ž ӵ  ش.
        p_codegate_serv->centering_link();

        //  3  ϴ ˻
        if(exc_3market == ttrue) {
            if(p_codegate_serv->exc_3market() < 0) {
                // '0'  
                hgdbgbrk;
                retst = ffalse;
            }
        }
    }

    return retst;
}

bbool stockgate::old_download_codegate(p_codegate p_codegate_serv, 
                                   long sortkey_b /* = sortkey_invalid */,
                                   bbool exc_3market /* = ttrue */)
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(p_codegate_serv != nnull);

    if(p_codegate_serv == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
    if(sortkey_b != sortkey_invalid) {
        p_codegate_serv->set_sortkey(sortkey_b);
    }

    //
    CString strCode,strName,strImsi, strFullCode;
    char    buf[2];
    long    itemnum;
    sint    cnt;
    bbool   retst = ttrue;

    codefxin    codefxin_r;

    init_codefxin(&codefxin_r);


    pStockCode.CreateInstance(__uuidof(CpStockCode));
    
    itemnum = pStockCode->GetCount();

    for(cnt = 0; cnt < itemnum; cnt++) {
        init_codefxin(&codefxin_r);

        strCode = (LPCTSTR)(_bstr_t)pStockCode->GetData(0,cnt);
        strName = (LPCTSTR)(_bstr_t)pStockCode->GetData(1,cnt);
        strFullCode = (LPCTSTR)(_bstr_t)pStockCode->GetData(2,cnt);

        hgstrncpy((p_str)codefxin_r.ba_fullcode, 
            strFullCode.GetBuffer(strFullCode.GetLength()+1), sizeof(codefxin_r.ba_fullcode));
        codefxin_r.stk_code = (_variant_t)pStockCode->GetData(3,cnt);

        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(4,cnt);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.market = buf[0];

        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(5,cnt);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.gamli = buf[0];

        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(6,cnt);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.scale = buf[0];

        codefxin_r.cashtime = (_variant_t)pStockCode->GetData(7,cnt);
        codefxin_r.groupcode = (_variant_t)pStockCode->GetData(8,cnt);

        //  Ÿ ǰ Ȯ ʴ.
        // string ޾Ƽ byte Ѱܾ Ѵ.
        //  ٷ (bbyte)(_variant_t)   Ѿ ʴ´.
        strImsi = (LPCTSTR)(_bstr_t)pStockCode->GetData(9,cnt);
        memset(buf,0,2);
        strncpy(buf, strImsi,1);
        codefxin_r.kospiflag = buf[0];

        //
        if(p_codegate_serv->append(strCode.GetBuffer(strCode.GetLength()+1), 
            strName.GetBuffer(strName.GetLength()+1), &codefxin_r) == ffalse) {
            hgdbgbrk;
            retst = ffalse;
            break;
        }
    } 
    pStockCode.Release();

    if(retst == ttrue) {
        //  ũ ȭŲ.
        // - 뷮 ݺ Ž ӵ  ش.
        p_codegate_serv->centering_link();

        //  3  ϴ ˻
        if(exc_3market == ttrue) {
            if(p_codegate_serv->exc_3market() < 0) {
                // '0'  
                hgdbgbrk;
                retst = ffalse;
            }
        }
    }

    return retst;
}

p_codegate stockgate::read_codegate_new(p_str pfile, long sortkey_b /* = sortkey_invalid */, bbool exc_3market /* = ttrue */)
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(pfile != nnull);

    if(pfile == nnull) {
        hgdbgbrk;
        return nnull;
    }

    //
    p_codegate  p_codegate_loc;

    p_codegate_loc = new codegate();

    if(p_codegate_loc->read(pfile, sortkey_b, exc_3market) == ffalse) {
        hgdbgbrk;
        delete p_codegate_loc;
        return nnull;
    }

    return p_codegate_loc;
}

