#include "stocgate.h"

#include "Mmsystem.h."  // sound-bell

//----------
// stockgate
//----------
stockgate::stockgate()
{
    init();
}

stockgate::~stockgate()
{
    reset();
}

bbool stockgate::init()
{
    this->pStockCode = nnull;
    this->pCodeMgr = nnull;

    // ۾  ǥ
    this->mp_ComboMsg = nnull;
    this->msgon_combo = ffalse;

    return ttrue;
}

bbool stockgate::reset(void)
{
    //
    //-this->exit_trade();

	//
    init();

    return ttrue;
}

bbool stockgate::is_active(void)
{
    //   ʾƼ ´.
    //-ICpCybos        pCybos;
    //-pCpCybos.CreateInstance(__uuidof(ICpCybos));
    //-
    //-if(pCpCybos->IsConnect()) {
    //-    return ttrue;
    //-}
    //-else {
        return ffalse;
    //-}
}

bbool stockgate::get_codefilename(CString cstrDataFolder, p_str p_codeval, 
                                  CString &cstrCodeFileName, bbyte TimeType /* = 'D' */)
{
    cstrCodeFileName.Empty();

    if(cstrDataFolder.GetLength() <= 1) {
        hgdbgbrk;
        return ffalse;
    }
    if(p_codeval == nnull) {
        hgdbgbrk;
        return ffalse;
    }
    if(hgstrlen(p_codeval) < 7) { // ׸ ̰ '4'.
        if((hgstrcmp(p_codeval, __strn_kospi_index_codeval__) != 0) && 
            (hgstrcmp(p_codeval, __strn_kosdak_index_codeval__) != 0)) {
            hgdbgbrk;
            return ffalse;
        }
    }

    if(cstrDataFolder.GetAt(cstrDataFolder.GetLength() - 1) != '\\') {
        //-cstrDataFolder.Append("\\", 1);
		cstrDataFolder += "\\";
    }

    // ڵ尪 ͸ 
    //-cstrDataFolder.Append(&p_codeval[1], 3);
    //-cstrDataFolder.Append("\\");

    CString     cstrDir;

    cstrDir = &p_codeval[1];
    cstrDir = cstrDir.Left(3);

	cstrDataFolder += cstrDir;
	cstrDataFolder += "\\";

    //  ̸ 
    cstrCodeFileName.Format(_T("%s%s."), 
		cstrDataFolder.GetBuffer(cstrDataFolder.GetLength()+1), p_codeval);
    if(TimeType == 'D') {
        cstrCodeFileName += arcext_stockdaily;
    }
    else if(TimeType == 'W') {
        cstrCodeFileName += arcext_stockweek;
    }
    else if(TimeType == 'M') {
        cstrCodeFileName += arcext_stockmonth;
    }
    else if(TimeType == 'B') {
        cstrCodeFileName += arcext_stockbun;
    }
    else {
        AfxMessageBox(_T("Ȯε    - ð Ȯ"));
        return ffalse;
    }

    return ttrue;
}

bbool stockgate::get_powercodefilename(CString cstrDataFolder, p_str p_codeval, CString &cstrCodeFileName)
{
    cstrCodeFileName.Empty();

    if(cstrDataFolder.GetLength() <= 1) {
        hgdbgbrk;
        return ffalse;
    }
    if(p_codeval == nnull) {
        hgdbgbrk;
        return ffalse;
    }
    if(hgstrlen(p_codeval) < 7) {
        hgdbgbrk;
        return ffalse;
    }

    if(cstrDataFolder.GetAt(cstrDataFolder.GetLength() - 1) != '\\') {
        //-cstrDataFolder.Append("\\", 1);
		cstrDataFolder += "\\";
    }

    // ڵ尪 ͸ 
    CString     cstrDir;

    cstrDir = &p_codeval[1];
    cstrDir = cstrDir.Left(3);

	cstrDataFolder += cstrDir;
	cstrDataFolder += "\\";

    //  ̸ 
    cstrCodeFileName.Format(_T("%s%s."), 
		cstrDataFolder.GetBuffer(cstrDataFolder.GetLength()+1), p_codeval);
    cstrCodeFileName += arcext_stockpower;

    return ttrue;
}

void stockgate::send_combmsg(CComboBox *p_ComboMsg)
{
    if(p_ComboMsg == nnull) {
        hgdbgbrk;
        return ;
    }
    this->mp_ComboMsg = p_ComboMsg;
}

void stockgate::send_combmsg_on(bbool on_flag)
{
    this->msgon_combo = on_flag;
}

void stockgate::print_combomsg(CString cstrMsg)
{
    //------- ͸ ޽ ---------//
    if((this->msgon_combo == ttrue) && (this->mp_ComboMsg != nnull)) {
        this->mp_ComboMsg->InsertString(-1, cstrMsg);
        this->mp_ComboMsg->SetCurSel(this->mp_ComboMsg->GetCount() - 1);
        this->mp_ComboMsg->UpdateWindow();
    }
}

CString stockgate::GetPathname()
{
    long        dotpos;
    CString     cstrPath;

    cstrPath = AfxGetApp()->m_pszHelpFilePath;
    dotpos = cstrPath.ReverseFind('\\');
    if(dotpos <= 0) {
        hgdbgbrk;
		AfxMessageBox(_T("α׷  "));
    }
    cstrPath = cstrPath.Left(dotpos + 1);

    return cstrPath;
}


CString stockgate::GetProfileName()
{
    long        dotpos;
    CString     cstrPath;

    cstrPath = AfxGetApp()->m_pszHelpFilePath;
    dotpos = cstrPath.ReverseFind('.');
    if(dotpos <= 0) {
        hgdbgbrk;
		AfxMessageBox(_T("α׷  "));
    }
    cstrPath = cstrPath.Left(dotpos + 1);

    cstrPath += "ini";

    return cstrPath;
}

//-----------
// ext-expand
//-----------
bbool stockgate::FillJongmok(CComboBox *p_JongMokList, p_codegate p_codegate_w)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if((p_JongMokList == nnull) || (p_codegate_w == nnull)) {
        hgdbgbrk;
        return ffalse;
    }

    //
	p_JongMokList->ResetContent();
	p_JongMokList->UpdateData(TRUE);

    //
	CString strDisp;

    long        itemnum, inscnt;
    p_codelink  p_code;

    p_code = p_codegate_w->get_head();
    itemnum = p_codegate_w->get_linknum();

    for(inscnt = 0; inscnt < itemnum; inscnt++, p_code = p_code->p_next) {
		switch (p_code->value.fixvalue.market) {
		case market_ext_so:
		case market_ext_dak:
			strDisp.Format("%s    %s", 
                (p_str)p_code->value.code.ba_num, 
                p_code->value.code.p_name);
			p_JongMokList->AddString(strDisp);
			break;
		case market_ext_free:
			//-strDisp.Format("%s    %s",strCode, strName);
			break;
			
		}
	} 

    return ttrue;
}

