#include "stocgate.h"

//--------
// nowgate
//--------
p_nowgate stockgate::download_nowgate_new(p_codegate p_codegate_w, long sortkey_b /* = sortkey_invalid */)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(p_codegate_w != nnull);

    if(p_codegate_w == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
    p_nowgate  p_nowgate_serv;

    p_nowgate_serv = new nowgate(nnull, sortkey_b);

    if(download_nowgate(p_nowgate_serv, p_codegate_w, sortkey_b) == ffalse) {
        hgdbgbrk;
        delete p_nowgate_serv;
        return nnull;
    }

    return p_nowgate_serv;
}

p_nowgate stockgate::download_nowgate_new(p_str p_codelist, long sortkey_b /* = sortkey_invalid */)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(p_codelist != nnull);

    if(p_codelist == nnull) {
        hgdbgbrk;
        return ffalse;
    }

    //
    p_nowgate  p_nowgate_serv;

    p_nowgate_serv = new nowgate(nnull, sortkey_b);

    if(download_nowgate(p_nowgate_serv, p_codelist, sortkey_b) <= 0) {
        //  ڵϿ ϳ ٿ  
        // ڵ尪 ߸ 쿡 ߻
        hgdbgbrk;
        delete p_nowgate_serv;
        return nnull;
    }

    return p_nowgate_serv;
}

bbool stockgate::download_nowgate(p_nowgate p_nowgate_serv, p_codegate p_codegate_w, long sortkey_b /* = sortkey_invalid */)
{
    hgassert((p_nowgate_serv != nnull) && (p_codegate_w != nnull));

    if((p_nowgate_serv == nnull) || (p_codegate_w == nnull)) {
        hgdbgbrk;
        return ffalse;
    }

    bbool   retst;
    long    codecnt, codelist_num, retnum;
    p_str   p_codelist;
    
    p_codelink  p_codelink_beg;

    codelist_num = p_codegate_w->get_linknum();
    if(codelist_num <= 0) {
        hgdbgbrk;
        return ffalse;
    }

    //
    retst = ttrue;
    codecnt = 0; 
    p_codelist = nnull;
    while(codecnt < codelist_num) {
        if(p_codelist != nnull) {
            hgfree(p_codelist);
            p_codelist = nnull;
        }

        // ⼭ ڵ尪  ڿ ȯ Լ ʿ
        p_codelist = p_codegate_w->make_codeval_string(codecnt, stockmst2_max, &retnum);
        if(p_codelist == nnull) {
            hgdbgbrk;
            retst = ffalse;
            break;
        }
        if(retnum != stockmst2_max) {
            //  ̶ ó   ٸ 
            // ϴ   ǳ ϸ鼭  ߰  
            //  ó  codegate linknum ƾ Ѵ.
            if((codecnt + retnum) != codelist_num) {
                hgdbgbrk;
                retst = ffalse;
                break;
            }
        }
        p_codelink_beg = p_codegate_w->drag_entrylink(codecnt);
        if(p_codelink_beg == nnull) {
            hgdbgbrk;
            retst = ffalse;
            break;
        }

        //-
        if(this->download_nowgate(p_nowgate_serv, p_codelist, sortkey_b, p_codelink_beg) <= 0) {
            // ó   .
            hgdbgbrk;
            retst = ffalse;
            break;
        }

        //
        codecnt += retnum;
    }
    if(p_codelist != nnull) {
        hgfree(p_codelist);
        p_codelist = nnull;
    }

    return retst;
}

long stockgate::download_nowgate(p_nowgate p_nowgate_serv, p_str p_codelist, 
                                  long sortkey_b /* = sortkey_invalid */,
                                  p_codelink p_codelink_beg /* = nnull */)
{
    // return value: (-1) ɰ  ϶ ߻
    //             : 0 - ó   ,  ϶ ߻
    long        itempos = (-1);

    // p_codelink_beg: ȿ˻縦  ʴ´. nnull ȿ.
    //   => 屸(ŷ,ڽ), ,  ں  ؼ ʿҶ ´.
    //   =>   nnull̸ ߰ ؼ  ⼭  ʰڴٴ ̴.
    hgassert((p_nowgate_serv != nnull) && (p_codelist != nnull));

    if((p_nowgate_serv == nnull) || (p_codelist == nnull)) {
        hgdbgbrk;
        return itempos;
    }

    long    codelist_num;
    
    codelist_num = count_stockcode_num(p_codelist);
    if(codelist_num <= 0) {
        hgdbgbrk;
        return itempos;
    }
    if(codelist_num > stockmst2_max) {
		AfxMessageBox(_T("StockMsg2 Լ - ִ밪 ʰ (110)"));
        return itempos;
    }

    // Ű ޴´.
    if(sortkey_b != sortkey_invalid) {
        p_nowgate_serv->set_sortkey(sortkey_b);
    }

    //
    long        itemnum;

    p_codefxin  p_codefxin_work = nnull;
    p_codelink  p_codelink_work;
    nowfxin     nowfxin_r;
    CString     strCode, strName;

	HRESULT     hr;
	CString     strErrorMsg;
	_bstr_t		bstrMsgg;
	IDibPtr     pStockMst2;

	try {
        hr = pStockMst2.CreateInstance(__uuidof(StockMst2));
        if(FAILED(hr)) {
		    _com_raise_error(hr);
            return itempos;
        }
    	
	    pStockMst2->SetInputValue(0, p_codelist);

	    pStockMst2->BlockRequest();

	    if (0 != pStockMst2->GetDibStatus()) {
		    bstrMsgg = pStockMst2->GetDibMsg1();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
		    strErrorMsg += (LPSTR)bstrMsgg;

		    bstrMsgg = pStockMst2->GetDibMsg2();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
			strErrorMsg += (LPSTR)bstrMsgg;
    		
		    strErrorMsg.TrimRight();
		    AfxMessageBox(strErrorMsg);

    	    pStockMst2.Release();
            return itempos;
	    }

        itemnum = pStockMst2->GetHeaderValue(0);
        if(itemnum != codelist_num) {
            //-------------------------------------------------------------------
            // ڿ Ѿ ڵ尪     ٸ
            // ߸ ڵ尪 Ѿ ´.
            // 񱳰   óϰ ٸ 쿡 · Ѿ 
            // óѴ.
            //    񱳰   ۾Ѵ.
            //-------------------------------------------------------------------
            // 2007.5.15.
            //  ϰ ۾ ߴܽ 
            //   ʴ Ȳ ߻ߴ.
            // ļ ۾ ؼ ߴܽŰ 
            // ƿ ŭ óϰ д.(ó ߻ߴ.)
            //-------------------------------------------------------------------
            //-itemnum = 0;
            //-------------------------------------------------------------------
            strErrorMsg.Format("[%d]  [%d] ޾ҽϴ.", codelist_num, itemnum);
		    AfxMessageBox(strErrorMsg);
        }

        //
        itempos = 0;
        p_codelink_work = p_codelink_beg;
        if(p_codelink_work == nnull) {
            //----------------------------------------------
            // nnull ˻縦  ʴ´. nnull ȿ̴.
            // -    óϵ ׳ Ų.
            //----------------------------------------------
            //-hgdbgbrk;
            //-itemnum = 0;
        }
        else {
            p_nowgate_serv->set_assistcode(ttrue);
        }

	    while(itempos < itemnum) {
            if(p_codelink_work == nnull) {
                p_codefxin_work = nnull;
            }
            else {
                p_codefxin_work = &p_codelink_work->value.fixvalue;
            }
            if(this->download_nowgate_item(pStockMst2, itempos, &nowfxin_r, strCode, strName) == ffalse) {
                hgdbgbrk;
                itempos = (-1);
                break;
            }

            if(p_nowgate_serv->append(strCode.GetBuffer(strCode.GetLength() + 1), 
                strName.GetBuffer(strName.GetLength() + 1), &nowfxin_r, p_codefxin_work) == nnull) {
                hgdbgbrk;
                itempos = (-1);
                break;
            }

            // next counting
            itempos++;
            if(p_codelink_work != nnull) {
                // nnull ȿ̴.    óѴ.
                p_codelink_work = p_codelink_work->p_next;
            }
        } 

        //
	    pStockMst2.Release();
    }
	catch (_com_error e) {
		AfxMessageBox(e.ErrorMessage());
	}
    //  ũ ȭŲ.
    // - 뷮 ݺ Ž ӵ  ش.
    p_nowgate_serv->centering_link();

    //-if(itempos == 0) {
    //-    int dummy = 0;
    //-}
    return itempos;
}

bbool stockgate::download_nowgate_item(IDibPtr pStockMst2, long itempos, p_nowfxin p_nowfxin_r, CString &strCode, CString &strName)
{
    hgassert((p_nowfxin_r != nnull) && (itempos >= 0));

    if((p_nowfxin_r == nnull) || (itempos < 0)) {
        return ffalse;
    }

    //
	CString     strImsi;

    //
    init_nowfxin(p_nowfxin_r);

    strCode = (LPCTSTR)(_bstr_t)pStockMst2->GetDataValue(0,itempos);
	strName = (LPCTSTR)(_bstr_t)pStockMst2->GetDataValue(1,itempos);

    p_nowfxin_r->pri.time = (_variant_t)pStockMst2->GetDataValue(2,itempos);    //2- (long) ð(HHMM)
    p_nowfxin_r->pri.endval = (_variant_t)pStockMst2->GetDataValue(3,itempos);   //3- (long) 簡
    p_nowfxin_r->pri.yesday_daebi = (_variant_t)pStockMst2->GetDataValue(4,itempos);//4- (long) ϴ
    //5- (BYTE) ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
    p_nowfxin_r->state = (bbyte)(_variant_t)pStockMst2->GetDataValue(5,itempos);
    p_nowfxin_r->pri.begval = (_variant_t)pStockMst2->GetDataValue(6,itempos);     //6- (long) ð
    p_nowfxin_r->pri.highval = (_variant_t)pStockMst2->GetDataValue(7,itempos);    //7- (long) 
    p_nowfxin_r->pri.lowval = (_variant_t)pStockMst2->GetDataValue(8,itempos);     //8- (long) 
    p_nowfxin_r->call_sale = (_variant_t)pStockMst2->GetDataValue(9,itempos);   //9- (long) ŵȣ
    p_nowfxin_r->call_buy = (_variant_t)pStockMst2->GetDataValue(10,itempos);    //10- (long) żȣ
    p_nowfxin_r->pri.amount = (ulong)(long)(_variant_t)pStockMst2->GetDataValue(11,itempos);     //11- (unsigned long) ŷ
    p_nowfxin_r->money = (_variant_t)pStockMst2->GetDataValue(12,itempos);      //12- (long) ŷ(, ŷ:, ڽ:õ)
    p_nowfxin_r->total_sale_amount = (_variant_t)pStockMst2->GetDataValue(13,itempos);  //13- (long) Ѹŵܷ
    p_nowfxin_r->total_buy_amount = (_variant_t)pStockMst2->GetDataValue(14,itempos);   //14- (long) Ѹżܷ
    p_nowfxin_r->spare_sale = (_variant_t)pStockMst2->GetDataValue(15,itempos); //15- (long) ŵܷ
    p_nowfxin_r->spare_buy = (_variant_t)pStockMst2->GetDataValue(16,itempos);  //16- (long) żܷ
    p_nowfxin_r->stocknum = (ulong)(long)(_variant_t)pStockMst2->GetDataValue(17,itempos);   //17- (unsigned long) ֽļ
    p_nowfxin_r->fore_rate = (_variant_t)pStockMst2->GetDataValue(18,itempos);  //18- (long) ܱκ(%)
    p_nowfxin_r->yesday_endval = (_variant_t)pStockMst2->GetDataValue(19,itempos);//19- (long) 
    p_nowfxin_r->yesday_amount = (ulong)(long)(_variant_t)pStockMst2->GetDataValue(20,itempos);//20- (unsigned long) ϰŷ
    p_nowfxin_r->connect_power = (float)(_variant_t)pStockMst2->GetDataValue(21,itempos);//21- (float) üᰭ
    p_nowfxin_r->connect_price = (ulong)(long)(_variant_t)pStockMst2->GetDataValue(22,itempos);//22- (unsigned long) üᷮ
    p_nowfxin_r->connect_state = (bbyte)(_variant_t)pStockMst2->GetDataValue(23,itempos);//23- (BYTE) üᰡ Flag('O':ŵ, 'B':ż)
    p_nowfxin_r->call_state = (bbyte)(_variant_t)pStockMst2->GetDataValue(24,itempos); //24- (BYTE) ȣ Flag('O':ŵ, 'B':ż)
    p_nowfxin_r->sametime = (bbyte)(_variant_t)pStockMst2->GetDataValue(25,itempos);   //25- (BYTE) ȣ('1':ȣ, '2':)
    p_nowfxin_r->preconnect_price = (_variant_t)pStockMst2->GetDataValue(26,itempos);   //26- (long) üᰡ
    p_nowfxin_r->yesday_daebi_preconnect_price = (_variant_t)pStockMst2->GetDataValue(27,itempos);  //27- (long) üᰡ ϴ
    p_nowfxin_r->preconnect_price_state = (_variant_t)pStockMst2->GetDataValue(28,itempos); //28- (long) üᰡ ± ('1':,'2':,'3':,'4':,'5':϶,'6':⼼,'7':⼼,'8':⼼,'9':⼼϶)
    p_nowfxin_r->preconnect_price_amount = (ulong)(long)(_variant_t)pStockMst2->GetDataValue(29,itempos); //29- (unsigned long) üᰡ ŷ

    //  Լ   ʱ  ߰  Ѵ.
    if(p_nowfxin_r->yesday_endval > 0) {    // űԻִ   .
        p_nowfxin_r->pri.rate = calc_rate(p_nowfxin_r->yesday_endval, p_nowfxin_r->pri.yesday_daebi);
    }

    return ttrue;
}

p_nowgate stockgate::read_nowgate_new(p_str pfile, long sortkey_b /* = sortkey_invalid */)
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    hgassert(pfile != nnull);

    if(pfile == nnull) {
        hgdbgbrk;
        return nnull;
    }

    //
    p_nowgate  p_nowgate_loc;

    p_nowgate_loc = new nowgate(nnull, sortkey_b);

    if(p_nowgate_loc->read(pfile, sortkey_b) == ffalse) {
        hgdbgbrk;
        delete p_nowgate_loc;
        return nnull;
    }

    return p_nowgate_loc;
}

long stockgate::get_jongmok_capital(p_str p_codevalue)
{
    //     ںݾ ¸ Ѵ.
    //  StockMst()   ü  óؾ ϴµ 
    // ð ٺ ںݾ׸ Ѵ.
    // 
    // ⼭ ϴ ںݾ [鸸]̴.
    long    cur_capital = 0;

    hgassert(p_codevalue != nnull);

    if(p_codevalue == nnull) {
        hgdbgbrk;
        return cur_capital;
    }

    //
    CString     strCode, strName;

	HRESULT     hr;
	CString     strErrorMsg;
	_bstr_t		bstrMsgg;
	IDibPtr     pStockMst;

	try {
        hr = pStockMst.CreateInstance(__uuidof(StockMst));
        if(FAILED(hr)) {
		    _com_raise_error(hr);
            return cur_capital;
        }
    	
	    pStockMst->SetInputValue(0, p_codevalue);

	    pStockMst->BlockRequest();

	    if(0 != pStockMst->GetDibStatus()) {
		    bstrMsgg = pStockMst->GetDibMsg1();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
		    strErrorMsg += (LPSTR)bstrMsgg;

		    bstrMsgg = pStockMst->GetDibMsg2();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
			strErrorMsg += (LPSTR)bstrMsgg;
    		
		    strErrorMsg.TrimRight();
		    AfxMessageBox(strErrorMsg);

    	    pStockMst.Release();
            return cur_capital;
	    }

        cur_capital = pStockMst->GetHeaderValue(32);   // 32 ں

        //
	    pStockMst.Release();
    }
	catch (_com_error e) {
		AfxMessageBox(e.ErrorMessage());
	}

    return cur_capital;
}

bbool stockgate::get_jongmok_now2(p_nowfxin p_nowfxin_r, p_str p_codevalue)
{
    //     ¸ Ѵ.
    long    retst = ffalse;

    hgassert((p_nowfxin_r != nnull) && (p_codevalue != nnull));

    if((p_nowfxin_r == nnull) || (p_codevalue == nnull)) {
        hgdbgbrk;
        return retst;
    }

    //
    CString     strCode, strName;

	HRESULT     hr;
	CString     strErrorMsg;
	_bstr_t		bstrMsgg;
	IDibPtr     pStockMst2;

	try {
        hr = pStockMst2.CreateInstance(__uuidof(StockMst2));
        if(FAILED(hr)) {
		    _com_raise_error(hr);
            return retst;
        }
    	
	    pStockMst2->SetInputValue(0, p_codevalue);

	    pStockMst2->BlockRequest();

	    if(0 != pStockMst2->GetDibStatus()) {
		    bstrMsgg = pStockMst2->GetDibMsg1();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
		    strErrorMsg += (LPSTR)bstrMsgg;

		    bstrMsgg = pStockMst2->GetDibMsg2();
		    //-strErrorMsg += bstrMsgg.GetBSTR();
			strErrorMsg += (LPSTR)bstrMsgg;
    		
		    strErrorMsg.TrimRight();
		    AfxMessageBox(strErrorMsg);

    	    pStockMst2.Release();
            return retst;
	    }

        long itemnum = pStockMst2->GetHeaderValue(0);
        if(itemnum != 1) {
            strErrorMsg.Format("[%s] -  ¸  ߽ϴ.", p_codevalue);
		    AfxMessageBox(strErrorMsg);
    	    pStockMst2.Release();
            return retst;
        }

        if(this->download_nowgate_item(pStockMst2, 0, p_nowfxin_r, strCode, strName) == ffalse) {
            hgdbgbrk;
    	    pStockMst2.Release();
            return retst;
        }

        //
	    pStockMst2.Release();
    }
	catch (_com_error e) {
		AfxMessageBox(e.ErrorMessage());
	}

    retst = ttrue;
    return retst;
}

//-------------------
// CpCodeMgr
//-------------------
long stockgate::get_market_time(bbool begin_time /* = ttrue */)
{
    long        ret_time = 0;

    //
    ICpCodeMgrPtr   pCpCodeMgr;
	HRESULT         hr;
	CString         strErrorMsg;

	try {
        hr = pCpCodeMgr.CreateInstance(__uuidof(CpCodeMgr));
        if(FAILED(hr)) {
		    _com_raise_error(hr);
            return ret_time;
        }

        if(begin_time == ttrue) {
            ret_time = pCpCodeMgr->GetMarketStartTime ();
        }
        else {
            ret_time = pCpCodeMgr->GetMarketEndTime ();
        }

        pCpCodeMgr.Release();
    }
	catch (_com_error e) {
		AfxMessageBox(e.ErrorMessage());
	}

    return ret_time;
}

