#ifndef _STOCKINFO_DEFN_
#define _STOCKINFO_DEFN_

#include ".\\..\\boolhts\\stdafx.h"

#include "boolext.h"

#define __export_list_limitmode__    // м    ܺη  쿡  д.

//---------
// ϰ
//---------
//  Ȯ
#define arcext_stocktheme_ini   "stt"   // stock-code-theme-ini(text file)
#define arcext_stockcode    "stc"   // stock-code
#define arcext_stocknow     "stn"   // stock-now
#define arcext_stockdaily   "std"   // stock-daily
#define arcext_stockweek    "stw"   // stock-week
#define arcext_stockmonth   "stm"   // stock-month
#define arcext_stockmove    "stv"   // stock-move
#define arcext_stockpredata "spd"   // stock-predata
#define arcext_stockhistory "sth"   // stock-history
#define arcext_stocktext    "txt"   // stock-text
#define arcext_stockpower   "stp"   // stock-power
#define arcext_stockpowerspot   "sps"   // stock-power-spot
#define arcext_stocktic     "sti"   // stock-tic
#define arcext_stockbun     "stb"   // stock-bun(bong) к
#define arcext_stocktrd     "str"   // stock-trade к

#define arcfile_lastinfo    "_lastinfo" // ֽ   ̸
#define arcfile_nowspot     "_nowspot_" //  ü 
#define arcfile_powerspot   "_powerspot_" // üᰭ ü 

//    ڿ
#define checksum_basic  "  ˿ ̴."

//     ĺȣ
#define checksum_id_code    0xf2190725  // stock-code
#define checksum_id_now     0xf2195009  // stock-now
#define checksum_id_daily   0xf2190725  // stock-daily
#define checksum_id_cdnpack 0xf2919208  // stock-now-gate-pack
#define checksum_id_move    0xf2897037  // stock-move
#define checksum_id_predata 0xf2835150  // stock-last-info
#define checksum_id_history 0xf2811075  // big-info
#define checksum_id_power     0xf2791202  // power-info
#define checksum_id_powerspot 0xf2755339  // power-info
#define checksum_id_aunxindex 0xf2616701  // auxindex-info
#define checksum_id_trade     0xf2599903  // trade-info
#define checksum_id_trade_run 0xf2599905  // trade-run-info
#define checksum_id_trade_yet 0xf2599907  // trade-yet-info
#define checksum_id_call      0xf2311100  // stock-call
#define checksum_id_news      0xf2319300  // stock-news

//  
#define sortkey_invalid         0   // ȿ
#define sortkey_codeval         1   // ڵ
#define sortkey_codename        2   // ̸
#define sortkey_codeval_rev     3   // ڵ忪
#define sortkey_codename_rev    4   // ̸
#define sortkey_rate_high       11  //  ūͺ
#define sortkey_rate_low        12  // ϶ ūͺ
#define sortkey_baserate_high   21  // ð- ūͺ
#define sortkey_baserate_low    22  // ð-϶ ūͺ
#define sortkey_newrate_high    31  // Ű- ūͺ
#define sortkey_newrate_low     32  // Ű-϶ ūͺ
#define sortkey_limitrate_high  41  // - ūͺ
#define sortkey_limitrate_low   42  // -϶ ūͺ
        // ⼭Ʈ  þ  ó ؼ
        //  ߰ ̴.
#define sortkey_amount_high     901 // ŷ ūͺ
#define sortkey_amountrate_high 902 // ŷ ūͺ
#define sortkey_amountrotate_high 903 //  ֽĿ  ŷ ȸ ūͺ
#define sortkey_avg_uprate_high 921 // ջ    
#define sortkey_day             922 // ¥ջ    
#define sortkey_rate_perday     923 //      
#define sortkey_money_high      911 // ŷ ūͺ
#define sortkey_lastatach       991 //  ڿ ̱(ũ   )
#define sortkey_upitem_high     992 //    
#define sortkey_midupitem_high  993 // ߰    
#define sortkey_price_high      931 // ֽİ ū ͺ
#define sortkey_price_low       932 // ֽİ  ͺ
#define sortkey_conpower_high   935 // üᰭ ū ͺ
#define sortkey_conpower_low    936 // üᰭ  ͺ
#define sortkey_presee_rate_high       938 // (üᰡ)  ūͺ
#define sortkey_default         sortkey_rate_high

//------------------------------------------------
//   CodeMgr.GetStockMarketKind()
//------------------------------------------------
#define market_ext_inv  '0' // ȿ or ʱ
#define market_ext_so   '1' // ŷ
#define market_ext_dak  '2' // ڽ
#define market_ext_free '3' // free-board
#define market_ext_krx  '4' // krx

//------------------------------------------------
//   CodeMgr.GetStockControlKind ()
//------------------------------------------------
#define gamli_ext_inv   '0' // ȿ or ʱ
#define gamli_ext_norm  gamli_ext_inv // 
#define gamli_ext_attention '1' // 
#define gamli_ext_warning   '2' // 
#define gamli_ext_danger_notice '3' // 迹
#define gamli_ext_danger        '4' // 

//------------------------------------------------
//   CodeMgr.GetStockSupervisionKind()
//------------------------------------------------
#define admin_ext_inv   '0' // ȿ or ʱ
#define admin_ext_none  admin_ext_inv // Ϲ
#define admin_ext_yes   '1' // 

//------------------------------------------------
// ֽ  CodeMgr.GetStockStausKind()
//------------------------------------------------
#define stock_state_inv   '0' // ȿ or ʱ
#define stock_state_norm  stock_state_inv // 
#define stock_state_stop  '1' // ŷ
#define stock_state_break '2' // ŷ

// ں Ը 
#define capscale_inv    '0' // ȿ or ʱ
#define capscale_non    capscale_inv // Ϻ  ں Ը .
#define capscale_big    '1' // 
#define capscale_mid    '2' // 
#define capscale_small  '3' // 

// ں Ը 
#define kospi_inv    '0' // ȿ or ʱ
#define kospi_make   '2' // 
#define kospi_power  '3' // 
#define kospi_build  '4' // Ǽ
#define kospi_flow   '5' // 
#define kospi_money  '6' // 

// stockmst2 
#define stockmst2_max   110
#define stockdelimt     ',' //  ڵ忡 ׸ ִ ĺ
#define cp_request_max  30  // 30ʰ 30ȸ ̻ ȣϸ  ɸ鼭 ߴܵȴ.

//-------------------
// Svr7043  ǰ
//-------------------
// 屸
#define	marketme_none	'0'
#define	marketme_so		'1'	// ŷ
#define	marketme_dak	'2'	// ڽ
#define	marketme_3		'3'	// 3
#define	marketme_sodak	'9'	// ŷ+ڽ(Ȯ ޴)
#define	marketme_end	10000

// ñ
#define	selme_highmax	'1'	// 
#define	selme_high		'2'	// 
#define	selme_plain		'3'	// 
#define	selme_lowmin	'4'	// 
#define	selme_low		'5'	// ϶
#define	selme_newhigh	'6'	// Ű
#define	selme_newlow	'7'	// 
#define	selme_maxafter	'8'	//  ϶
#define	selme_minafter	'9'	//  
#define	selme_end		10000

// 
#define	dayme_none		'0'
#define	dayme_today		'1'	// 
#define	dayme_yesterday	'2'	// 
#define	dayme_end		10000

// 
#define	sortme_none			0
#define	sortme_codehigh		11	// ڵ 
#define	sortme_codelow		12	// ڵ 
#define	sortme_yesratehigh	21	// ϴ 
#define	sortme_yesratelow	22	// ϴ 
#define	sortme_relayhigh	31	// ϼ 
#define	sortme_relaylow		32	// ϼ 
#define	sortme_newhigh		41	// Ű
#define	sortme_newlow		42	// 
#define	sortme_end			10000

// 
#define	adminme_none	'0'
#define	adminme_exc		'1'	// 
#define	adminme_inc		'2'	// 
#define	adminme_end		10000

// ŷ 
#define	amountme_1		'0'	// 1 ̻
#define	amountme_10k	'1'	// 1 ̻
#define	amountme_25k	'2'	// 25õ ̻
#define	amountme_100k	'3'	// 10 ̻
#define	amountme_500k	'4'	// 50 ̻
#define	amountme_1m		'5'	// 1鸸 ̻
#define	amountme_end	10000

// Ű,  Ⱓó
#define	newme_none		'0'
#define	newme_5			'1'	// 5
#define	newme_20		'2'	// 20
#define	newme_60		'3'	// 60
#define	newme_year		'4'	// 
#define	newme_52week	'5'	// 52
#define	newme_end		10000

//  ϶ Ⱓó
#define	hilo_none		'0'
#define	hilo_begin		'0'	// ð
#define	hilo_high		'1'	// 
#define	hilo_low		'2'	// 
#define	hilo_end		10000


//--------------------------------------------------
// ϴ    -  Ѱ
//--------------------------------------------------
#define updownst_inv    0   // ȿ - 簡  ()
#define updownst_up     1   // 
#define updownst_down   2   // ϶
#define updownst_zero   3   // 
#define updownst_upmax  4   // 
#define updownst_downmax    5   // 
#define updownst_upmaxdown  6   //  ϶
#define updownst_downmaxup  7   //  

//--------------------------------------------------
// ϴ    -  Ѱ
//--------------------------------------------------
#define uprate_midarea      5   // 5% ߰ 
#define uprate_higharea     10  // 10%  
#define uprate_upmaxarea    12  // 12% Ѱ α 
#define downrate_midarea    -5  // -5% ߰ 
#define downrate_lowarea    -10 // -10%  
#define downrate_downmaxarea -12  // -12% Ѱ α 

#define nowpack_exp_mine   "// ɱ׷Դϴ."


// print 
#define print_file(hfile, msg)  (hgfilewrite(hfile, msg, (int)hgstrlen(msg)) != (int)hgstrlen(msg))
#define print_linebreadk_2  "====================================================\r\n"
#define print_linebreadk_1  "----------------------------------------------------\r\n"
#define print_ommite6x1   "......\r\n"
#define print_ommite6x2   "......\r\n......\r\n"
#define print_prbreadk_1  "\r\n"
#define print_prbreadk_2  "\r\n\r\n"
#define print_prbreadk_3  "\r\n\r\n\r\n"
#define print_prbreadk_4  "\r\n\r\n\r\n\r\n"
#define print_prbreadk_5  "\r\n\r\n\r\n\r\n\r\n"
#define print_keyname_codeval   "ڵ"
#define print_keyname_upmax     "Ѱ"

//----------------------------------
// ڿ  - Ÿ η  ͵
//----------------------------------
#define __strn_kospi__          "ŷ"
#define __strn_kospi_index__    "ŷ "
#define __strn_kospi_index_codeval__  "U001"
#define __strn_kosdak__         "ڽ"
#define __strn_kosdak_index__   "ڽ "
#define __strn_kosdak_index_codeval__  "U201"


//-------------------------------------------------
// command-msg
//-------------------------------------------------
// SpotWnd.cpp
//-------------------------------------------------
// command-msg
#define WM_SPOT_TIMER_EVENT     (WM_USER+391)


//-------
// extern
//-------

//----------
// Լ 
//----------
bbool is_firstitem(p_str p_codeval);
long get_curtime_hourmin();
long get_time_bungab(long pretime, long posttime);
int count_stockcode_num(p_str p_stockcodelist);
long count_limitmax(long curvalue, bbool updown_flag);
#define count_limitmax_high(a)  count_limitmax(a, ttrue)    // Ѱ ϱ
#define count_limitmax_low(a)  count_limitmax(a, ffalse)    // Ѱ ϱ
float calc_rate(long baseval, long nowval);

#endif  //- _STOCKINFO_DEFN_













