// JongmokList.cpp :  Դϴ.
//

#include "stdafx.h"
#include "boolhts.h"
#include "JongmokList.h"

extern CboolhtsApp theApp;

// CJongmokList ȭ Դϴ.
char BASED_CODE szFilter[] = "Stock Files (*.stc)|*.stc|All Files (*.*)|*.*||";

IMPLEMENT_DYNAMIC(CJongmokList, CDialog)
CJongmokList::CJongmokList(CWnd* pParent /*=NULL*/)
	: CDialog(CJongmokList::IDD, pParent)
{
    this->m_codegate = nnull;
}

CJongmokList::~CJongmokList()
{
    if(this->m_codegate != nnull) {
        delete this->m_codegate;
        this->m_codegate = nnull;
    }
}

void CJongmokList::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_RES_NUM, m_ResNum);
    DDX_Control(pDX, IDC_RES_NUM_DAK, m_ResNumDak);
    DDX_Control(pDX, IDC_RES_NUM_SO, m_ResNumSo);
    DDX_Control(pDX, IDC_RES_NUM_3, m_ResNum3);
    DDX_Control(pDX, IDC_RES_NUM_UNKNOWN, m_ResNumUnknown);
    DDX_Control(pDX, IDC_KOSPI200_ONLY, m_Kospi200_Only);
    DDX_Control(pDX, IDC_RES_NUM_FIRST, m_ResNumFirst);
    DDX_Control(pDX, IDC_FIRSTITEM_ONLY, m_FirstItems_Olny);
    DDX_Control(pDX, IDC_FIRSTITEM_EXC, m_FirstItem_Exc);
    DDX_Control(pDX, IDC_LIST, m_List);
}


BEGIN_MESSAGE_MAP(CJongmokList, CDialog)
    ON_BN_CLICKED(IDC_EXIT, OnBnClickedExit)
    ON_BN_CLICKED(IDC_GET_JONGMOK, OnBnClickedGetJongmok)
    ON_BN_CLICKED(IDC_SORT_CODE, OnBnClickedSortCode)
    ON_BN_CLICKED(IDC_SORT_NAME, OnBnClickedSortName)
    ON_BN_CLICKED(IDC_MARKET_SO, OnBnClickedMarketSo)
    ON_BN_CLICKED(IDC_MARKET_DAK, OnBnClickedMarketDak)
    ON_BN_CLICKED(IDC_MARKET_3, OnBnClickedMarket3)
    ON_BN_CLICKED(IDC_MARKET_UNK, OnBnClickedMarketUnk)
    ON_BN_CLICKED(IDC_MARKET_ALL, OnBnClickedMarketAll)
    ON_BN_CLICKED(IDC_ADMINST_ALL, OnBnClickedAdminstAll)
    ON_BN_CLICKED(IDC_ADMINST_NORM, OnBnClickedAdminstNorm)
    ON_BN_CLICKED(IDC_ADMINST_OVER, OnBnClickedAdminstOver)
    ON_BN_CLICKED(IDC_ADMINST_YES, OnBnClickedAdminstYes)
    ON_BN_CLICKED(IDC_ADMINST_STOP, OnBnClickedAdminstStop)
    ON_BN_CLICKED(IDC_MARKET_3EXC, OnBnClickedMarket3exc)
    ON_BN_CLICKED(IDC_KOSPI200_ONLY, OnBnClickedKospi200Only)
    ON_BN_CLICKED(IDC_SCALE_ALL, OnBnClickedScaleAll)
    ON_BN_CLICKED(IDC_SCALE_BIG, OnBnClickedScaleBig)
    ON_BN_CLICKED(IDC_SCALE_MID, OnBnClickedScaleMid)
    ON_BN_CLICKED(IDC_SCALE_SMA, OnBnClickedScaleSma)
    ON_BN_CLICKED(IDC_SCALE_UNK, OnBnClickedScaleUnk)
    ON_BN_CLICKED(IDC_SAVE, OnBnClickedSave)
    ON_BN_CLICKED(IDC_READ, OnBnClickedRead)
    ON_BN_CLICKED(IDC_MODE_SERVER, OnBnClickedModeServer)
    ON_BN_CLICKED(IDC_MODE_LOCAL, OnBnClickedModeLocal)
    ON_BN_CLICKED(IDC_EXPORT_TXT, OnBnClickedExportTxt)
    ON_BN_CLICKED(IDC_FILTER_EXPORT, OnBnClickedFilterExport)
    ON_BN_CLICKED(IDC_FIRSTITEM_ONLY, OnBnClickedFirstitemOnly)
    ON_BN_CLICKED(IDC_FIRSTITEM_EXC, OnBnClickedFirstitemExc)
END_MESSAGE_MAP()


// CJongmokList ޽ óԴϴ.
BOOL CJongmokList::OnInitDialog()
{
    CDialog::OnInitDialog();

    //  ¿ Ʈ ڽ
	m_List.InsertColumn(0,"",LVCFMT_LEFT, 42);
	m_List.InsertColumn(1,"ڵ",LVCFMT_LEFT, 68);
	m_List.InsertColumn(2,"",LVCFMT_LEFT, 100);
	m_List.InsertColumn(3,"Ǯڵ",LVCFMT_LEFT, 100);
	m_List.InsertColumn(4,"ڵ",LVCFMT_LEFT, 64);
	m_List.InsertColumn(5,"",LVCFMT_LEFT, 60);
	m_List.InsertColumn(6,"",LVCFMT_LEFT, 80);
	m_List.InsertColumn(7,"ں",LVCFMT_LEFT, 54);
	m_List.InsertColumn(8,"",LVCFMT_LEFT, 48);
	m_List.InsertColumn(9,"׷ڵ",LVCFMT_LEFT, 64);
	m_List.InsertColumn(10,"KOSPI200",LVCFMT_LEFT, 68);
    //-m_List.SetRowHeight(14);

    // Ű
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_NAME, IDC_SORT_CODE);

    // 屸
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_ALL);

    // 
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_ALL);

    // ں Ը
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_ALL);

    // ۾
	this->CheckRadioButton(IDC_MODE_SERVER, IDC_MODE_LOCAL, IDC_MODE_SERVER);
    this->GetDlgItem(IDC_MODE_SERVER)->EnableWindow(ffalse);
    this->GetDlgItem(IDC_MODE_LOCAL)->EnableWindow(ffalse);

    return TRUE;  // return TRUE unless you set the focus to a control
    // : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CJongmokList::OnBnClickedExit()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    this->OnOK();
}

void CJongmokList::OnBnClickedGetJongmok()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(GetJongmok() == ttrue) {
        FillSererJongmok();
    }
}

bbool CJongmokList::GetJongmok()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    long    sortkey_c;
    if(	this->IsDlgButtonChecked(IDC_SORT_CODE) != 0) {
        sortkey_c = sortkey_codeval;
    }
    else {
        sortkey_c = sortkey_codename;
    }

    bbool   exc_3market;
    if(AfxMessageBox("3  ", MB_YESNO , 0) == IDYES) {
        exc_3market = ttrue;
    }
    else {
        exc_3market = ffalse;
    }

    //
    if(this->m_codegate != nnull) {
        delete this->m_codegate;
    }
    BeginWaitCursor();
    this->m_codegate = theApp.DownloadJongmokList(sortkey_c, exc_3market);
    if(this->m_codegate == nnull) {
        EndWaitCursor();
        AfxMessageBox(" ٿε ߽ϴ.");
        return ffalse;
    }
    EndWaitCursor();

    //--------------------------------------
    //  ؼ  üũ Ʈ 
    //--------------------------------------
	this->CheckRadioButton(IDC_MODE_SERVER, IDC_MODE_LOCAL, IDC_MODE_SERVER);
    this->GetDlgItem(IDC_MODE_SERVER)->EnableWindow(ttrue);

    return ttrue;
}

void CJongmokList::FillSererJongmok()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    BeginWaitCursor();

	ICpCodeMgrPtr   pCodeMgr;

    CString     strDisp, strName;
    long        i, itemnum, index, inscnt;

    p_codelink  p_code;

    //
    if(this->m_codegate == nnull) {
        AfxMessageBox("  ʽÿ");
        return ;
    }

    //  
	this->m_List.DeleteAllItems();
	UpdateData(TRUE);

	pCodeMgr.CreateInstance(__uuidof(CpCodeMgr));
    

    p_code = this->m_codegate->get_head();
    itemnum = this->m_codegate->get_linknum();

	for(i = 0, index = 0, inscnt = 0; 
        i < itemnum; 
        i++, index++, p_code = p_code->p_next) {
        //
        if(p_code == nnull) {
            hgdbgbrk;
            break;
        }

        //---------------
        //   ˻
        //---------------
        if(this->FilterCheck(p_code) == ffalse) {
            continue;
        }

        //--------------------------------------
        // ׸   Ʈ ڽ ä.
        //--------------------------------------
        strDisp.Format("%d", (inscnt + 1));
		m_List.InsertItem(inscnt, strDisp);

        m_List.SetItemText(inscnt , 1, (p_str)p_code->value.code.ba_num);
        m_List.SetItemText(inscnt , 2, p_code->value.code.p_name);

        m_List.SetItemText(inscnt , 3, (LPSTR)p_code->value.fixvalue.ba_fullcode);

        //
        strName.Format("%.3d", p_code->value.fixvalue.stk_code);
        _bstr_t bstrCode(strName);
		strName = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockIndustryCode(bstrCode);
        strDisp.Format("%.3d(%s)", p_code->value.fixvalue.stk_code, strName);
		m_List.SetItemText(inscnt , 4, strDisp);

        switch(p_code->value.fixvalue.market) {
        case market_ext_so:
            strDisp = "ŷ";
            break;
        case market_ext_dak:
            strDisp = "ڽ";
            break;
        case market_ext_free:
            strDisp = "3";
            break;
		default:
            strDisp = "";
            break;
		}
		m_List.SetItemText(inscnt , 5, strDisp);

        //
        strDisp = " ";

        // 
        switch(p_code->value.fixvalue.gamli) {
        case gamli_ext_norm:    // 
            break;
        case gamli_ext_attention:   // 
        case gamli_ext_warning:     // 
        case gamli_ext_danger_notice:   // 迹
        case gamli_ext_danger:          // 
            strDisp = "̻޵";
            break;
        default:
            hgdbgbrk;
            break;
        }

        // 
        switch(p_code->value.fixvalue.admin) {
        case admin_ext_none:    // Ϲ
            break;
        case admin_ext_yes:     // 
            strDisp += "";
            break;
        default:
            hgdbgbrk;
            break;
        }

        // ֽĻ
        switch(p_code->value.fixvalue.state) {
        case stock_state_norm:  // 
        case stock_state_break: // ŷ-߿ Ͻ 
            break;
        case stock_state_stop:  // ŷ
            strDisp += "";
            break;
        default:
            hgdbgbrk;
            break;
        }
		m_List.SetItemText(inscnt , 6, strDisp);

        //
		switch(p_code->value.fixvalue.scale) {
        case capscale_big:  // 
            strDisp = "";
            break;
        case capscale_mid:  // 
            strDisp = "";
            break;
        case capscale_small:    // 
            strDisp = "";
            break;
		default:
            strDisp = "";
            break;
		}
		m_List.SetItemText(inscnt , 7, strDisp);

        //
        strDisp.Format("%.2d", p_code->value.fixvalue.cashtime);
		m_List.SetItemText(inscnt , 8, strDisp);

        strName.Format("9%.2d", p_code->value.fixvalue.groupcode);
        bstrCode = strName;
		
        //-strName = (LPCTSTR)(_bstr_t)pCodeMgr->GetGroupCodeList(p_code->value.fixvalue.groupcode);
		strName = (LPCTSTR)(_bstr_t)pCodeMgr->GetStockGroupCode(bstrCode);
        
        strDisp.Format("%.2d(%s)", p_code->value.fixvalue.groupcode, strName);
		m_List.SetItemText(inscnt , 9, strDisp);

        //
        switch(p_code->value.fixvalue.kospiflag) {
		case kospi_inv:
            strDisp = "ä";
            break;
		case kospi_make:
            strDisp = "";
            break;
		case kospi_power:
            strDisp = "";
            break;
		case kospi_build:
            strDisp = "Ǽ";
            break;
		case kospi_flow:
            strDisp = "";
            break;
        case kospi_money:
            strDisp = "";
            break;
		default:
            strDisp = "";
            break;
		}
		m_List.SetItemText(inscnt , 10, strDisp);

        // 
        inscnt++;
	} 
	pCodeMgr.Release();

    //
    strDisp.Format("%d", this->m_codegate->get_linknum());
    m_ResNum.SetWindowText(strDisp);
    strDisp.Format("%d", this->m_codegate->get_linknum_dak());
    m_ResNumDak.SetWindowText(strDisp);
    strDisp.Format("%d", this->m_codegate->get_linknum_so());
    m_ResNumSo.SetWindowText(strDisp);
    strDisp.Format("%d", this->m_codegate->get_linknum_3());
    m_ResNum3.SetWindowText(strDisp);
    strDisp.Format("%d", this->m_codegate->count_firstitem());
    m_ResNumFirst.SetWindowText(strDisp);

//-exit_this:
    EndWaitCursor();
}

void CJongmokList::OnBnClickedSortCode()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_NAME, IDC_SORT_CODE);

    // ̹    Ѵ.
    if((this->m_codegate != nnull) && (this->m_codegate->get_linknum() > 0)) {
        //  Ű ٸ  .
        if(this->m_codegate->get_sortkey() != sortkey_codeval) {
            p_codegate  p_codegate_n = new codegate(this->m_codegate, sortkey_codeval);
            if(p_codegate_n == nnull) {
                hgdbgbrk;
                AfxMessageBox(" ڵƮ  ߽ϴ.");
                return ;
            }

            //
            delete this->m_codegate;
            this->m_codegate = p_codegate_n;

            //
            FillSererJongmok();
        }
    }
}

void CJongmokList::OnBnClickedSortName()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SORT_CODE, IDC_SORT_NAME, IDC_SORT_NAME);

    // ̹    Ѵ.
    if((this->m_codegate != nnull) && (this->m_codegate->get_linknum() > 0)) {
        //  Ű ٸ  .
        if(this->m_codegate->get_sortkey() != sortkey_codename) {
            p_codegate  p_codegate_n = new codegate(this->m_codegate, sortkey_codename);
            if(p_codegate_n == nnull) {
                hgdbgbrk;
                AfxMessageBox(" ڵƮ  ߽ϴ.");
                return ;
            }

            //
            delete this->m_codegate;
            this->m_codegate = p_codegate_n;

            //
            FillSererJongmok();
        }
    }
}

void CJongmokList::OnBnClickedMarketSo()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_SO);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedMarketDak()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_DAK);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedMarket3()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_3);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedMarket3exc()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_3EXC);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedMarketUnk()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_UNK);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedMarketAll()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_ALL);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedAdminstAll()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_ALL);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedAdminstNorm()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_NORM);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedAdminstOver()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_OVER);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedAdminstYes()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_YES);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedAdminstStop()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_ADMINST_ALL, IDC_ADMINST_STOP, IDC_ADMINST_STOP);
    FillSererJongmok();
}

bbool CJongmokList::FilterCheck(p_codelink p_code)
{
    //---------
    // 屸
    //---------
    if(this->IsDlgButtonChecked(IDC_MARKET_SO)) {
        if(p_code->value.fixvalue.market != market_ext_so) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_DAK)) {
        if(p_code->value.fixvalue.market != market_ext_dak) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_3)) {
        if(p_code->value.fixvalue.market != market_ext_free) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_3EXC)) {    // 3 
        if(p_code->value.fixvalue.market == market_ext_free) {
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_UNK)) {
        switch(p_code->value.fixvalue.market) {
        case market_ext_so:
        case market_ext_dak:
        case market_ext_free:
            return ffalse;
        default:
            break;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_MARKET_ALL)) {
        // ϱ ؼ  ڵ带 д.
    }

    //---------
    // 
    //---------
    if(this->IsDlgButtonChecked(IDC_ADMINST_NORM)) {
        //
        if(p_code->value.fixvalue.gamli != gamli_ext_norm) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_OVER)) {
        // ̻޵
        switch(p_code->value.fixvalue.gamli) {
        case gamli_ext_norm:    // 
            return ffalse;
        case gamli_ext_attention:   // 
        case gamli_ext_warning:     // 
        case gamli_ext_danger_notice:   // 迹
        case gamli_ext_danger:          // 
            return ttrue;
        default:
            hgdbgbrk;
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_YES)) {
        //
        if(p_code->value.fixvalue.admin != admin_ext_yes) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_STOP)) {
        //
        if(p_code->value.fixvalue.state == stock_state_norm) {
            return ffalse;
        }// 
    }
    else if(this->IsDlgButtonChecked(IDC_ADMINST_ALL)) {
        // ϱ ؼ  ڵ带 д.
    }

    //-----------------
    // KOSPI200  
    //-----------------
    if(this->m_Kospi200_Only.GetCheck()) {
        // ŷ  ȴ.
        if(p_code->value.fixvalue.market != market_ext_so) {
            return ffalse;
        }

        switch(p_code->value.fixvalue.kospiflag) {
		case kospi_inv: //"ä";
            return ffalse;
		case kospi_make:    //"";
		case kospi_power:   //"";
		case kospi_build:   //"Ǽ";
		case kospi_flow:    //"";
        case kospi_money:   // "";
            break;
		default:
            //-AfxMessageBox("");
            //  ƴϴ.
            // Ϻ   µ ڵ忡  κ̶
            //  ϰ Ȯؼ óѴ.
            //  ó ʰ Ѿ.
            break;
		}
    }

    //--------------
    // 켱ָ 
    //--------------
    if(this->m_FirstItems_Olny.GetCheck()) {
        if(is_codelink_firstitem(p_code) == ffalse) {
            return ffalse;
        }
    }

    //--------------
    // 켱ָ 
    //--------------
    if(this->m_FirstItem_Exc.GetCheck()) {
        if(is_codelink_firstitem(p_code) == ttrue) {
            return ffalse;
        }
    }
    

    //------------
    // ں 
    //------------
    if(this->IsDlgButtonChecked(IDC_SCALE_ALL)) {
    }
    else if(this->IsDlgButtonChecked(IDC_SCALE_BIG)) {
        if(p_code->value.fixvalue.scale != capscale_big) {  // 
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_SCALE_MID)) {
        if(p_code->value.fixvalue.scale != capscale_mid) {  // 
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_SCALE_SMA)) {
        if(p_code->value.fixvalue.scale != capscale_small) {  // 
            return ffalse;
        }
    }
    else if(this->IsDlgButtonChecked(IDC_SCALE_UNK)) {
		switch(p_code->value.fixvalue.scale) {
        case capscale_big:  // 
        case capscale_mid:  // 
        case capscale_small:    // 
        case capscale_non:  // 켱ִ  '0'̴. 켱ְ ƴϾ '0' 찡 ִ.
            return ffalse;
		default:
            int     cnt = 0;
            break;
		}
    }

    //
    return ttrue;
}


void CJongmokList::OnBnClickedKospi200Only()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    m_FirstItems_Olny.SetCheck(0);
    m_FirstItem_Exc.SetCheck(0);

    if(this->m_Kospi200_Only.GetCheck()) {
        // ڽ200 ׸ ŷ 񿡸 ȴ.
        // ڵ   ŷҷ ٲ۴.
    	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_ALL);

        FillSererJongmok();
    }
}

void CJongmokList::OnBnClickedScaleAll()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_ALL);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedScaleBig()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_BIG);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedScaleMid()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_MID);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedScaleSma()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_SMA);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedScaleUnk()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_SCALE_ALL, IDC_SCALE_UNK, IDC_SCALE_UNK);
    FillSererJongmok();
}

void CJongmokList::OnBnClickedSave()
{
	// TODO: Add your control notification handler code here
    if(this->IsDlgButtonChecked(IDC_MODE_SERVER) == 0) {
        AfxMessageBox(" ͸   ֽϴ.   Ŀ Ͻʽÿ.");
        return ;
    }
    if((this->m_codegate == nnull) ||
        (this->m_codegate->get_linknum() <= 0)) {
        AfxMessageBox(" ͸  ʽÿ.");
        return ;
    }

    CFileDialog FileSel(ffalse, arcext_stockcode, NULL, 
        OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_OVERWRITEPROMPT, szFilter, NULL);

    if(FileSel.DoModal() != IDOK) {
        return ;
    }

	// get full path to database file
    CString     cstrExtName = FileSel.GetFileExt();
    if(cstrExtName.CompareNoCase(arcext_stockcode) != 0) {
        AfxMessageBox(" α׷    Դϴ.");
        return ;
    }


    LPSTR       lpFile;
    CString     m_FileName = FileSel.GetPathName();
    lpFile = m_FileName.GetBuffer(512);

    BeginWaitCursor();
    if(this->m_codegate->write(lpFile) == ffalse) {
        EndWaitCursor();

        AfxMessageBox("ϴµ  ߻Ͽϴ.", MB_OK, 0);
        return ;
    }
    EndWaitCursor();
    AfxMessageBox("߽ϴ.");

    return;
}

void CJongmokList::OnBnClickedRead()
{
	// TODO: Add your control notification handler code here

    long    sortkey_c;
    if(	this->IsDlgButtonChecked(IDC_SORT_CODE) != 0) {
        sortkey_c = sortkey_codeval;
    }
    else {
        sortkey_c = sortkey_codename;
    }

    bbool   exc_3market;
    if(AfxMessageBox("3  ", MB_YESNO , 0) == IDYES) {
        exc_3market = ttrue;
    }
    else {
        exc_3market = ffalse;
    }

    //----------
    //  
    //----------
    CFileDialog FileSel(ttrue, arcext_stockcode, NULL, 
        OFN_HIDEREADONLY | OFN_LONGNAMES | OFN_OVERWRITEPROMPT, szFilter, NULL);

    if(FileSel.DoModal() != IDOK) {
        return ;
    }

	// get full path to database file
    CString     cstrExtName = FileSel.GetFileExt();
    if(cstrExtName.CompareNoCase(arcext_stockcode) != 0) {
        AfxMessageBox(" α׷    Դϴ.");
        return ;
    }

    LPSTR       lpFile;
    CString     m_FileName = FileSel.GetPathName();
    lpFile = m_FileName.GetBuffer(512);

    //----------
    // read
    //----------
    BeginWaitCursor();
    if(this->m_codegate != nnull) {
        delete this->m_codegate;
    }
    this->m_codegate = this->m_stockgate.read_codegate_new(lpFile, sortkey_c, exc_3market);
    if(this->m_codegate == nnull) {
        EndWaitCursor();

        AfxMessageBox("оµ  ߻Ͽϴ.", MB_OK, 0);
        return ;
    }
    EndWaitCursor();

    //----------------
    // Ʈڽ 
    //----------------
    FillSererJongmok();

	this->CheckRadioButton(IDC_MODE_SERVER, IDC_MODE_LOCAL, IDC_MODE_LOCAL);
    this->GetDlgItem(IDC_MODE_LOCAL)->EnableWindow(ttrue);

    return;
}

void CJongmokList::OnBnClickedModeServer()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MODE_SERVER, IDC_MODE_LOCAL, IDC_MODE_SERVER);
    this->GetDlgItem(IDC_MODE_SERVER)->EnableWindow(ttrue);
}

void CJongmokList::OnBnClickedModeLocal()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	this->CheckRadioButton(IDC_MODE_SERVER, IDC_MODE_LOCAL, IDC_MODE_LOCAL);
    this->GetDlgItem(IDC_MODE_LOCAL)->EnableWindow(ttrue);
}

void CJongmokList::OnBnClickedExportTxt()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_codegate == nnull) {
        AfxMessageBox(" ڵ  κ ʽÿ.");
        return ;
    }

    //
    long        dotpos;
    CString     cstrPathFile;

    // profile Ѵ.
    cstrPathFile = AfxGetApp()->m_pszHelpFilePath;
    dotpos = cstrPathFile.ReverseFind('.');
    if(dotpos > 0) {
        cstrPathFile = cstrPathFile.Left(dotpos);
    }
    cstrPathFile += "_code.txt";

    //
    bbool   only_codeval = ttrue;
    if(AfxMessageBox("ڵ尪 ұ", MB_YESNO, NULL) != IDYES) {
        only_codeval = ffalse;
    }
    if(this->m_codegate->export_txt(cstrPathFile.GetBuffer(), only_codeval) == ffalse) {
        hgdbgbrk;
        return ;
    }
}

void CJongmokList::OnBnClickedFilterExport()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_codegate == nnull) {
        AfxMessageBox(" ڵ  κ ʽÿ.");
        return ;
    }

    //
    long        dotpos;
    CString     cstrPathFile;

    // profile Ѵ.
    cstrPathFile = AfxGetApp()->m_pszHelpFilePath;
    dotpos = cstrPathFile.ReverseFind('.');
    if(dotpos > 0) {
        cstrPathFile = cstrPathFile.Left(dotpos);
    }
    cstrPathFile += "_code.txt";

    //
    bbool   retst = ffalse;
    hfile   hfile_work;

    hfile_work = HGFileCreate(cstrPathFile.GetBuffer(), FILE_CREATE_MODE);
    if(hfile_work == hfile_error) {
        hgdbgbrk;
        return ;
    }

    //
    int         workcnt, listcnt;
	p_codelink  p_worker;
    hgstr32     prtmsg32;

    //----------
    //  
    //----------
    workcnt = 0;
    listcnt = 0;
    p_worker = this->m_codegate->get_head();

    while(p_worker != nnull) {
        //
        workcnt++;

        //---------------
        //   ˻
        //---------------
        if(this->FilterCheck(p_worker) == ffalse) {
            p_worker = p_worker->p_next;
            continue;
        }

        //
        listcnt++;

        //
        sprintf((p_str)prtmsg32, "%d : ", listcnt);
        if(hgfilewrite(hfile_work, prtmsg32, 
            hgstrlen((p_str)prtmsg32)) != 
            hgstrlen((p_str)prtmsg32)) {
            hgdbgbrk;
            goto exit_this;
        }

        // ڵ尪 ڵ ϴ 
        if(this->IsDlgButtonChecked(IDC_SORT_CODE)) {   // ڵ  
            //
            if(print_file(hfile_work, (p_str)p_worker->value.code.ba_num)) {
                hgdbgbrk;
                goto exit_this;
            }

            //
            prtmsg32[0] = '(';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                goto exit_this;
            }
            if(hgfilewrite(hfile_work, p_worker->value.code.p_name, 
                hgstrlen(p_worker->value.code.p_name)) != 
                hgstrlen(p_worker->value.code.p_name)) {
                hgdbgbrk;
                goto exit_this;
            }
            prtmsg32[0] = ')';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                goto exit_this;
            }
        }
        else {  // ڵ̸ 켱
            //
            prtmsg32[0] = '(';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                goto exit_this;
            }
            if(hgfilewrite(hfile_work, p_worker->value.code.p_name, 
                hgstrlen(p_worker->value.code.p_name)) != 
                hgstrlen(p_worker->value.code.p_name)) {
                hgdbgbrk;
                goto exit_this;
            }
            prtmsg32[0] = ')';
            if(hgfilewrite(hfile_work, prtmsg32, 1) != 1) {
                hgdbgbrk;
                goto exit_this;
            }

            //
            if(print_file(hfile_work, (p_str)p_worker->value.code.ba_num)) {
                hgdbgbrk;
                goto exit_this;
            }
        }
        if(print_file(hfile_work, print_prbreadk_1)) {
            hgdbgbrk;
            goto exit_this;
        }

        //
        p_worker = p_worker->p_next;
    }
    if(workcnt != this->m_codegate->get_linknum()) {
        hgdbgbrk;
        goto exit_this;
    }

    //
    retst = ttrue;

exit_this:
    hgfileclose(hfile_work);
    if(retst == ffalse) {
        hgdbgbrk;
        return ;
    }
    
    return ;

}

void CJongmokList::OnBnClickedFirstitemOnly()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    m_Kospi200_Only.SetCheck(0);
    m_FirstItem_Exc.SetCheck(0);
    
    if(this->m_FirstItems_Olny.GetCheck()) {
        // 켱ָ ۾ϴ°
    	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_ALL);

        FillSererJongmok();
    }
}

void CJongmokList::OnBnClickedFirstitemExc()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    m_Kospi200_Only.SetCheck(0);
    m_FirstItems_Olny.SetCheck(0);
    
    if(this->m_FirstItem_Exc.GetCheck()) {
        // 켱ָ ۾ϴ°
    	this->CheckRadioButton(IDC_MARKET_SO, IDC_MARKET_ALL, IDC_MARKET_ALL);

        FillSererJongmok();
    }
}
