// SpotWnd.cpp :  Դϴ.
//

#include "stdafx.h"
#include "boolhts.h"
#include "SpotWnd.h"

extern CboolhtsApp theApp;

// CSpotWnd

IMPLEMENT_DYNAMIC(CSpotWnd, CWnd)
CSpotWnd::CSpotWnd()
{
	EnableActiveAccessibility();

    this->m_nowgate_timer = nnull;
    this->m_codegate_thema = nnull;  // ׷(׸) ó ؼ ڵ Ѵ.

    // option
    this->m_opt_logwrite = ttrue;   // ٿε   ΰ

    //
    this->m_AutoDown = 0;
    this->m_AutoInterval = DEFT_STOCKNOW_INTERVAL_DEFT; // 1000 ǻ( 1ʿ ).
}

CSpotWnd::~CSpotWnd()
{
    this->StopTimer();

    this->m_stockgate.reset();

    if(this->m_nowgate_timer != nnull) {
        delete this->m_nowgate_timer;
        this->m_nowgate_timer = nnull;
    }
    if(this->m_codegate_thema != nnull) {
        delete this->m_codegate_thema;
        this->m_codegate_thema = nnull;
    }
}


BEGIN_MESSAGE_MAP(CSpotWnd, CWnd)
    ON_WM_TIMER()
    ON_WM_CLOSE()
END_MESSAGE_MAP()



// CSpotWnd ޽ óԴϴ.


void CSpotWnd::OnTimer(UINT nIDEvent)
{
    // TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
    static BOOL NowWorkingFlag = FALSE;

    // TODO: Add your message handler code here and/or call default
    if(nIDEvent == m_AutoDown) {
        if(NowWorkingFlag == FALSE) {
            NowWorkingFlag = ttrue;

            TimerWorker();

            //
            NowWorkingFlag = FALSE;

            // ׽Ʈ ؼ wparam(1), lparam(2)  .
            // ߿ ʿϸ ߰Ѵ.
            this->GetParent()->SendMessage(WM_SPOT_TIMER_EVENT, 1, 2);

        }
	}

    //-CWnd::OnTimer(nIDEvent);
}

void CSpotWnd::OnClose()
{
    // TODO: ⿡ ޽ ó ڵ带 ߰ /Ǵ ⺻ ȣմϴ.
    this->StopTimer();

    CWnd::OnClose();
}

void CSpotWnd::RunTimer(int TimerBubGab /* = 0 */)
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_AutoDown != 0) {
        KillTimer(this->m_AutoDown);
        this->m_AutoDown = 0;
    }
    else {
        if(TimerBubGab > 0) {   // '0' ũ а Ѵٴ 
            this->m_AutoInterval = TimerBubGab * 1000;  // 1(1000) * 60 = 1
        }

        int     bun_interval = 60;
        int     cho_interval = this->m_AutoInterval * bun_interval;
        this->m_AutoDown = (UINT)SetTimer(DEFT_STOCKNOW_TID, cho_interval, NULL);
    }
}

void CSpotWnd::StopTimer()
{
    // TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
    if(this->m_AutoDown != 0) {
        KillTimer(this->m_AutoDown);
        this->m_AutoDown = 0;
    }
}

bbool CSpotWnd::TimerWorker()
{
    long    curtime = get_curtime_hourmin();

    if(this->m_nowgate_timer != nnull) {
        long    server_time = this->m_nowgate_timer->get_datatime();
        int     gabmin = get_time_bungab(server_time, curtime);

        if(gabmin >= DEFT_STOCKNOW_DOWN_GAB) {
            delete this->m_nowgate_timer;
            this->m_nowgate_timer = nnull;
        }
    }

    //
    if(this->m_nowgate_timer == nnull) {
        // download
        this->m_nowgate_timer = this->GetJongmok();
    }

    return ttrue;
}

p_nowgate CSpotWnd::GetJongmok(p_codegate p_codegate_now /* = nnull */)
{
    //-------------------------------------------------------------
    // p_codegate_now: nnull  ȿ̴.
    //- ٿε   ʾƼ ü  ٿεѴ.
    //-------------------------------------------------------------
    p_nowgate   p_nowgate_new = nnull;
    long        sortkey_c;
    p_codegate  p_codegate_worker = nnull;

    //  ٿεϴ  ʹ ۾ ȿ  ؼ
    // ڵ Ű ش.
    //
    //  ͷ  ۾ Ϳ  ɼ Ѱܼ óѴ.
    sortkey_c = sortkey_codeval;    // ڵ

    /*
    CString cstr_codelist;
    cstr_codelist = "A011720,A005750,A014900";  // ڵ ̿ Ⱑ   ȴ.

    // ---------   ؼ  ޾Ƽ  ޴  ----------
    // --------- ڵ尪 ڿ ѱ  ----------
    // --------- ƹų ص . -------
    BeginWaitCursor();

    p_nowgate_new = this->m_stockgate.download_nowgate_new(cstr_codelist.GetBuffer(), sortkey_c);
    if(p_nowgate_new == nnull) {
        EndWaitCursor();
        this->AfxMessageBox(" ٿε ߽ϴ.");
        return p_nowgate_new;
    }
    EndWaitCursor();
    */

    // ---------   ؼ  ޾Ƽ  ޴  ----------
    // --------- ڵ尪 codegate ѱ  ----------
    // --------- ƹų ص . -------
    if(theApp.mp_codelist_excfirst == nnull) {
        AfxMessageBox(" ڵ  ٿε  ¶ ۾   ϴ.");
        return ffalse;
    }

    // ۾  Ѵ.
    if(p_codegate_now != nnull) {
        p_codegate_worker = p_codegate_now;
    }
    else {
        //---------------------------------------------------
        // 2009.01.09.
        //---------------------------------------------------
        // 켱ָ ԽѼ ޴´.
        // - SpotWnd Ŭ   ü ޵ ؾ Ѵ.
        //   Ϻ ĵ Ʈ   ü ʿϱ ̴.
        //   켱 ͸  Ŭ ۿ ϵ ؾ Ѵ.
        //---------------------------------------------------
        //-p_codegate_worker = theApp.mp_codelist_excfirst;
        //---------------------------------------------------
        p_codegate_worker = theApp.mp_codelist_incfirst;
    }

    //
    BeginWaitCursor();
    p_nowgate_new = this->m_stockgate.download_nowgate_new(p_codegate_worker, sortkey_c);
    if(p_nowgate_new == nnull) {
        EndWaitCursor();
        AfxMessageBox(" ü ٿε ߽ϴ.");
        return nnull;
    }
    EndWaitCursor();

    // ٿε   ΰ
    if(this->m_opt_logwrite == ttrue) {
        //  -  Ͽ Ϻ  Ҷ   ִ.
        // ׷ ٿε ڸ ׻ α  صд.
        bbool   retst = theApp.SpotLogWrite(p_nowgate_new);
        if(retst  == ffalse) {
            hgdbgbrk;
            //-return ffalse;     ȣ 
        }
    }

    return p_nowgate_new;
}

BOOL CSpotWnd::Create(CWnd* pParentWnd, UINT nID)
{
    // 
    DWORD   dwStyle = WS_CHILD | WS_VISIBLE;
    RECT    rect = CRect(0, 0, 100, 100);   // ũ .  ؼ ׳ش.
    
    return CWnd::Create(nnull, nnull, dwStyle, rect, pParentWnd, nID, nnull);
}



